-- hds header_start
--
-- VHDL Architecture CERC_be_fpga.be_top_tester.rtl
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 14:15:40 10/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
library exemplar;
use exemplar.exemplar.ALL;


entity be_top_tester is
   port( 
      vme_command_out     : in     std_logic;
      TTC_rst_frm_vme_b   : out    std_logic;
      clk_lvds_vme        : out    std_logic;
      clk_lvds_vme_b      : out    std_logic;
      fe_config_out       : out    std_logic_vector (8 downto 1);
      fe_empty_flag       : out    std_logic;
      fe_frame_sync_out   : out    std_logic_vector (8 downto 1);
      fe_full_flag        : out    std_logic;
      fe_half_flag        : out    std_logic;
      fe_readout_sync_out : out    std_logic_vector (8 downto 1);
      j0_trig_in_lvdsb_i  : out    std_logic;
      j0_trig_in_lvdsp_i  : out    std_logic;
      j2_trig_lvdsb_i     : out    std_logic_vector (15 downto 0);
      j2_trig_lvdsp_i     : out    std_logic_vector (15 downto 0);
      rst                 : out    std_logic;
      temp_int_b          : out    std_logic;
      test_trig           : out    std_logic;
      test_trig_B         : out    std_logic;
      vme_command_in      : out    std_logic;
      vme_throttle        : out    std_logic;
      lm82_sda            : inout  std_logic
   );

-- Declarations

end be_top_tester ;


-- hds interface_end

architecture test of be_top_tester is

	type int_array32 is array (31 downto 1) of integer;
	signal be_reg_len : int_array32;

	constant CLKPERIOD 		: time := 25 ns;

	signal 	clk_osc 			: std_logic := '1';
	signal 	clk	 			: std_logic := '1';

	signal 	ser_tx 			: std_logic := '0';
	signal 	ser_rx			: std_logic := '0';
	
--	signal 	rx_data			: integer 	:= 0;
	signal 	rx_data			: std_logic_vector(32 downto 0) := "000000000000000000000000000000000";
	
	signal   sink_test_data	: std_logic_vector(31 downto 0) := "00000000000000000000010000000000";
	
	constant	BE_DEST_ID		: std_logic_vector(4 downto 0) := "01010";
	constant	TRIG_DEST_ID	: std_logic_vector(4 downto 0) := "01001";
		
	constant	WR					: std_logic := '0';
	constant	RD					: std_logic := '1';

	-- TRIG Registers
	--------------------------------------------
	constant TRIG_ENABLE    	: integer :=  1;
	constant TRIG_STATUS     	: integer :=  2;
	constant TRIG_CATCH			: integer :=  3; 
	constant ENABLE      		: integer :=  4;
	constant TRIG_COUNT     	: integer :=  5;
	constant TRIG_OSC  			: integer :=  6;
	constant BURST_COUNT			: integer :=  7;
	constant PB_TRIG_COUNT  	: integer :=  8;
	constant FW_VERSION       	: integer :=  9;
	constant FW_DATE          	: integer := 10;
	constant CONTROL     		: integer := 11;
	constant COMMAND         	: integer := 12;
	constant FIFO_DATA        	: integer := 13;
	constant FIFO_STATUS      	: integer := 14;
	constant CONFIG 				: integer := 15;
	constant BUSY_TIMEOUT	  	: integer := 16;
	constant BURST_TIMEOUT	  	: integer := 17;
	constant PB_CATCH	  			: integer := 18;
	constant CAND0	  				: integer := 19;
	constant CAND1	  				: integer := 20;
	constant CAND2	  				: integer := 21;
	constant CAND3	  				: integer := 22;
	constant BEAM_MODE	  		: integer := 23;
	constant INVERT	  			: integer := 24;
	constant TRIG_QDR				: integer := 25;
--	constant 						: integer := 26;
	constant SIGS_CATCH			: integer := 27;
	constant SEQUENCER	  	  	: integer := 28;
	constant SQUIRT				: integer := 29;
	constant RAM_DATA         	: integer := 30;
	constant RAM_ADDRESS      	: integer := 31;

	
	-- BE Registers
	-------------------------------------------
	constant TRIGGER_SELECT   	: integer :=  1;
	constant MODE            	: integer :=  2;
	constant TTC_RX_CNTL 		: integer :=  3; 
	constant TEST        		: integer :=  4;
	constant FE_ENABLE      	: integer :=  5;
	constant READOUT_CNTL   	: integer :=  6;
	constant RUN_CNTL 			: integer :=  7;
	constant SW_TRIGGER     	: integer :=  8;
	constant SOFT_RST       	: integer :=  9;
	constant FED_ID_REG       	: integer := 10;
	constant TTC_RX_RST    		: integer := 11;
	constant LM82_CNTL        	: integer := 12;
	
--	constant      				   : integer := 13;
--	constant 						: integer := 14;
	constant TRIG_CONTROL     	: integer := 15;
	constant BE_STATUS      	: integer := 16;
	constant L1A_COUNT			: integer := 17;
	constant BX_COUNT    	  	: integer := 18;
	constant QDR_FRAME_COUNT  	: integer := 19;
	constant TTC_READY  			: integer := 20;
	constant FIRMWARE_ID			: integer := 21;
	constant QDR_DATA_COUNT		: integer := 22;
	constant TOTAL_FRAME_COUNT	: integer := 23;
	constant TTC_STATUS			: integer := 24;
	constant LM82_STATUS			: integer := 25;
	constant TTC_SINGLE_CMND   : integer := 26;
	constant TTC_BRDCST_CMND	: integer := 27;
--	constant 		   	  	  	: integer := 28;
--	constant 						: integer := 29;
--	constant            			: integer := 30;
--	constant  						: integer := 31;


	-- FE Registers
	-------------------------------------------
	
	-- 'COMMAND' REGISTERS
	constant FE_FIRMWARE_ID   	: integer :=  3;
	constant TRIGGER_COUNT   	: integer :=  30;
		
	-- Set register lengths
	--be_reg_len(RUN_CNTL)			<=  2;
	--be_reg_len(READOUT_CNTL		<=	 2;
	--be_reg_len(MODE)				<=  4;
	--be_reg_len(TRIGGER_SELECT) <=  3;
	--be_reg_len(FED_ID_REG)		<= 12;
	--be_reg_len(FE_ENABLE)		<=  8;
	--be_reg_len(TRIG_CONTROL) 	<=	32;


	----------------------------------------------------------

	signal j0_trig : std_logic;
	signal j2_trig : std_logic_vector (15 downto 0);
	
	signal rd_test_pulse : std_logic;


begin
------------------------------------------------------------------------------	
	-- clock generator
	------------------
	clk_osc   		 <= not clk_osc after CLKPERIOD/2;
	clk_lvds_vme 	 <= clk_osc;
   clk_lvds_vme_b  <= not(clk_osc);
   
   clk 	 			 <= clk_osc;
   	
	-- IO Assignments
	-----------------
   vme_command_in <= ser_tx;
	ser_rx <= vme_command_out;
	
	j0_trig_in_lvdsp_i <= j0_trig;
   j0_trig_in_lvdsb_i <= not(j0_trig);
      
   j2_trig_lvdsp_i <= j2_trig;
   j2_trig_lvdsb_i <= not(j2_trig);
   

	-----------------------------------------------------------------------
	main_sim: process

		-- Procedures
		----------------------------------------------------------------
		procedure WaitClks(len : in integer) is
		begin
			wait for (len * 25 ns) - 15 ns;
			wait until rising_edge(clk);
			wait for 1 ns;
		end procedure;
		---------------------------------------------------------------
		procedure Serial_Read(iss_length : in integer ) is
		begin
			ser_tx <= '1'; 							-- 'stop' bit
			WaitClks(1);
			ser_tx <= '0';
			WaitClks(29);								-- rx data latency
			rx_data <= (others=>'0');
			for n_rdata in (iss_length-1) downto 0 loop	-- rx data
				wait for 5 ns;
				rd_test_pulse <= '1';
				--rx_data <= rx_data + (conv_integer(ser_rx)*(2**n_rdata));
				rx_data(n_rdata) <= ser_rx;
				WaitClks(1);
				rd_test_pulse <= '0';
			end loop;
			WaitClks(4);
		end procedure;
		----------------------------------------------------------------
		procedure Serial_Write(	iss_length 	: in integer; 
										iss_data 	: in integer) is
			variable	ss_data		: std_logic_vector(31 downto 0);
		begin
			ss_data		:= CONV_STD_LOGIC_VECTOR(iss_data, 32);
			for n_wdata in (iss_length-1) downto 0 loop			
				ser_tx <= ss_data(n_wdata); WaitClks(1);
			end loop;
			ser_tx <= '0'; WaitClks(1);				
			WaitClks(4);											
		end procedure;
		----------------------------------------------------------------
		procedure Serial_Addr( 	rd_nwr : in std_logic;
										ss_dest : in std_logic_vector(4 downto 0); 
										iss_desig, iss_length : in integer ) is
			variable	ss_desig		: std_logic_vector(4 downto 0);
			variable	ss_length	: std_logic_vector(15 downto 0);
		begin
			ss_desig 	:= CONV_STD_LOGIC_VECTOR(iss_desig, 5);
			ss_length  	:= CONV_STD_LOGIC_VECTOR((iss_length), 16);
			WaitClks(1);
			-- Destination Packet
			ser_tx <= '1'; WaitClks(1); 					-- start bit
   		for n_adest in 4 downto 0 loop						-- destination (4:0)
				ser_tx <= ss_dest(n_adest);	WaitClks(1);
			end loop;
			-- Read/Write and Desig Packet
			ser_tx <= '1'; 				WaitClks(1);	-- start bit
			ser_tx <= rd_nwr; 			WaitClks(1);	-- read/write bit
			for n_adesig in 4 downto 0 loop						-- designator (4:0)
				ser_tx <= ss_desig(n_adesig); 	WaitClks(1);
			end loop;
			-- Length and Data Packet
			ser_tx <= '1'; WaitClks(1);					-- Length Start Bit
			for n_alen in 15 downto 0 loop						-- Length field
				ser_tx <= ss_length(n_alen); WaitClks(1);
			end loop;
		end procedure;
		---------------------------------------------------------------
		procedure BERegRead(iss_desig, iss_length : in integer ) is
		begin
			Serial_Addr(RD, BE_DEST_ID, iss_desig, iss_length+1); --length corrected
			WaitClks(2);  -- Needed to compensate for stupid FE timing
			Serial_Read(iss_length);
		end procedure;
		---------------------------------------------------------------
		procedure BERegWrite(iss_desig, iss_length, iss_data : in integer ) is
		begin
			Serial_Addr(WR, BE_DEST_ID, iss_desig, iss_length);
			Serial_Write(iss_length, iss_data);
		end procedure;
		---------------------------------------------------------------
		procedure TrigRegRead(iss_desig : in integer ) is
		begin
			Serial_Addr(RD, TRIG_DEST_ID, iss_desig, 32);
			Serial_Read(32);
		end procedure;
		---------------------------------------------------------------
		procedure TrigRegWrite(iss_desig, iss_data : in integer ) is
		begin
			Serial_Addr(WR, TRIG_DEST_ID, iss_desig, 32);
			Serial_Write(32, iss_data);
		end procedure;
		---------------------------------------------------------------
		procedure FERegRead(ifeid, iss_desig, iss_length : in integer ) is
		begin
			Serial_Addr(RD, conv_std_logic_vector(ifeid+1,5), iss_desig, iss_length+3);  -- Length corrector
			WaitClks(1);
			Serial_Read(iss_length);
		end procedure;
		---------------------------------------------------------------
		procedure FERegWrite(ifeid, iss_desig, iss_length, iss_data : in integer ) is
		begin
			Serial_Addr(WR, conv_std_logic_vector(ifeid+1,5), iss_desig, iss_length);
			Serial_Write(iss_length, iss_data);
		end procedure;
		--------------------------------------------------------------- 
		procedure FEConfRegWrite(icrfeid, icr_addr, icr_data : in integer ) is
		begin
			FERegWrite(icrfeid, 8, 10, icr_addr);
			FERegWrite(icrfeid, 7, 32, icr_data);
		end procedure;
		--------------------------------------------------------------- 
		procedure FEConfRegRead(icrfeid, icr_addr : in integer ) is
		begin
			FERegWrite(icrfeid, 8, 10, icr_addr);
			FERegRead(icrfeid, 29, 32);
		end procedure;
		--------------------------------------------------------------- 

		
	----------------------------------------------------------------------
	-- Main Simulation
	----------------------------------------------------------------------
	begin

		-- Initial Values
	  	TTC_rst_frm_vme_b		<= '1';
      fe_empty_flag        <= '1';
      fe_full_flag         <= '1';
      fe_half_flag         <= '1';
      j0_trig 					<= '0';
      j2_trig 					<= "0000000000000000";
      temp_int_b           <= '1';
      test_trig            <= '0';
      test_trig_B          <= '1';
      vme_throttle         <= '1';
      lm82_sda             <= '0';
       
      WaitClks(1);
            
		-- Reset
		-----------------------------------------------------------------
		rst <= '1';
		WaitClks(8);
		
		rst <= '0';
		WaitClks(50);
		
		-----------------------------------------------------------------	
		
		TrigRegRead(FW_VERSION);
		WaitClks(100);
		
		FERegRead(1, FE_FIRMWARE_ID, 	32); --FE1(of 0-7), Trig-COUNT
		WaitClks(100);
		
		BERegRead(FIRMWARE_ID, 32);
		WaitClks(100);
		
		------------------------------------------------------------------


	--	BERegWrite(RUN_CNTL,			 2, 3			   ); --already defaults to this;
	--	BERegWrite(READOUT_CNTL,	 2, 2				);	--already defaults to this;
		BERegWrite(MODE, 				 4, 2				);
	--	BERegWrite(TRIGGER_SELECT,  3, 4				); --already defaults to this;
	--	BERegWrite(FED_ID_REG, 		12, 16#cec#			);
		BERegWrite(FE_ENABLE, 		 8, 16#02#			);
		BERegWrite(TRIG_CONTROL,	32, 16#00000202#);  ---1202#	);
		
		
	--	TrigRegWrite(ENABLE, 		16#00000001#);
	--	TrigRegWrite(TRIG_OSC, 		40000			);
	--	TrigRegWrite(BURST_COUNT, 	500			);
	--	TrigRegWrite(BUSY_TIMEOUT, 20000			);
		TrigRegWrite(TRIG_ENABLE, 	16#00000001#);
		TrigRegWrite(CONFIG, 		16#000c0002#);  --(0=off, 1=constant val, 2=oscillate, 3=count)

		-----------------------------------------------------------------------

		for n in 0 to 4 loop
			j2_trig <= "0000000000000001";
			WaitClks(2);
			j2_trig <= "0000000000000000";
			WaitClks(2);
			TrigRegWrite(CONTROL, 		0); --clear busy
			WaitClks(5);
			
			FERegRead(1, TRIGGER_COUNT, 	33); --FE1(of 0-7), Trig-COUNT ***33????
			WaitClks(20);
		
		end loop;
			
		FEConfRegWrite(1,   0,   128);					-- 0x00000080 = 0b00000000 00000000 00000000 10000000
		FEConfRegWrite(1,   1,     0);					-- 0x00000000 = 0b00000000 00000000 00000000 00000000
		
		WaitClks(100);
		FEConfRegRead(1, 0);
		WaitClks(100);
		
		FEConfRegWrite(1,   4,     1);					-- 0x00000001 = 0b00000000 00000000 00000000 00000001
		FEConfRegWrite(1,   5, 	 120);	-- 16384);	-- 0x00004000 = 0b00000000 00000000 01000000 00000000
		FEConfRegWrite(1,   6,     0);					-- 0x00000000 = 0b00000000 00000000 00000000 00000000
		FEConfRegWrite(1,  12,    10);	--   100);	-- 0x00000064 = 0b00000000 00000000 00000000 01100100
		FEConfRegWrite(1,  13,    20);	--   200);	-- 0x000000c8 = 0b00000000 00000000 00000000 11001000
		FEConfRegWrite(1,  16,    30);	--   300);	-- 0x0000012c = 0b00000000 00000000 00000001 00101100
		FEConfRegWrite(1,  17,    50);	--   500);	-- 0x000001f4 = 0b00000000 00000000 00000001 11110100
		FEConfRegWrite(1,  20,    40);	--   400);	-- 0x00000190 = 0b00000000 00000000 00000001 10010000
		FEConfRegWrite(1,  21,     8);	--    80);	-- 0x00000050 = 0b00000000 00000000 00000000 01010000
		FEConfRegWrite(1,  22,     8);	--    80);	-- 0x00000050 = 0b00000000 00000000 00000000 01010000
		FEConfRegWrite(1,  23,     4);	--    18);	-- 0x00000012 = 0b00000000 00000000 00000000 00010010
		FEConfRegWrite(1,  24,     0);	--     0);	-- 0x00000000 = 0b00000000 00000000 00000000 00000000
		FEConfRegWrite(1,  28,    30);	--   300);	-- 0x0000012c = 0b00000000 00000000 00000001 00101100
		FEConfRegWrite(1,  29, 	 100);	-- 13500);	-- 0x000034bc = 0b00000000 00000000 00110100 10111100
		FEConfRegWrite(1,  30,     8);	--     8);	-- 0x00000008 = 0b00000000 00000000 00000000 00001000
		FEConfRegWrite(1,  31,    30);	--    30);	-- 0x0000001e = 0b00000000 00000000 00000000 00011110
		FEConfRegWrite(1,  32,     0);	--     0);	-- 0x00000000 = 0b00000000 00000000 00000000 00000000
		FEConfRegWrite(1,  33,     0);	--     0);	-- 0x00000000 = 0b00000000 00000000 00000000 00000000
		FEConfRegWrite(1,  34,    70);	--  4500);	-- 0x00001194 = 0b00000000 00000000 00010001 10010100
		FEConfRegWrite(1,  35,     1);	--     1);	-- 0x00000001 = 0b00000000 00000000 00000000 00000001
		FEConfRegWrite(1,  36,    80);	--  5000);	-- 0x00001388 = 0b00000000 00000000 00010011 10001000 
		

		WaitClks(50);

				
		--WaitClks(50);
		
		FERegRead(2, 32, 3); --FE1, FW-ID

		WaitClks(50);
		
		for n in 0 to 4 loop
			TrigRegWrite(TRIG_QDR, (16#00020000#) + n);
			WaitClks(10);
			j2_trig <= "0000000000000001";
			WaitClks(2);
			j2_trig <= "0000000000000000";
			WaitClks(1100);
			TrigRegWrite(CONTROL, 		0); --clear busy
			WaitClks(300);
					
			FERegRead(1, TRIGGER_COUNT, 32); --FE1(of 0-7), Trig-COUNT
			
		end loop;
		
		
		vme_throttle         <= '0';
		WaitClks(200);
		vme_throttle         <= '1';
			
		BERegWrite(TRIG_CONTROL,	32, 16#00003202#	);
		WaitClks(1000);
		
		for n in 0 to 2 loop
			TrigRegWrite(TRIG_QDR, (n*16#10000#) + 3);
			WaitClks(10);
			j2_trig <= "0000000000000001";
			WaitClks(2);
			j2_trig <= "0000000000000000";
			WaitClks(1100);
			TrigRegWrite(CONTROL, 		0); --clear busy
			WaitClks(300);
			
			vme_throttle         <= '0';
			WaitClks(200);
			vme_throttle         <= '1';
			
		end loop;
		
		vme_throttle         <= '0';
		
		wait;      
  	end process;  
      
end test;
