-- hds header_start
--
-- VHDL Entity CALICE_BE_fpga.addr_gen1.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 11:54:09 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity addr_gen1 is
   port( 
      FE_enable_reg           : in     std_logic_vector (8 downto 1);
      back_pressure_B         : in     std_logic;
      clk1x                   : in     std_logic;
      clk2x                   : in     std_logic;
      data_out_en             : in     std_logic;
      en_fe_data_capture      : in     std_logic;
      internal_freeze_bar     : in     std_logic;
      rdout_sync_in           : in     std_logic_vector (8 downto 1);
      rdout_sync_out_sig1     : in     std_logic;
      reset                   : in     std_logic;
      done                    : out    std_logic;
      empty_flags             : out    std_logic_vector (7 downto 0);
      frm_addr_and_lengths    : out    std_logic_vector (35 downto 0);
      frm_addr_fifo_empty     : out    std_logic;
      full_flags              : out    std_logic_vector (7 downto 0);
      half_full_flags         : out    std_logic_vector (7 downto 0);
      partial_empty_flags     : out    std_logic_vector (7 downto 0);
      partial_full_flags      : out    std_logic_vector (7 downto 0);
      qdr_data_count          : out    std_logic_vector (17 downto 0);
      qdr_frame_count         : out    std_logic_vector (23 downto 0);
      qdr_rd_addr             : out    std_logic_vector (18 downto 1);
      qdr_rd_addr_en          : out    std_logic;
      qdr_wr_addr             : out    std_logic_vector (18 downto 1);
      qdr_wr_addr_en          : out    std_logic;
      rd_fe_lengths           : out    std_logic_vector (17 downto 0);
      rd_total_length_fifo_en : out    std_logic;
      rd_trckr_hdr_en         : out    std_logic;
      readout_sync_out_sig    : out    std_logic;
      start_data_format       : out    std_logic;
      stop_data_format        : out    std_logic;
      store_frame_data_bus    : out    std_logic_VECTOR (7 downto 0);
      total_frame_count       : out    std_logic_vector (23 downto 0)
   );

-- Declarations

end addr_gen1 ;


-- hds interface_end

--
-- VHDL Architecture CALICE_BE_fpga.addr_gen1.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 11:54:11 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

LIBRARY ieee;
USE ieee.std_logic_1164.all;

library CALICE_BE_fpga;

architecture struct of addr_gen1 is

   -- Architecture declarations

   -- Internal signal declarations
   signal addr_bases              : std_logic_vector(143 downto 0);
   signal byte_length1            : std_logic_vector(14 downto 0);
   signal byte_length2            : std_logic_vector(14 downto 0);
   signal byte_length3            : std_logic_vector(14 downto 0);
   signal byte_length4            : std_logic_vector(14 downto 0);
   signal byte_length5            : std_logic_vector(14 downto 0);
   signal byte_length6            : std_logic_vector(14 downto 0);
   signal byte_length7            : std_logic_vector(14 downto 0);
   signal byte_length8            : std_logic_vector(14 downto 0);
   signal done_1                  : std_logic;
   signal done_2                  : std_logic;
   signal fe_len_25_flag          : std_logic;
   signal fe_len_50_flag          : std_logic;
   signal fe_len_87_flag          : std_logic;
   signal fe_len_empty            : std_logic;
   signal fe_len_full             : std_logic;
   signal frame_lengths           : std_logic_vector(143 downto 0);
   signal frm_addr_25_flag        : std_logic;
   signal frm_addr_50_flag        : std_logic;
   signal frm_addr_87_flag        : std_logic;
   signal frm_addr_fifo_empty1    : std_logic;
   signal frm_addr_fifo_full      : std_logic;
   signal length1                 : std_logic_vector(17 downto 0);
   signal length2                 : std_logic_vector(17 downto 0);
   signal length3                 : std_logic_vector(17 downto 0);
   signal length4                 : std_logic_vector(17 downto 0);
   signal length5                 : std_logic_vector(17 downto 0);
   signal length6                 : std_logic_vector(17 downto 0);
   signal length7                 : std_logic_vector(17 downto 0);
   signal length8                 : std_logic_vector(17 downto 0);
   signal low                     : std_logic;
   signal qdr_25_flag             : std_logic;
   signal qdr_50_flag             : std_logic;
   signal qdr_87_flag             : std_logic;
   signal qdr_empty_flag          : std_logic;
   signal qdr_full_flag           : std_logic;
   signal readout_sync_sig        : std_logic;
   signal rst_registers           : std_logic;
   signal total_length_25_flag    : std_logic;
   signal total_length_50_flag    : std_logic;
   signal total_length_87_flag    : std_logic;
   signal total_length_fifo_empty : std_logic;
   signal total_length_fifo_full  : std_logic;

   -- Implicit buffer signal declarations
   signal rd_trckr_hdr_en_internal         : std_logic;
   signal frm_addr_and_lengths_internal    : std_logic_vector (35 downto 0);
   signal rd_total_length_fifo_en_internal : std_logic;
   signal frm_addr_fifo_empty_internal     : std_logic;
   signal done_internal                    : std_logic;


   -- Component Declarations
   component base_gen1
   port (
      clk1x                   : in     std_logic ;
      clk2x                   : in     std_logic ;
      done_1                  : in     std_logic ;
      internal_freeze_bar     : in     std_logic ;
      length1                 : in     std_logic_vector (17 downto 0);
      length2                 : in     std_logic_vector (17 downto 0);
      length3                 : in     std_logic_vector (17 downto 0);
      length4                 : in     std_logic_vector (17 downto 0);
      length5                 : in     std_logic_vector (17 downto 0);
      length6                 : in     std_logic_vector (17 downto 0);
      length7                 : in     std_logic_vector (17 downto 0);
      length8                 : in     std_logic_vector (17 downto 0);
      rd_total_length_fifo_en : in     std_logic ;
      reset                   : in     std_logic ;
      addr_bases              : out    std_logic_vector (143 downto 0);
      done_2                  : out    std_logic ;
      frame_lengths           : out    std_logic_vector (143 downto 0);
      frm_addr_and_lengths    : out    std_logic_vector (35 downto 0);
      readout_sync_sig        : out    std_logic ;
      rst_registers           : out    std_logic ;
      total_length_25_flag    : out    std_logic ;
      total_length_50_flag    : out    std_logic ;
      total_length_87_flag    : out    std_logic ;
      total_length_fifo_empty : out    std_logic ;
      total_length_fifo_full  : out    std_logic 
   );
   end component;
   component base_length_gen1
   port (
      addr_bases              : in     std_logic_vector (143 downto 0);
      back_pressure_B         : in     std_logic ;
      clk1x                   : in     std_logic ;
      clk2x                   : in     std_logic ;
      data_out_en             : in     std_logic ;
      done_2                  : in     std_logic ;
      frame_lengths           : in     std_logic_vector (143 downto 0);
      frm_addr_and_lengths    : in     std_logic_vector (35 downto 0);
      internal_freeze_bar     : in     std_logic ;
      rdout_sync_out_sig1     : in     std_logic ;
      readout_sync_sig        : in     std_logic ;
      reset                   : in     std_logic ;
      total_length_fifo_empty : in     std_logic ;
      frm_addr_25_flag        : out    std_logic ;
      frm_addr_50_flag        : out    std_logic ;
      frm_addr_87_flag        : out    std_logic ;
      frm_addr_fifo_empty     : out    std_logic ;
      frm_addr_fifo_full      : out    std_logic ;
      qdr_25_flag             : out    std_logic ;
      qdr_50_flag             : out    std_logic ;
      qdr_87_flag             : out    std_logic ;
      qdr_data_count          : out    std_logic_vector (17 downto 0);
      qdr_empty_flag          : out    std_logic ;
      qdr_frame_count         : out    std_logic_vector (23 downto 0);
      qdr_full_flag           : out    std_logic ;
      qdr_rd_addr             : out    std_logic_vector (18 downto 1);
      qdr_rd_addr_en          : out    std_logic ;
      qdr_wr_addr             : out    std_logic_vector (18 downto 1);
      qdr_wr_addr_en          : out    std_logic ;
      rd_total_length_fifo_en : out    std_logic ;
      rd_trckr_hdr_en         : out    std_logic ;
      readout_sync_out_sig    : out    std_logic ;
      start_data_format       : out    std_logic ;
      stop_data_format        : out    std_logic ;
      store_frame_data_bus    : out    std_logic_VECTOR (7 downto 0);
      total_frame_count       : out    std_logic_vector (23 downto 0)
   );
   end component;
   component lengths_deserialise1
   port (
      FE_enable_reg      : in     std_logic_vector (8 downto 1);
      clk1x              : in     std_logic ;
      en_fe_data_capture : in     std_logic ;
      rdout_sync_in      : in     std_logic_vector (8 downto 1);
      rst_registers      : in     std_logic ;
      byte_length1       : out    std_logic_vector (14 downto 0);
      byte_length2       : out    std_logic_vector (14 downto 0);
      byte_length3       : out    std_logic_vector (14 downto 0);
      byte_length4       : out    std_logic_vector (14 downto 0);
      byte_length5       : out    std_logic_vector (14 downto 0);
      byte_length6       : out    std_logic_vector (14 downto 0);
      byte_length7       : out    std_logic_vector (14 downto 0);
      byte_length8       : out    std_logic_vector (14 downto 0);
      done               : out    std_logic 
   );
   end component;
   component word64_lengths1
   port (
      byte_length1       : in     std_logic_vector (14 downto 0);
      byte_length2       : in     std_logic_vector (14 downto 0);
      byte_length3       : in     std_logic_vector (14 downto 0);
      byte_length4       : in     std_logic_vector (14 downto 0);
      byte_length5       : in     std_logic_vector (14 downto 0);
      byte_length6       : in     std_logic_vector (14 downto 0);
      byte_length7       : in     std_logic_vector (14 downto 0);
      byte_length8       : in     std_logic_vector (14 downto 0);
      clk1x              : in     std_logic ;
      clk2x              : in     std_logic ;
      done               : in     std_logic ;
      en_fe_data_capture : in     std_logic ;
      rd_trckr_hdr_en    : in     std_logic ;
      reset              : in     std_logic ;
      rst_registers      : in     std_logic ;
      done_1             : out    std_logic ;
      fe_len_25_flag     : out    std_logic ;
      fe_len_50_flag     : out    std_logic ;
      fe_len_87_flag     : out    std_logic ;
      fe_len_empty       : out    std_logic ;
      fe_len_full        : out    std_logic ;
      length1            : out    std_logic_vector (17 downto 0);
      length2            : out    std_logic_vector (17 downto 0);
      length3            : out    std_logic_vector (17 downto 0);
      length4            : out    std_logic_vector (17 downto 0);
      length5            : out    std_logic_vector (17 downto 0);
      length6            : out    std_logic_vector (17 downto 0);
      length7            : out    std_logic_vector (17 downto 0);
      length8            : out    std_logic_vector (17 downto 0);
      rd_fe_lengths      : out    std_logic_vector (17 downto 0)
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : base_gen1 use entity CALICE_BE_fpga.base_gen1;
   for all : base_length_gen1 use entity CALICE_BE_fpga.base_length_gen1;
   for all : lengths_deserialise1 use entity CALICE_BE_fpga.lengths_deserialise1;
   for all : word64_lengths1 use entity CALICE_BE_fpga.word64_lengths1;
   -- pragma synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb1
   empty_flags(0) <= qdr_empty_flag;
   empty_flags(1) <= frm_addr_fifo_empty1;
   empty_flags(2) <= total_length_fifo_empty;
   empty_flags(5) <= fe_len_empty;
   
   partial_empty_flags(0) <= qdr_25_flag;
   partial_empty_flags(1) <= frm_addr_25_flag;
   partial_empty_flags(2) <= total_length_25_flag;
   partial_empty_flags(5) <= fe_len_25_flag;
   
   half_full_flags(0) <= qdr_50_flag;
   half_full_flags(1) <= frm_addr_50_flag;
   half_full_flags(2) <= total_length_50_flag;
   half_full_flags(5) <= fe_len_50_flag;
   
   partial_full_flags(0) <= qdr_87_flag;
   partial_full_flags(1) <= frm_addr_87_flag;
   partial_full_flags(2) <= total_length_87_flag;
   partial_full_flags(5) <= fe_len_87_flag;
   
   full_flags(0) <= qdr_full_flag;
   full_flags(1) <= frm_addr_fifo_full;
   full_flags(2) <= total_length_fifo_full;
   full_flags(5) <= fe_len_full;


   -- ModuleWare code for instance 'I3' of 'gnd'
      low <= '0';

   -- ModuleWare code for instance 'I10' of 'buff'
   frm_addr_fifo_empty1 <= frm_addr_fifo_empty_internal;
   -- Instance port mappings.
   I4 : base_gen1
      port map (
         clk1x                   => clk1x,
         clk2x                   => clk2x,
         done_1                  => done_1,
         internal_freeze_bar     => internal_freeze_bar,
         length1                 => length1,
         length2                 => length2,
         length3                 => length3,
         length4                 => length4,
         length5                 => length5,
         length6                 => length6,
         length7                 => length7,
         length8                 => length8,
         rd_total_length_fifo_en => rd_total_length_fifo_en_internal,
         reset                   => reset,
         addr_bases              => addr_bases,
         done_2                  => done_2,
         frame_lengths           => frame_lengths,
         frm_addr_and_lengths    => frm_addr_and_lengths_internal,
         readout_sync_sig        => readout_sync_sig,
         rst_registers           => rst_registers,
         total_length_25_flag    => total_length_25_flag,
         total_length_50_flag    => total_length_50_flag,
         total_length_87_flag    => total_length_87_flag,
         total_length_fifo_empty => total_length_fifo_empty,
         total_length_fifo_full  => total_length_fifo_full
      );
   I5 : base_length_gen1
      port map (
         addr_bases              => addr_bases,
         back_pressure_B         => back_pressure_B,
         clk1x                   => clk1x,
         clk2x                   => clk2x,
         data_out_en             => data_out_en,
         done_2                  => done_2,
         frame_lengths           => frame_lengths,
         frm_addr_and_lengths    => frm_addr_and_lengths_internal,
         internal_freeze_bar     => internal_freeze_bar,
         rdout_sync_out_sig1     => rdout_sync_out_sig1,
         readout_sync_sig        => readout_sync_sig,
         reset                   => reset,
         total_length_fifo_empty => total_length_fifo_empty,
         frm_addr_25_flag        => frm_addr_25_flag,
         frm_addr_50_flag        => frm_addr_50_flag,
         frm_addr_87_flag        => frm_addr_87_flag,
         frm_addr_fifo_empty     => frm_addr_fifo_empty_internal,
         frm_addr_fifo_full      => frm_addr_fifo_full,
         qdr_25_flag             => qdr_25_flag,
         qdr_50_flag             => qdr_50_flag,
         qdr_87_flag             => qdr_87_flag,
         qdr_data_count          => qdr_data_count,
         qdr_empty_flag          => qdr_empty_flag,
         qdr_frame_count         => qdr_frame_count,
         qdr_full_flag           => qdr_full_flag,
         qdr_rd_addr             => qdr_rd_addr,
         qdr_rd_addr_en          => qdr_rd_addr_en,
         qdr_wr_addr             => qdr_wr_addr,
         qdr_wr_addr_en          => qdr_wr_addr_en,
         rd_total_length_fifo_en => rd_total_length_fifo_en_internal,
         rd_trckr_hdr_en         => rd_trckr_hdr_en_internal,
         readout_sync_out_sig    => readout_sync_out_sig,
         start_data_format       => start_data_format,
         stop_data_format        => stop_data_format,
         store_frame_data_bus    => store_frame_data_bus,
         total_frame_count       => total_frame_count
      );
   I0 : lengths_deserialise1
      port map (
         FE_enable_reg      => FE_enable_reg,
         clk1x              => clk1x,
         en_fe_data_capture => en_fe_data_capture,
         rdout_sync_in      => rdout_sync_in,
         rst_registers      => rst_registers,
         byte_length1       => byte_length1,
         byte_length2       => byte_length2,
         byte_length3       => byte_length3,
         byte_length4       => byte_length4,
         byte_length5       => byte_length5,
         byte_length6       => byte_length6,
         byte_length7       => byte_length7,
         byte_length8       => byte_length8,
         done               => done_internal
      );
   I1 : word64_lengths1
      port map (
         byte_length1       => byte_length1,
         byte_length2       => byte_length2,
         byte_length3       => byte_length3,
         byte_length4       => byte_length4,
         byte_length5       => byte_length5,
         byte_length6       => byte_length6,
         byte_length7       => byte_length7,
         byte_length8       => byte_length8,
         clk1x              => clk1x,
         clk2x              => clk2x,
         done               => done_internal,
         en_fe_data_capture => en_fe_data_capture,
         rd_trckr_hdr_en    => rd_trckr_hdr_en_internal,
         reset              => reset,
         rst_registers      => rst_registers,
         done_1             => done_1,
         fe_len_25_flag     => fe_len_25_flag,
         fe_len_50_flag     => fe_len_50_flag,
         fe_len_87_flag     => fe_len_87_flag,
         fe_len_empty       => fe_len_empty,
         fe_len_full        => fe_len_full,
         length1            => length1,
         length2            => length2,
         length3            => length3,
         length4            => length4,
         length5            => length5,
         length6            => length6,
         length7            => length7,
         length8            => length8,
         rd_fe_lengths      => rd_fe_lengths
      );

   -- Implicit buffered output assignments
   rd_trckr_hdr_en         <= rd_trckr_hdr_en_internal;
   frm_addr_and_lengths    <= frm_addr_and_lengths_internal;
   rd_total_length_fifo_en <= rd_total_length_fifo_en_internal;
   frm_addr_fifo_empty     <= frm_addr_fifo_empty_internal;
   done                    <= done_internal;

end struct;
