-- hds header_start
--
-- Module xaw_dll_4phase40
-- Generated by Xilinx Architecture Wizard
-- VHDL
-- Written for synthesis tool: LeonardoSpectrum
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
-- synopsys translate_off
--library unisim;
--use unisim.vcomponents.all;
-- synopsys translate_on
library unisim;
use unisim.vpkg.all;

entity aw_dcm_4phase is
    port (
        CLKIN_IN : in std_logic;
        RST_IN : in std_logic;
        STATUS_OUT : out std_logic_vector (2 downto 0);
        LOCKED_OUT : out std_logic;
        CLK90_OUT : out std_logic;
        CLK180_OUT : out std_logic;
        CLK270_OUT : out std_logic;
        CLK0_OUT : out std_logic
        );
end aw_dcm_4phase;

architecture xilinx of aw_dcm_4phase is
   signal CLKFB_IN : std_logic;
   signal CLK0_BUF : std_logic;
   signal CLK90_BUF : std_logic;
   signal CLK180_BUF : std_logic;
   signal CLK270_BUF : std_logic;
   signal GND : std_logic;
   signal STATUS_float : std_logic_vector (4 downto 0);

   attribute CLK_FEEDBACK : string;
   attribute CLK_FEEDBACK of DCM_INST : label is "1X";
   attribute CLKDV_DIVIDE : real;
   attribute CLKDV_DIVIDE of DCM_INST : label is 2.0;
   attribute CLKFX_DIVIDE : integer;
   attribute CLKFX_DIVIDE of DCM_INST : label is 1;
   attribute CLKFX_MULTIPLY : integer;
   attribute CLKFX_MULTIPLY of DCM_INST : label is 4;
   attribute CLKIN_DIVIDE_BY_2 : boolean;
   attribute CLKIN_DIVIDE_BY_2 of DCM_INST : label is FALSE;
   attribute CLKIN_PERIOD : real;
   attribute CLKIN_PERIOD of DCM_INST : label is 25.0;
   attribute CLKOUT_PHASE_SHIFT : string;
   attribute CLKOUT_PHASE_SHIFT of DCM_INST : label is "NONE";
   attribute DESKEW_ADJUST : string;
   attribute DESKEW_ADJUST of DCM_INST : label is "SYSTEM_SYNCHRONOUS";
   attribute DFS_FREQUENCY_MODE : string;
   attribute DFS_FREQUENCY_MODE of DCM_INST : label is "LOW";
   attribute DLL_FREQUENCY_MODE : string;
   attribute DLL_FREQUENCY_MODE of DCM_INST : label is "LOW";
   attribute DUTY_CYCLE_CORRECTION : boolean;
   attribute DUTY_CYCLE_CORRECTION of DCM_INST : label is TRUE;
   attribute PHASE_SHIFT : integer;
   attribute PHASE_SHIFT of DCM_INST : label is 0;
   attribute STARTUP_WAIT : boolean;
   attribute STARTUP_WAIT of DCM_INST : label is FALSE;

   component DCM
-- synopsys translate_off
    generic( 
       CLKDV_DIVIDE : real := 2.0;
       CLKFX_DIVIDE : integer := 1;
       CLKFX_MULTIPLY : integer := 4;
       CLKIN_DIVIDE_BY_2 : boolean := false;
       CLKIN_PERIOD : real := 0.0;                         
       CLKOUT_PHASE_SHIFT : string := "NONE";
       CLK_FEEDBACK : string := "1X";
       DESKEW_ADJUST : string := "SYSTEM_SYNCHRONOUS";     
       DFS_FREQUENCY_MODE : string := "LOW";
       DLL_FREQUENCY_MODE : string := "LOW";
       DSS_MODE : string := "NONE";                        
       DUTY_CYCLE_CORRECTION : boolean := true;
       FACTORY_JF : bit_vector := X"C080";                 
       MAXPERCLKIN : time := 1000000 ps;                   
       MAXPERPSCLK : time := 100000000 ps;                 
       PHASE_SHIFT : integer := 0;
       SIM_CLKIN_CYCLE_JITTER : time := 300 ps;            
       SIM_CLKIN_PERIOD_JITTER : time := 1000 ps;          
       STARTUP_WAIT : boolean := false                     
     );
-- synopsys translate_on
     port (
       CLKIN : in std_logic;
       CLKFB : in std_logic;
       RST : in std_logic;
       PSEN : in std_logic;
       PSINCDEC : in std_logic;
       PSCLK : in std_logic;
       DSSEN : in std_logic;
       CLK0 : out std_logic;
       CLK90 : out std_logic;
       CLK180 : out std_logic;
       CLK270 : out std_logic;
       CLKDV : out std_logic;
       CLK2X : out std_logic;
       CLK2X180 : out std_logic;
       CLKFX : out std_logic;
       CLKFX180 : out std_logic;
       STATUS : out std_logic_vector (7 downto 0);
       LOCKED : out std_logic;
       PSDONE : out std_logic
       );
   end component;
   component BUFG
     port (
       I : in std_logic;
       O : out std_logic
       );
   end component;

begin
   DCM_INST : DCM
-- synopsys translate_off
    Generic map (
      CLK_FEEDBACK => "1X",
      CLKDV_DIVIDE => 2.0,
      CLKFX_DIVIDE => 1,
      CLKFX_MULTIPLY => 4,
      CLKIN_DIVIDE_BY_2 => FALSE,
      CLKIN_PERIOD => 25.0,
      CLKOUT_PHASE_SHIFT => "NONE",
      DESKEW_ADJUST => "SYSTEM_SYNCHRONOUS",
      DFS_FREQUENCY_MODE => "LOW",
      DLL_FREQUENCY_MODE => "LOW",
      DUTY_CYCLE_CORRECTION => TRUE,
      PHASE_SHIFT => 0,
      STARTUP_WAIT => FALSE)
-- synopsys translate_on
     port map (
      CLKIN => CLKIN_IN,
      CLKFB => CLKFB_IN,
      RST => RST_IN,
      PSEN => GND,
      PSINCDEC => GND,
      PSCLK => GND,
      DSSEN => GND,
      CLK0 => CLK0_BUF,
      CLK90 => CLK90_BUF,
      CLK180 => CLK180_BUF,
      CLK270 => CLK270_BUF,
      STATUS(2 downto 0) => STATUS_OUT(2 downto 0),
      STATUS(7 downto 3) => STATUS_float(4 downto 0),
      LOCKED => LOCKED_OUT);

   CLK0_BUFG_INST : BUFG
     port map (
      I => CLK0_BUF,
      O => CLKFB_IN);

   CLK90_BUFG_INST : BUFG
     port map (
      I => CLK90_BUF,
      O => CLK90_OUT);

   CLK180_BUFG_INST : BUFG
     port map (
      I => CLK180_BUF,
      O => CLK180_OUT);

   CLK270_BUFG_INST : BUFG
     port map (
      I => CLK270_BUF,
      O => CLK270_OUT);

   CLK0_OUT <= CLKFB_IN;
   GND <= '0';
   
end xilinx ;

