-- hds header_start
--
-- VHDL Entity CALICE_BE_fpga.base_length_gen.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:54:00 08/11/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity base_length_gen is
   port( 
      addr_bases              : in     std_logic_vector (143 downto 0);
      back_pressure_B         : in     std_logic;
      clk1x                   : in     std_logic;
      clk2x                   : in     std_logic;
      data_out_en             : in     std_logic;
      done_2                  : in     std_logic;
      frame_lengths           : in     std_logic_vector (143 downto 0);
      frm_addr_and_lengths    : in     std_logic_vector (35 downto 0);
      internal_freeze_bar     : in     std_logic;
      rdout_sync_out_sig1     : in     std_logic;
      readout_sync_sig        : in     std_logic;
      reset                   : in     std_logic;
      total_length_fifo_empty : in     std_logic;
      frm_addr_25_flag        : out    std_logic;
      frm_addr_50_flag        : out    std_logic;
      frm_addr_87_flag        : out    std_logic;
      frm_addr_fifo_empty     : out    std_logic;
      frm_addr_fifo_full      : out    std_logic;
      qdr_25_flag             : out    std_logic;
      qdr_50_flag             : out    std_logic;
      qdr_87_flag             : out    std_logic;
      qdr_data_count          : out    std_logic_vector (17 downto 0);
      qdr_empty_flag          : out    std_logic;
      qdr_frame_count         : out    std_logic_vector (23 downto 0);
      qdr_full_flag           : out    std_logic;
      qdr_rd_addr             : out    std_logic_vector (18 downto 1);
      qdr_rd_addr_en          : out    std_logic;
      qdr_wr_addr             : out    std_logic_vector (18 downto 1);
      qdr_wr_addr_en          : out    std_logic;
      rd_total_length_fifo_en : out    std_logic;
      rd_trckr_hdr_en         : out    std_logic;
      readout_sync_out_sig    : out    std_logic;
      start_data_format       : out    std_logic;
      stop_data_format        : out    std_logic;
      store_frame_data_bus    : out    std_logic_VECTOR (7 downto 0);
      total_frame_count       : out    std_logic_vector (23 downto 0)
   );

-- Declarations

end base_length_gen ;


-- hds interface_end

--
-- VHDL Architecture CALICE_BE_fpga.base_length_gen.struct_1
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:54:04 08/11/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

library CALICE_BE_fpga;
library unisim;

architecture struct_1 of base_length_gen is

   -- Architecture declarations

   -- Internal signal declarations
   signal addr_length_fifo_en    : std_logic;
   signal addr_length_fifo_wr_en : std_logic;
   signal din1                   : std_logic_vector(23 downto 0);
   signal en_frm_cnt_dwn         : std_logic;
   signal en_frm_cnt_up          : std_logic;
   signal frm_cntr_clk_en        : std_logic;
   signal frm_cntr_up_dn         : std_logic;
   signal frm_lenght_fifo_empty  : std_logic;
   signal high                   : std_logic;
   signal load_or_count          : std_logic;
   signal low                    : std_logic;
   signal max1                   : std_logic;
   signal max2                   : std_logic;
   signal rd_length_1            : std_logic_vector(17 downto 0);
   signal rd_load_or_count       : std_logic;
   signal wr_addr_fifo_flags     : std_logic_vector(2 downto 0);
   signal wr_base                : std_logic_vector(17 downto 0);
   signal wr_base_1              : std_logic_VECTOR(17 downto 0);
   signal wr_base_a              : std_logic_VECTOR(17 downto 0);
   signal wr_base_length_en      : std_logic;
   signal wr_length              : std_logic_vector(17 downto 0);
   signal wr_length_1            : std_logic_vector(17 downto 0);
   signal wr_length_a            : std_logic_vector(17 downto 0);
   signal wrd_cntr_clk_en        : std_logic;
   signal wrd_cntr_up_dn         : std_logic;

   -- Implicit buffer signal declarations
   signal qdr_wr_addr_en_internal       : std_logic;
   signal store_frame_data_bus_internal : std_logic_VECTOR (7 downto 0);
   signal qdr_rd_addr_en_internal       : std_logic;
   signal qdr_frame_count_internal      : std_logic_vector (23 downto 0);
   signal qdr_data_count_internal       : std_logic_vector (17 downto 0);


   -- Component Declarations
   component AND2
   port (
      I0 : in     STD_ULOGIC;
      I1 : in     STD_ULOGIC;
      O  : out    STD_ULOGIC
   );
   end component;
   component cntr_18bits
   port (
      Q       : out    std_logic_VECTOR (17 downto 0);
      CLK     : in     std_logic ;
      UP      : in     std_logic ;
      THRESH0 : out    std_logic ;
      CE      : in     std_logic ;
      ACLR    : in     std_logic 
   );
   end component;
   component count_frame_cntl
   port (
      clk2x               : in     std_logic ;
      en_frm_cnt_dwn      : in     std_logic ;
      en_frm_cnt_up       : in     std_logic ;
      internal_freeze_bar : in     std_logic ;
      reset               : in     std_logic ;
      frm_cntr_clk_en     : out    std_logic ;
      frm_cntr_up_dn      : out    std_logic 
   );
   end component;
   component count_word_cntl
   port (
      clk2x               : in     std_logic ;
      internal_freeze_bar : in     std_logic ;
      qdr_rd_addr_en      : in     std_logic ;
      qdr_wr_addr_en      : in     std_logic ;
      reset               : in     std_logic ;
      wrd_cntr_clk_en     : out    std_logic ;
      wrd_cntr_up_dn      : out    std_logic 
   );
   end component;
   component fifo_4k_18bits
   port (
      din      : in     std_logic_VECTOR (17 downto 0);
      wr_en    : in     std_logic ;
      wr_clk   : in     std_logic ;
      rd_en    : in     std_logic ;
      rd_clk   : in     std_logic ;
      ainit    : in     std_logic ;
      dout     : out    std_logic_VECTOR (17 downto 0);
      full     : out    std_logic ;
      empty    : out    std_logic ;
      wr_count : out    std_logic_VECTOR (2 downto 0)
   );
   end component;
   component frm_addr_flag_gen
   port (
      clk2x              : in     std_logic ;
      reset              : in     std_logic ;
      wr_addr_fifo_flags : in     std_logic_vector (2 downto 0);
      frm_addr_25_flag   : out    std_logic ;
      frm_addr_50_flag   : out    std_logic ;
      frm_addr_87_flag   : out    std_logic 
   );
   end component;
   component qdr_flags_gen
   port (
      clk2x          : in     std_logic ;
      qdr_data_count : in     std_logic_vector (17 downto 0);
      reset          : in     std_logic ;
      qdr_25_flag    : out    std_logic ;
      qdr_50_flag    : out    std_logic ;
      qdr_87_flag    : out    std_logic ;
      qdr_empty_flag : out    std_logic ;
      qdr_full_flag  : out    std_logic 
   );
   end component;
   component qdr_rd_addr_cntl
   port (
      back_pressure_B         : in     std_logic ;
      clk2x                   : in     std_logic ;
      data_out_en             : in     std_logic ;
      qdr_frame_count         : in     std_logic_vector (23 downto 0);
      rd_length_1             : in     std_logic_vector (17 downto 0);
      reset                   : in     std_logic ;
      total_length_fifo_empty : in     std_logic ;
      en_frm_cnt_dwn          : out    std_logic ;
      rd_load_or_count        : out    std_logic ;
      rd_total_length_fifo_en : out    std_logic ;
      rd_trckr_hdr_en         : out    std_logic ;
      start_data_format       : out    std_logic ;
      stop_data_format        : out    std_logic 
   );
   end component;
   component qdr_wr_addr_cntl
   port (
      clk2x                 : in     std_logic ;
      frm_lenght_fifo_empty : in     std_logic ;
      rdout_sync_out_sig1   : in     std_logic ;
      readout_sync_sig      : in     std_logic ;
      reset                 : in     std_logic ;
      store_frame_data_bus  : in     std_logic_VECTOR (7 downto 0);
      addr_length_fifo_en   : out    std_logic ;
      en_frm_cnt_up         : out    std_logic ;
      load_or_count         : out    std_logic ;
      readout_sync_out_sig  : out    std_logic 
   );
   end component;
   component rd_addr_sr
   port (
      back_pressure_B      : in     std_logic ;
      clk2x                : in     std_logic ;
      frm_addr_and_lengths : in     std_logic_vector (35 downto 0);
      rd_load_or_count     : in     std_logic ;
      reset                : in     std_logic ;
      qdr_rd_addr          : out    std_logic_vector (18 downto 1);
      qdr_rd_addr_en       : out    std_logic ;
      rd_length_1          : out    std_logic_vector (17 downto 0)
   );
   end component;
   component wr_addr_sr
   port (
      clk2x                : in     std_logic ;
      internal_freeze_bar  : in     std_logic ;
      load_or_count        : in     std_logic ;
      reset                : in     std_logic ;
      wr_base_1            : in     std_logic_VECTOR (17 downto 0);
      wr_length_1          : in     std_logic_vector (17 downto 0);
      qdr_wr_addr          : out    std_logic_vector (18 downto 1);
      qdr_wr_addr_en       : out    std_logic ;
      store_frame_data_bus : out    std_logic_VECTOR (7 downto 0)
   );
   end component;
   component wr_addr_to_fifo
   port (
      addr_bases        : in     std_logic_vector (143 downto 0);
      clk1x             : in     std_logic ;
      done_2            : in     std_logic ;
      frame_lengths     : in     std_logic_vector (143 downto 0);
      reset             : in     std_logic ;
      wr_base           : out    std_logic_vector (17 downto 0);
      wr_base_length_en : out    std_logic ;
      wr_length         : out    std_logic_vector (17 downto 0)
   );
   end component;

   -- ModuleWare Component Declarations
   component cntr_2DF246AE
   port (
      clk    : in     std_logic;
      clk_en : in     std_logic;
      din    : in     std_logic_vector (23 downto 0);
      load   : in     std_logic;
      reset  : in     std_logic;
      up_dn  : in     std_logic;
      count  : out    std_logic_vector (23 downto 0);
      max    : out    std_logic
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : AND2 use entity unisim.AND2;
   for all : cntr_18bits use entity CALICE_BE_fpga.cntr_18bits;
   for all : count_frame_cntl use entity CALICE_BE_fpga.count_frame_cntl;
   for all : count_word_cntl use entity CALICE_BE_fpga.count_word_cntl;
   for all : fifo_4k_18bits use entity CALICE_BE_fpga.fifo_4k_18bits;
   for all : frm_addr_flag_gen use entity CALICE_BE_fpga.frm_addr_flag_gen;
   for all : qdr_flags_gen use entity CALICE_BE_fpga.qdr_flags_gen;
   for all : qdr_rd_addr_cntl use entity CALICE_BE_fpga.qdr_rd_addr_cntl;
   for all : qdr_wr_addr_cntl use entity CALICE_BE_fpga.qdr_wr_addr_cntl;
   for all : rd_addr_sr use entity CALICE_BE_fpga.rd_addr_sr;
   for all : wr_addr_sr use entity CALICE_BE_fpga.wr_addr_sr;
   for all : wr_addr_to_fifo use entity CALICE_BE_fpga.wr_addr_to_fifo;
   -- pragma synthesis_on

   -- ModuleWare embedded configurations
   -- pragma synthesis_off
   for all : cntr_2DF246AE use entity CALICE_BE_fpga.cntr_2DF246AE;
   -- pragma synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 2 eb2
   din1 <= (others => '0');
   low <= '0';
   high <= '1';

   -- HDL Embedded Text Block 3 delay
   -- This is  a delay block for signals
   
   wr_base_1 <= wr_base_a after 1 ns;
   wr_length_1 <= wr_length_a after 1 ns;

   -- Instance port mappings.
   I3 : AND2
      port map (
         O  => addr_length_fifo_wr_en,
         I0 => internal_freeze_bar,
         I1 => wr_base_length_en
      );
   qdr_data_cntr : cntr_18bits
      port map (
         Q       => qdr_data_count_internal,
         CLK     => clk2x,
         UP      => wrd_cntr_up_dn,
         THRESH0 => open,
         CE      => wrd_cntr_clk_en,
         ACLR    => reset
      );
   I8 : count_frame_cntl
      port map (
         clk2x               => clk2x,
         en_frm_cnt_dwn      => en_frm_cnt_dwn,
         en_frm_cnt_up       => en_frm_cnt_up,
         internal_freeze_bar => internal_freeze_bar,
         reset               => reset,
         frm_cntr_clk_en     => frm_cntr_clk_en,
         frm_cntr_up_dn      => frm_cntr_up_dn
      );
   I9 : count_word_cntl
      port map (
         clk2x               => clk2x,
         internal_freeze_bar => internal_freeze_bar,
         qdr_rd_addr_en      => qdr_rd_addr_en_internal,
         qdr_wr_addr_en      => qdr_wr_addr_en_internal,
         reset               => reset,
         wrd_cntr_clk_en     => wrd_cntr_clk_en,
         wrd_cntr_up_dn      => wrd_cntr_up_dn
      );
   frame_address_fifo : fifo_4k_18bits
      port map (
         din      => wr_base,
         wr_en    => addr_length_fifo_wr_en,
         wr_clk   => clk1x,
         rd_en    => addr_length_fifo_en,
         rd_clk   => clk2x,
         ainit    => reset,
         dout     => wr_base_a,
         full     => frm_addr_fifo_full,
         empty    => frm_addr_fifo_empty,
         wr_count => wr_addr_fifo_flags
      );
   frame_length_fifo : fifo_4k_18bits
      port map (
         din      => wr_length,
         wr_en    => addr_length_fifo_wr_en,
         wr_clk   => clk1x,
         rd_en    => addr_length_fifo_en,
         rd_clk   => clk2x,
         ainit    => reset,
         dout     => wr_length_a,
         full     => open,
         empty    => frm_lenght_fifo_empty,
         wr_count => open
      );
   I0 : frm_addr_flag_gen
      port map (
         clk2x              => clk2x,
         reset              => reset,
         wr_addr_fifo_flags => wr_addr_fifo_flags,
         frm_addr_25_flag   => frm_addr_25_flag,
         frm_addr_50_flag   => frm_addr_50_flag,
         frm_addr_87_flag   => frm_addr_87_flag
      );
   I13 : qdr_flags_gen
      port map (
         clk2x          => clk2x,
         qdr_data_count => qdr_data_count_internal,
         reset          => reset,
         qdr_25_flag    => qdr_25_flag,
         qdr_50_flag    => qdr_50_flag,
         qdr_87_flag    => qdr_87_flag,
         qdr_empty_flag => qdr_empty_flag,
         qdr_full_flag  => qdr_full_flag
      );
   I6 : qdr_rd_addr_cntl
      port map (
         back_pressure_B         => back_pressure_B,
         clk2x                   => clk2x,
         data_out_en             => data_out_en,
         qdr_frame_count         => qdr_frame_count_internal,
         rd_length_1             => rd_length_1,
         reset                   => reset,
         total_length_fifo_empty => total_length_fifo_empty,
         en_frm_cnt_dwn          => en_frm_cnt_dwn,
         rd_load_or_count        => rd_load_or_count,
         rd_total_length_fifo_en => rd_total_length_fifo_en,
         rd_trckr_hdr_en         => rd_trckr_hdr_en,
         start_data_format       => start_data_format,
         stop_data_format        => stop_data_format
      );
   I1 : qdr_wr_addr_cntl
      port map (
         clk2x                 => clk2x,
         frm_lenght_fifo_empty => frm_lenght_fifo_empty,
         rdout_sync_out_sig1   => rdout_sync_out_sig1,
         readout_sync_sig      => readout_sync_sig,
         reset                 => reset,
         store_frame_data_bus  => store_frame_data_bus_internal,
         addr_length_fifo_en   => addr_length_fifo_en,
         en_frm_cnt_up         => en_frm_cnt_up,
         load_or_count         => load_or_count,
         readout_sync_out_sig  => readout_sync_out_sig
      );
   I7 : rd_addr_sr
      port map (
         back_pressure_B      => back_pressure_B,
         clk2x                => clk2x,
         frm_addr_and_lengths => frm_addr_and_lengths,
         rd_load_or_count     => rd_load_or_count,
         reset                => reset,
         qdr_rd_addr          => qdr_rd_addr,
         qdr_rd_addr_en       => qdr_rd_addr_en_internal,
         rd_length_1          => rd_length_1
      );
   I2 : wr_addr_sr
      port map (
         clk2x                => clk2x,
         internal_freeze_bar  => internal_freeze_bar,
         load_or_count        => load_or_count,
         reset                => reset,
         wr_base_1            => wr_base_1,
         wr_length_1          => wr_length_1,
         qdr_wr_addr          => qdr_wr_addr,
         qdr_wr_addr_en       => qdr_wr_addr_en_internal,
         store_frame_data_bus => store_frame_data_bus_internal
      );
   I5 : wr_addr_to_fifo
      port map (
         addr_bases        => addr_bases,
         clk1x             => clk1x,
         done_2            => done_2,
         frame_lengths     => frame_lengths,
         reset             => reset,
         wr_base           => wr_base,
         wr_base_length_en => wr_base_length_en,
         wr_length         => wr_length
      );

   -- ModuleWare instance port mappings.
   qdr_frame_cntr : cntr_2DF246AE
      port map (
         clk    => clk2x,
         clk_en => frm_cntr_clk_en,
         din    => din1,
         load   => low,
         reset  => reset,
         up_dn  => frm_cntr_up_dn,
         count  => qdr_frame_count_internal,
         max    => max1
      );

   total_frame_cntr : cntr_2DF246AE
      port map (
         clk    => clk2x,
         clk_en => en_frm_cnt_up,
         din    => din1,
         load   => low,
         reset  => reset,
         up_dn  => high,
         count  => total_frame_count,
         max    => max2
      );


   -- Implicit buffered output assignments
   qdr_wr_addr_en       <= qdr_wr_addr_en_internal;
   store_frame_data_bus <= store_frame_data_bus_internal;
   qdr_rd_addr_en       <= qdr_rd_addr_en_internal;
   qdr_frame_count      <= qdr_frame_count_internal;
   qdr_data_count       <= qdr_data_count_internal;

end struct_1;
