-- hds header_start
--
-- VHDL Entity CERC_be_fpga.be_system.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:53:03 09/24/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity be_system is
   generic( 
      FIRMWARE_VER : integer := 16#0000#
   );
   port( 
      addr            : in     std_logic_vector (15 downto 0);
      clk             : in     std_logic;
      db_rd           : in     std_logic;
      db_wr           : in     std_logic;
      fe_all_status_i : in     std_logic_vector (2 downto 0);
      fifo_rd         : in     std_logic;
      fifo_stat_rd    : in     std_logic;
      rst             : in     std_logic;
      trig_ext0_i     : in     std_logic;
      trig_ext1_i     : in     std_logic;
      trig_ser_i      : in     std_logic;
      rst_fe_o        : out    std_logic;
      trig_fe0_o      : out    std_logic;
      trig_fe1_o      : out    std_logic;
      trig_fe2_o      : out    std_logic;
      trig_fe3_o      : out    std_logic;
      trig_fe4_o      : out    std_logic;
      trig_fe5_o      : out    std_logic;
      trig_fe6_o      : out    std_logic;
      trig_fe7_o      : out    std_logic;
      trig_in_all_o   : out    std_logic;
      trig_raw_o      : out    std_logic;
      trigger_o       : out    std_logic;
      db              : inout  std_logic_vector (31 downto 0);
      fe0_dataio      : inout  std_logic_vector (8 downto 2);
      fe1_dataio      : inout  std_logic_vector (8 downto 2);
      fe2_dataio      : inout  std_logic_vector (8 downto 2);
      fe3_dataio      : inout  std_logic_vector (8 downto 2);
      fe4_dataio      : inout  std_logic_vector (8 downto 2);
      fe5_dataio      : inout  std_logic_vector (8 downto 2);
      fe6_dataio      : inout  std_logic_vector (8 downto 2);
      fe7_dataio      : inout  std_logic_vector (8 downto 2)
   );

-- Declarations

end be_system ;


-- hds interface_end

--
-- VHDL Architecture CERC_be_fpga.be_system.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:53:04 09/24/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use IEEE.VITAL_Timing.ALL;

library CERC_be_fpga;
library CERC_lib;
library Timestamp;
library unisim;

architecture struct of be_system is

   -- Architecture declarations

   -- Internal signal declarations
   signal ONE            : std_logic;
   signal ZERO           : std_logic;
   signal busy_trig      : std_logic;
   signal epoc_secs      : std_logic_vector(31 downto 0);
   signal ram_en         : std_logic;
   signal reg_en         : std_logic_vector(63 downto 0);
   signal reg_input_en   : std_logic_vector(31 downto 0);
   signal reg_input_stat : std_logic_vector(31 downto 0);
   signal reg_output_en  : std_logic_vector(31 downto 0);
   signal reg_trig_ctrl  : std_logic_vector(31 downto 0);
   signal reg_trig_osc   : std_logic_vector(31 downto 0);
   signal rst_trig_osc   : std_logic;
   signal trig_all_bufg  : STD_LOGIC;
   signal trig_ctrl_set  : std_logic_vector(31 downto 0);
   signal trig_ext0      : std_logic;
   signal trig_ext0_en   : std_logic;
   signal trig_ext1      : std_logic;
   signal trig_ext1_en   : std_logic;
   signal trig_fe0_en    : std_logic;
   signal trig_fe1_en    : std_logic;
   signal trig_fe2_en    : std_logic;
   signal trig_fe3_en    : std_logic;
   signal trig_fe4_en    : std_logic;
   signal trig_fe5_en    : std_logic;
   signal trig_fe6_en    : std_logic;
   signal trig_fe7_en    : std_logic;
   signal trig_in_all    : std_logic;
   signal trig_osc       : std_logic;
   signal trig_osc_en    : std_logic;
   signal trig_osc_int   : std_logic;
   signal trig_raw       : std_logic;
   signal trig_raw_sync  : std_logic;
   signal trig_sync      : std_logic;
   signal trigger        : std_logic;


   -- Component Declarations
   component BUFG
   generic (
      TimingChecksOn : Boolean          := TRUE;
      InstancePath   : STRING           := "*";
      Xon            : Boolean          := True;
      MsgOn          : Boolean          := False;
      tpd_I_O        : VitalDelayType01 := (0.100 ns, 0.100 ns);
      tipd_I         : VitalDelayType01 := (0.000 ns, 0.000 ns)
   );
   port (
      O : out    STD_ULOGIC ;
      I : in     STD_ULOGIC 
   );
   end component;
   component addr_decoder64
   port (
      rst      : in     std_logic ;
      clk      : in     std_logic ;
      addr_i   : in     std_logic_vector (15 downto 0);
      ram_en_o : out    std_logic ;
      en_i     : in     std_logic ;
      reg_en_o : out    std_logic_vector (63 downto 0)
   );
   end component;
   component enable8
   port (
      en0 : in     std_logic ;
      in0 : in     std_logic ;
      o0  : out    std_logic ;
      en1 : in     std_logic ;
      in1 : in     std_logic ;
      o1  : out    std_logic ;
      en2 : in     std_logic ;
      in2 : in     std_logic ;
      o2  : out    std_logic ;
      en3 : in     std_logic ;
      in3 : in     std_logic ;
      o3  : out    std_logic ;
      en4 : in     std_logic ;
      in4 : in     std_logic ;
      o4  : out    std_logic ;
      en5 : in     std_logic ;
      in5 : in     std_logic ;
      o5  : out    std_logic ;
      en6 : in     std_logic ;
      in6 : in     std_logic ;
      o6  : out    std_logic ;
      en7 : in     std_logic ;
      in7 : in     std_logic ;
      o7  : out    std_logic 
   );
   end component;
   component m_and2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_buff
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;
   component m_or2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_or4
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      I3 : in     std_logic ;
      I4 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_power
   port (
      ONE  : out    std_logic ;
      ZERO : out    std_logic 
   );
   end component;
   component ram_tribus
   port (
      addr   : in     std_logic_vector (9 downto 0);
      clk    : in     std_logic ;
      enable : in     std_logic ;
      read   : in     std_logic ;
      write  : in     std_logic ;
      db     : inout  std_logic_vector (31 downto 0)
   );
   end component;
   component register32
   generic (
      RESET_VAL : integer := 0
   );
   port (
      clk   : in     std_logic ;
      en_i  : in     std_logic ;
      rd_i  : in     std_logic ;
      rst   : in     std_logic ;
      wr_i  : in     std_logic ;
      reg_o : out    std_logic_vector (31 downto 0);
      db_io : inout  std_logic_vector (31 downto 0)
   );
   end component;
   component simpsync
   port (
      async : in     std_logic ;
      clk   : in     std_logic ;
      sync  : out    std_logic 
   );
   end component;
   component state_clr_reg32
   port (
      en_i    : in     std_logic ;
      rd_i    : in     std_logic ;
      set_i   : in     std_logic_vector (31 downto 0);
      db_io   : inout  std_logic_vector (31 downto 0);
      wr_i    : in     std_logic ;
      rst     : in     std_logic ;
      clk     : in     std_logic ;
      state_o : out    std_logic_vector (31 downto 0)
   );
   end component;
   component statreg32
   port (
      en_i   : in     std_logic ;
      rd_i   : in     std_logic ;
      stat_i : in     std_logic_vector (31 downto 0);
      db_oz  : out    std_logic_vector (31 downto 0)
   );
   end component;
   component stretch_trig
   generic (
      LEN : integer := 10
   );
   port (
      i   : in     std_logic ;
      clk : in     std_logic ;
      rst : in     std_logic ;
      o   : out    std_logic 
   );
   end component;
   component timestamp
   port (
      epoc_secs : out    std_logic_vector (31 downto 0)
   );
   end component;
   component trig_count_reg
   port (
      clk     : in     std_logic ;
      rd_i    : in     std_logic ;
      rst     : in     std_logic ;
      rw_en_i : in     std_logic ;
      sig     : in     std_logic ;
      wr_i    : in     std_logic ;
      db_oz   : out    std_logic_vector (31 downto 0)
   );
   end component;
   component trig_fifo
   port (
      busy_trig    : in     std_logic ;
      clk          : in     std_logic ;
      fifo_din     : in     std_logic_vector (31 downto 0);
      fifo_read_en : in     std_logic ;
      fifo_stat_en : in     std_logic ;
      rd_i         : in     std_logic ;
      rst          : in     std_logic ;
      db_oz        : out    std_logic_vector (31 downto 0)
   );
   end component;
   component trigger_osc
   port (
      clk         : in     std_logic ;
      rst         : in     std_logic ;
      count_max_i : in     std_logic_vector (31 downto 0);
      trig_osc_o  : out    std_logic 
   );
   end component;
   component version_id
   generic (
      FIRMWARE_VER : integer := 16#0000#
   );
   port (
      en_i  : in     std_logic ;
      rd_i  : in     std_logic ;
      db_oz : out    std_logic_vector (31 downto 0)
   );
   end component;
   component z_seven
   port (
      z7 : out    std_logic_vector (6 downto 0)
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : BUFG use entity unisim.BUFG;
   for all : addr_decoder64 use entity CERC_lib.addr_decoder64;
   for all : enable8 use entity CERC_lib.enable8;
   for all : m_and2 use entity CERC_lib.m_and2;
   for all : m_buff use entity CERC_lib.m_buff;
   for all : m_or2 use entity CERC_lib.m_or2;
   for all : m_or4 use entity CERC_lib.m_or4;
   for all : m_power use entity CERC_lib.m_power;
   for all : ram_tribus use entity CERC_lib.ram_tribus;
   for all : register32 use entity CERC_lib.register32;
   for all : simpsync use entity CERC_lib.simpsync;
   for all : state_clr_reg32 use entity CERC_lib.state_clr_reg32;
   for all : statreg32 use entity CERC_lib.statreg32;
   for all : stretch_trig use entity CERC_lib.stretch_trig;
   for all : timestamp use entity Timestamp.timestamp;
   for all : trig_count_reg use entity CERC_lib.trig_count_reg;
   for all : trig_fifo use entity CERC_be_fpga.trig_fifo;
   for all : trigger_osc use entity CERC_be_fpga.trigger_osc;
   for all : version_id use entity CERC_lib.version_id;
   for all : z_seven use entity CERC_lib.z_seven;
   -- pragma synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 3 reg_trig_ctrl_map
   -- reg_trig_ctrl_map
   trig_ctrl_set(0) <= trig_raw;
   
   trig_ctrl_set(31 downto 1) <= (others => '0');
   
   busy_trig <= reg_trig_ctrl(0);

   -- HDL Embedded Text Block 4 reg_in_en_map
   --reg_in_en_map
   trig_ext0_en <= reg_input_en(0);
   trig_ext1_en <= reg_input_en(1);
   
   trig_osc_en <= reg_input_en(24);

   -- HDL Embedded Text Block 5 reg_in_stat_map
   -- trig_status_map
   reg_input_stat(0) <= trig_ext0_i;
   reg_input_stat(1) <= trig_ext1_i;
   
   reg_input_stat(7 downto 2) <= (others => '0');
   
   reg_input_stat(8) <= trig_ext0;
   reg_input_stat(9) <= trig_ext1;
   
   reg_input_stat(15 downto 10) <= (others => '0');
   
   reg_input_stat(16) <= trig_raw;
   reg_input_stat(17) <= trigger;
   
   reg_input_stat(23 downto 18) <= (others => '0');
                                                   
   reg_input_stat(24) <= trig_osc;
   
   reg_input_stat(31 downto 25) <= (others => '0');

   -- HDL Embedded Text Block 6 reg_out_en_map
   -- reg_in_en_map
   trig_fe0_en <= reg_output_en(0);
   trig_fe1_en <= reg_output_en(1);
   trig_fe2_en <= reg_output_en(2);
   trig_fe3_en <= reg_output_en(3);
   trig_fe4_en <= reg_output_en(4);
   trig_fe5_en <= reg_output_en(5);
   trig_fe6_en <= reg_output_en(6);
   trig_fe7_en <= reg_output_en(7);

   -- Instance port mappings.
   bufg_1 : BUFG
      generic map (
         TimingChecksOn => TRUE,
         InstancePath   => "*",
         Xon            => True,
         MsgOn          => False,
         tpd_I_O        => (0.100 ns, 0.100 ns),
         tipd_I         => (0.000 ns, 0.000 ns)
      )
      port map (
         O => trig_all_bufg,
         I => trig_in_all
      );
   addr_decoder64_1 : addr_decoder64
      port map (
         rst      => rst,
         clk      => clk,
         addr_i   => addr,
         ram_en_o => ram_en,
         en_i     => ONE,
         reg_en_o => reg_en
      );
   enable8_1 : enable8
      port map (
         en0 => trig_fe0_en,
         in0 => trigger,
         o0  => trig_fe0_o,
         en1 => trig_fe1_en,
         in1 => trigger,
         o1  => trig_fe1_o,
         en2 => trig_fe2_en,
         in2 => trigger,
         o2  => trig_fe2_o,
         en3 => trig_fe3_en,
         in3 => trigger,
         o3  => trig_fe3_o,
         en4 => trig_fe4_en,
         in4 => trigger,
         o4  => trig_fe4_o,
         en5 => trig_fe5_en,
         in5 => trigger,
         o5  => trig_fe5_o,
         en6 => trig_fe6_en,
         in6 => trigger,
         o6  => trig_fe6_o,
         en7 => trig_fe7_en,
         in7 => trigger,
         o7  => trig_fe7_o
      );
   m_and2_4 : m_and2
      port map (
         I1 => trig_ext0_i,
         I2 => trig_ext0_en,
         O  => trig_ext0
      );
   m_and2_3 : m_and2
      port map (
         I1 => trig_osc_int,
         I2 => trig_osc_en,
         O  => trig_osc
      );
   m_and2_2 : m_and2
      port map (
         I1 => trig_ext1_i,
         I2 => trig_ext1_en,
         O  => trig_ext1
      );
   m_and2_1 : m_and2
      port map (
         I1 => db_wr,
         I2 => reg_en(6),
         O  => rst_trig_osc
      );
   m_buff_4 : m_buff
      port map (
         I => trig_in_all,
         O => trig_in_all_o
      );
   m_buff_3 : m_buff
      port map (
         I => trig_raw,
         O => trig_raw_o
      );
   m_buff_2 : m_buff
      port map (
         I => rst,
         O => rst_fe_o
      );
   m_buff_1 : m_buff
      port map (
         I => trigger,
         O => trigger_o
      );
   m_or2_2 : m_or2
      port map (
         I1 => trig_raw,
         I2 => busy_trig,
         O  => trigger
      );
   m_or4_1 : m_or4
      port map (
         I1 => trig_ext0,
         I2 => trig_ext1,
         I3 => trig_osc,
         I4 => trig_ser_i,
         O  => trig_in_all
      );
   m_power_1 : m_power
      port map (
         ONE  => ONE,
         ZERO => ZERO
      );
   ram_tribus_1 : ram_tribus
      port map (
         addr   => addr(11 DOWNTO 2),
         clk    => clk,
         enable => ram_en,
         read   => db_rd,
         write  => db_wr,
         db     => db
      );
   reg_osc_period : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => reg_en(6),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_trig_osc,
         db_io => db
      );
   reg_out_en : register32
      generic map (
         RESET_VAL => 16#FF#
      )
      port map (
         clk   => clk,
         en_i  => reg_en(4),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_output_en,
         db_io => db
      );
   reg_in_en : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => reg_en(1),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_input_en,
         db_io => db
      );
   simpsync_2 : simpsync
      port map (
         async => trig_raw,
         clk   => clk,
         sync  => trig_raw_sync
      );
   simpsync_1 : simpsync
      port map (
         async => trigger,
         clk   => clk,
         sync  => trig_sync
      );
   reg_catch : state_clr_reg32
      port map (
         en_i    => reg_en(3),
         rd_i    => db_rd,
         set_i   => reg_input_stat,
         db_io   => db,
         wr_i    => db_wr,
         rst     => rst,
         clk     => clk,
         state_o => open
      );
   reg_control : state_clr_reg32
      port map (
         en_i    => reg_en(0),
         rd_i    => db_rd,
         set_i   => trig_ctrl_set,
         db_io   => db,
         wr_i    => db_wr,
         rst     => rst,
         clk     => clk,
         state_o => reg_trig_ctrl
      );
   reg_status1 : statreg32
      port map (
         en_i   => reg_en(10),
         rd_i   => db_rd,
         stat_i => epoc_secs,
         db_oz  => db
      );
   reg_status : statreg32
      port map (
         en_i   => reg_en(2),
         rd_i   => db_rd,
         stat_i => reg_input_stat,
         db_oz  => db
      );
   stretch_trig_1 : stretch_trig
      generic map (
         LEN => 4
      )
      port map (
         i   => trig_all_bufg,
         clk => clk,
         rst => rst,
         o   => trig_raw
      );
   I1 : timestamp
      port map (
         epoc_secs => epoc_secs
      );
   reg_trig_count2 : trig_count_reg
      port map (
         clk     => clk,
         rd_i    => db_rd,
         rst     => rst,
         rw_en_i => reg_en(8),
         sig     => trig_raw_sync,
         wr_i    => db_wr,
         db_oz   => db
      );
   reg_trig_count : trig_count_reg
      port map (
         clk     => clk,
         rd_i    => db_rd,
         rst     => rst,
         rw_en_i => reg_en(5),
         sig     => trig_sync,
         wr_i    => db_wr,
         db_oz   => db
      );
   trig_fifo_1 : trig_fifo
      port map (
         busy_trig    => busy_trig,
         clk          => clk,
         fifo_din     => reg_input_stat,
         fifo_read_en => fifo_rd,
         fifo_stat_en => fifo_stat_rd,
         rd_i         => ONE,
         rst          => rst,
         db_oz        => db
      );
   trigger_osc_1 : trigger_osc
      port map (
         clk         => clk,
         rst         => rst_trig_osc,
         count_max_i => reg_trig_osc,
         trig_osc_o  => trig_osc_int
      );
   I0 : version_id
      generic map (
         FIRMWARE_VER => FIRMWARE_VER
      )
      port map (
         en_i  => reg_en(9),
         rd_i  => db_rd,
         db_oz => db
      );
   I7 : z_seven
      port map (
         z7 => fe0_dataio
      );
   I8 : z_seven
      port map (
         z7 => fe1_dataio
      );
   I9 : z_seven
      port map (
         z7 => fe2_dataio
      );
   I10 : z_seven
      port map (
         z7 => fe3_dataio
      );
   I12 : z_seven
      port map (
         z7 => fe7_dataio
      );
   I13 : z_seven
      port map (
         z7 => fe6_dataio
      );
   I14 : z_seven
      port map (
         z7 => fe5_dataio
      );
   I15 : z_seven
      port map (
         z7 => fe4_dataio
      );

end struct;
