-- hds header_start
--
-- VHDL Entity CERC_be_fpga.be_trig_top.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 18:15:02 09/27/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity be_trig_top is
   generic( 
      FIRMWARE_VER : integer := 0
   );
   port( 
      clk_in              : in     std_logic;
      rst_in              : in     std_logic;
      trig_ext0_i         : in     std_logic;
      trig_ext1_i         : in     std_logic;
      trig_ser_config_in  : in     std_logic;
      qdr_addr_19_o       : out    std_logic;
      qdr_addr_20_o       : out    std_logic;
      trig_fe_o           : out    std_logic_vector (7 downto 0);
      trig_in_o           : out    std_logic;
      trig_ser_config_out : out    std_logic;
      trigger_o           : out    std_logic
   );

-- Declarations

end be_trig_top ;


-- hds interface_end

--
-- VHDL Architecture CERC_be_fpga.be_trig_top.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 18:15:03 09/27/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use IEEE.VITAL_Timing.ALL;

library CERC_be_fpga;
library CERC_lib;
library Timestamp;
library unisim;

architecture struct of be_trig_top is

   -- Architecture declarations

   -- Internal signal declarations
   signal ONE            : std_logic;
   signal ZERO           : std_logic;
   signal addr           : std_logic_vector(15 downto 0);
   signal busy_trig      : std_logic;
   signal busy_trig_n    : std_logic;
   signal clk            : std_logic;
   signal db             : std_logic_vector(31 downto 0);
   signal db_rd          : std_logic;
   signal db_rd0         : std_logic;
   signal db_wr          : std_logic;
   signal epoc_secs      : std_logic_vector(31 downto 0);
   signal reg_cmd        : std_logic_vector(31 downto 0);
   signal reg_input_en   : std_logic_vector(31 downto 0);
   signal reg_input_stat : std_logic_vector(31 downto 0);
   signal reg_output_en  : std_logic_vector(31 downto 0);
   signal reg_qdr_test   : std_logic_vector(31 downto 0);
   signal reg_trig_osc   : std_logic_vector(31 downto 0);
   signal ren            : std_logic_vector(31 downto 0);
   signal rst            : std_logic;
   signal rst_cmd        : std_logic;
   signal rst_trig_osc   : std_logic;
   signal trig_all_bufg  : STD_LOGIC;
   signal trig_cmd       : std_logic;
   signal trig_ext0      : std_logic;
   signal trig_ext0_en   : std_logic;
   signal trig_ext1      : std_logic;
   signal trig_ext1_en   : std_logic;
   signal trig_fe_en     : std_logic_vector(7 downto 0);
   signal trig_in        : std_logic;
   signal trig_in_sync   : std_logic;
   signal trig_osc       : std_logic;
   signal trig_osc_en    : std_logic;
   signal trig_osc_int   : std_logic;
   signal trig_sync      : std_logic;
   signal trigger        : std_logic;


   -- Component Declarations
   component BUFG
   generic (
      TimingChecksOn : Boolean          := TRUE;
      InstancePath   : STRING           := "*";
      Xon            : Boolean          := True;
      MsgOn          : Boolean          := False;
      tpd_I_O        : VitalDelayType01 := (0.100 ns, 0.100 ns);
      tipd_I         : VitalDelayType01 := (0.000 ns, 0.000 ns)
   );
   port (
      O : out    STD_ULOGIC ;
      I : in     STD_ULOGIC 
   );
   end component;
   component bt_addr_gen
   generic (
      RESET_VAL : integer := 0
   );
   port (
      clk      : in     std_logic ;
      en_i     : in     std_logic ;
      en_inc_i : in     std_logic ;
      rd_i     : in     std_logic ;
      rst      : in     std_logic ;
      wr_i     : in     std_logic ;
      addr_o   : out    std_logic_vector (15 downto 0);
      db_io    : inout  std_logic_vector (31 downto 0)
   );
   end component;
   component bt_ser_decoder
   port (
      clk      : in     std_logic ;
      rst      : in     std_logic ;
      ser_i    : in     std_logic ;
      ser_o    : out    std_logic ;
      db_rd0_o : out    std_logic ;
      db_rd_o  : out    std_logic ;
      db_wr_o  : out    std_logic ;
      ren_o    : out    std_logic_vector (31 downto 0);
      db_io    : inout  std_logic_vector (31 downto 0)
   );
   end component;
   component bt_trig_shape
   generic (
      LEN : integer := 10
   );
   port (
      rst            : in     std_logic ;
      clk            : in     std_logic ;
      trig_i         : in     std_logic ;
      trig_o         : out    std_logic ;
      busy_trig_o    : out    std_logic ;
      ren_busy_ctl_i : in     std_logic ;
      rd_i           : in     std_logic ;
      wr_i           : in     std_logic ;
      db_io          : inout  std_logic_vector (31 downto 0)
   );
   end component;
   component fan_en8
   port (
      i  : in     std_logic ;
      en : in     std_logic_vector (7 downto 0);
      o  : out    std_logic_vector (7 downto 0)
   );
   end component;
   component m_and2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_buff
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;
   component m_or2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_or4
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      I3 : in     std_logic ;
      I4 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_power
   port (
      ONE  : out    std_logic ;
      ZERO : out    std_logic 
   );
   end component;
   component ram_tribus
   port (
      addr   : in     std_logic_vector (9 downto 0);
      clk    : in     std_logic ;
      enable : in     std_logic ;
      read   : in     std_logic ;
      write  : in     std_logic ;
      db     : inout  std_logic_vector (31 downto 0)
   );
   end component;
   component register32
   generic (
      RESET_VAL : integer := 0
   );
   port (
      clk   : in     std_logic ;
      en_i  : in     std_logic ;
      rd_i  : in     std_logic ;
      rst   : in     std_logic ;
      wr_i  : in     std_logic ;
      reg_o : out    std_logic_vector (31 downto 0);
      db_io : inout  std_logic_vector (31 downto 0)
   );
   end component;
   component simpsync
   port (
      async : in     std_logic ;
      clk   : in     std_logic ;
      sync  : out    std_logic 
   );
   end component;
   component state_clr_reg32
   port (
      en_i    : in     std_logic ;
      rd_i    : in     std_logic ;
      set_i   : in     std_logic_vector (31 downto 0);
      db_io   : inout  std_logic_vector (31 downto 0);
      wr_i    : in     std_logic ;
      rst     : in     std_logic ;
      clk     : in     std_logic ;
      state_o : out    std_logic_vector (31 downto 0)
   );
   end component;
   component statreg32
   port (
      en_i   : in     std_logic ;
      rd_i   : in     std_logic ;
      stat_i : in     std_logic_vector (31 downto 0);
      db_oz  : out    std_logic_vector (31 downto 0)
   );
   end component;
   component timestamp
   port (
      epoc_secs : out    std_logic_vector (31 downto 0)
   );
   end component;
   component trig_count_reg
   port (
      clk     : in     std_logic ;
      rd_i    : in     std_logic ;
      rst     : in     std_logic ;
      rw_en_i : in     std_logic ;
      sig     : in     std_logic ;
      wr_i    : in     std_logic ;
      db_oz   : out    std_logic_vector (31 downto 0)
   );
   end component;
   component trig_fifo
   port (
      busy_trig    : in     std_logic ;
      clk          : in     std_logic ;
      fifo_din     : in     std_logic_vector (31 downto 0);
      fifo_read_en : in     std_logic ;
      fifo_stat_en : in     std_logic ;
      rd_i         : in     std_logic ;
      rst          : in     std_logic ;
      db_oz        : out    std_logic_vector (31 downto 0)
   );
   end component;
   component trigger_osc
   port (
      clk         : in     std_logic ;
      rst         : in     std_logic ;
      count_max_i : in     std_logic_vector (31 downto 0);
      trig_osc_o  : out    std_logic 
   );
   end component;
   component version_id
   generic (
      FIRMWARE_VER : integer := 16#0000#
   );
   port (
      en_i  : in     std_logic ;
      rd_i  : in     std_logic ;
      db_oz : out    std_logic_vector (31 downto 0)
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : BUFG use entity unisim.BUFG;
   for all : bt_addr_gen use entity CERC_be_fpga.bt_addr_gen;
   for all : bt_ser_decoder use entity CERC_be_fpga.bt_ser_decoder;
   for all : bt_trig_shape use entity CERC_be_fpga.bt_trig_shape;
   for all : fan_en8 use entity CERC_lib.fan_en8;
   for all : m_and2 use entity CERC_lib.m_and2;
   for all : m_buff use entity CERC_lib.m_buff;
   for all : m_or2 use entity CERC_lib.m_or2;
   for all : m_or4 use entity CERC_lib.m_or4;
   for all : m_power use entity CERC_lib.m_power;
   for all : ram_tribus use entity CERC_lib.ram_tribus;
   for all : register32 use entity CERC_lib.register32;
   for all : simpsync use entity CERC_lib.simpsync;
   for all : state_clr_reg32 use entity CERC_lib.state_clr_reg32;
   for all : statreg32 use entity CERC_lib.statreg32;
   for all : timestamp use entity Timestamp.timestamp;
   for all : trig_count_reg use entity CERC_lib.trig_count_reg;
   for all : trig_fifo use entity CERC_be_fpga.trig_fifo;
   for all : trigger_osc use entity CERC_be_fpga.trigger_osc;
   for all : version_id use entity CERC_lib.version_id;
   -- pragma synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 4 reg_in_en_map
   --reg_in_en_map
   trig_ext0_en <= reg_input_en(0);
   trig_ext1_en <= reg_input_en(1);
   
   trig_osc_en <= reg_input_en(24);

   -- HDL Embedded Text Block 5 reg_in_stat_map
   -- trig_status_map
   reg_input_stat(0) <= trig_ext0_i;
   reg_input_stat(1) <= trig_ext1_i;
   
   reg_input_stat(7 downto 2) <= (others => '0');
   
   reg_input_stat(8) <= trig_ext0;
   reg_input_stat(9) <= trig_ext1;
   
   reg_input_stat(15 downto 10) <= (others => '0');
   
   reg_input_stat(16) <= trig_in;
   reg_input_stat(17) <= trigger;
   
   reg_input_stat(23 downto 18) <= (others => '0');
                                                   
   reg_input_stat(24) <= trig_osc;
   
   reg_input_stat(31 downto 25) <= (others => '0');

   -- HDL Embedded Text Block 6 reg_out_en_map
   -- reg_in_en_map
   trig_fe_en <= reg_output_en(7 downto 0);

   -- Instance port mappings.
   bufg_1 : BUFG
      generic map (
         TimingChecksOn => TRUE,
         InstancePath   => "*",
         Xon            => True,
         MsgOn          => False,
         tpd_I_O        => (0.100 ns, 0.100 ns),
         tipd_I         => (0.000 ns, 0.000 ns)
      )
      port map (
         O => trig_all_bufg,
         I => trig_in
      );
   I6 : bt_addr_gen
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk      => clk,
         en_i     => ren(31),
         en_inc_i => ren(30),
         rd_i     => db_rd,
         rst      => rst,
         wr_i     => db_wr,
         addr_o   => addr,
         db_io    => db
      );
   bt_ser_decoder_1 : bt_ser_decoder
      port map (
         clk      => clk,
         rst      => rst,
         ser_i    => trig_ser_config_in,
         ser_o    => trig_ser_config_out,
         db_rd0_o => db_rd0,
         db_rd_o  => db_rd,
         db_wr_o  => db_wr,
         ren_o    => ren,
         db_io    => db
      );
   bt_trig_shape_1 : bt_trig_shape
      generic map (
         LEN => 10
      )
      port map (
         rst            => rst,
         clk            => clk,
         trig_i         => trig_all_bufg,
         trig_o         => trigger,
         busy_trig_o    => busy_trig,
         ren_busy_ctl_i => ren(11),
         rd_i           => db_rd,
         wr_i           => db_wr,
         db_io          => db
      );
   I3 : fan_en8
      port map (
         i  => trigger,
         en => trig_fe_en,
         o  => trig_fe_o
      );
   m_and2_1 : m_and2
      port map (
         I1 => db_wr,
         I2 => ren(6),
         O  => rst_trig_osc
      );
   m_and2_2 : m_and2
      port map (
         I1 => trig_ext1_i,
         I2 => trig_ext1_en,
         O  => trig_ext1
      );
   m_and2_3 : m_and2
      port map (
         I1 => trig_osc_int,
         I2 => trig_osc_en,
         O  => trig_osc
      );
   m_and2_4 : m_and2
      port map (
         I1 => trig_ext0_i,
         I2 => trig_ext0_en,
         O  => trig_ext0
      );
   m_buff_8 : m_buff
      port map (
         I => reg_qdr_test(0),
         O => qdr_addr_19_o
      );
   m_buff_1 : m_buff
      port map (
         I => trigger,
         O => trigger_o
      );
   m_buff_7 : m_buff
      port map (
         I => reg_qdr_test(1),
         O => qdr_addr_20_o
      );
   m_buff_6 : m_buff
      port map (
         I => reg_cmd(1),
         O => rst_cmd
      );
   m_buff_5 : m_buff
      port map (
         I => reg_cmd(0),
         O => trig_cmd
      );
   m_buff_9 : m_buff
      port map (
         I => clk_in,
         O => clk
      );
   m_buff_4 : m_buff
      port map (
         I => trig_in,
         O => trig_in_o
      );
   I5 : m_or2
      port map (
         I1 => rst_cmd,
         I2 => rst_in,
         O  => rst
      );
   m_or4_1 : m_or4
      port map (
         I1 => trig_cmd,
         I2 => trig_ext0,
         I3 => trig_ext1,
         I4 => trig_osc,
         O  => trig_in
      );
   m_power_1 : m_power
      port map (
         ONE  => ONE,
         ZERO => ZERO
      );
   ram_tribus_1 : ram_tribus
      port map (
         addr   => addr(11 DOWNTO 2),
         clk    => clk,
         enable => ren(30),
         read   => db_rd,
         write  => db_wr,
         db     => db
      );
   register32_1 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => ren(1),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_input_en,
         db_io => db
      );
   register32_2 : register32
      generic map (
         RESET_VAL => 16#FF#
      )
      port map (
         clk   => clk,
         en_i  => ren(4),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_output_en,
         db_io => db
      );
   register32_3 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => ren(6),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_trig_osc,
         db_io => db
      );
   register32_5 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => ren(15),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_qdr_test,
         db_io => db
      );
   register32_4 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => ren(12),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_cmd,
         db_io => db
      );
   simpsync_1 : simpsync
      port map (
         async => trigger,
         clk   => clk,
         sync  => trig_sync
      );
   simpsync_2 : simpsync
      port map (
         async => trig_in,
         clk   => clk,
         sync  => trig_in_sync
      );
   state_clr_reg32_1 : state_clr_reg32
      port map (
         en_i    => ren(3),
         rd_i    => db_rd,
         set_i   => reg_input_stat,
         db_io   => db,
         wr_i    => db_wr,
         rst     => rst,
         clk     => clk,
         state_o => open
      );
   statreg32_1 : statreg32
      port map (
         en_i   => ren(2),
         rd_i   => db_rd,
         stat_i => reg_input_stat,
         db_oz  => db
      );
   statreg32_2 : statreg32
      port map (
         en_i   => ren(10),
         rd_i   => db_rd,
         stat_i => epoc_secs,
         db_oz  => db
      );
   I1 : timestamp
      port map (
         epoc_secs => epoc_secs
      );
   trig_count_reg_2 : trig_count_reg
      port map (
         clk     => clk,
         rd_i    => db_rd,
         rst     => rst,
         rw_en_i => ren(8),
         sig     => trig_in_sync,
         wr_i    => db_wr,
         db_oz   => db
      );
   trig_count_reg_1 : trig_count_reg
      port map (
         clk     => clk,
         rd_i    => db_rd,
         rst     => rst,
         rw_en_i => ren(5),
         sig     => trig_sync,
         wr_i    => db_wr,
         db_oz   => db
      );
   trig_fifo_1 : trig_fifo
      port map (
         busy_trig    => busy_trig,
         clk          => clk,
         fifo_din     => reg_input_stat,
         fifo_read_en => ren(13),
         fifo_stat_en => ren(14),
         rd_i         => db_rd0,
         rst          => rst,
         db_oz        => db
      );
   trigger_osc_1 : trigger_osc
      port map (
         clk         => clk,
         rst         => rst_trig_osc,
         count_max_i => reg_trig_osc,
         trig_osc_o  => trig_osc_int
      );
   version_id_1 : version_id
      generic map (
         FIRMWARE_VER => FIRMWARE_VER
      )
      port map (
         en_i  => ren(9),
         rd_i  => db_rd,
         db_oz => db
      );

end struct;
