// renoir header_start
//
// Module chan_quad.command_decoder.behavioral
//
// Created:
//          by - wjfg72.UNKNOWN (TE2MANAGUA)
//          at - 11:55:52 25/06/01
//
// Generated by Mentor Graphics' Renoir(TM) 2000.3 (Build 2)
//
// renoir header_end

`resetall
`timescale 1ns/1ps

//these are designator values in decimal
`define regrw01_des		1
`define regrw02_des		2
`define regrw03_des		3
`define regrw04_des		4
`define regrw05_des		5
`define regrw06_des		6
`define regrw07_des		7
`define regrw08_des		8
`define regrw09_des		9
`define regrw10_des		10
`define regrw11_des		11
`define regrw12_des		12
`define regrw13_des		13
`define regrw14_des		14
`define regrw15_des		15

`define regro16_des		16
`define regro17_des		17
`define regro18_des		18
`define regro19_des		19
`define regro20_des		20
`define regro21_des		21
`define regro22_des		22
`define regro23_des		23
`define regro24_des		24
`define regro25_des		25
`define regro26_des		26
`define regro27_des		27
`define regro28_des		28
`define regro29_des		29
`define regro30_des		30
`define regro31_des		31


module be_vme_cmd_decoder(
		clk,
		rst,
		command_in,
		command_out,

		data_valid

	);


parameter DESIGNATOR = 5; 		// Number of bits in Command Designator
parameter LENGTH_FIELD = 16; 	// Number of bits in Command Length
// parameter RESET_LENGTH = 16; // Number of zeros that constitute a reset

// Internal Declarations

input clk, rst, command_in;

output command_out;
output data_valid;

// a process
reg [LENGTH_FIELD-1:0] length;
reg r_wB;
reg [DESIGNATOR-1:0] designator;
reg [1:0] state;
reg data_valid;
reg command_out, command_real;


always @(posedge clk or posedge rst)
begin
	if (rst)
		begin
		state <= #1 0;
		r_wB <= #1 0;
		length <= #1 0;
		designator <= #1 0;
		data_valid <= #1 0;
		end
	else
	begin
		case (state)
		0:
		begin
		// Shift in the command stream until a Designator is recognised
		r_wB <= #1 designator[DESIGNATOR-1];						 // assign bit 4
		designator <= #1 {designator[DESIGNATOR-2:0], command_in};   // assign bits 3 : 0  ie the designator
		data_valid <= #1 0;
		if (r_wB)		    // upon detection of first '1' go into state 1
			begin
			state <= #1 1;
			end
		end
		1:
		begin
			length <= #1 {length[LENGTH_FIELD-2:0], command_in};	   // length indicates the no. of data bits to follow
			data_valid <= #1 0;
			if (length[LENGTH_FIELD-1])	   // find the first '1'
				begin
				state <= #1 2;
				end
		end
		2:								   // stay in state 2 for the length number of clock cycles
		begin							   // which equals the number of data bits to follow
			length <= #1 length - 1;
			data_valid <= #1 0;
			if (length == 1)
			begin
				if (r_wB)				   // if read cycle then reset everything
					begin
					state <= #1 0;
					designator <= #1 0;
					r_wB <= #1 0;
					end
				else					   // if write cycle then assert data valid
					begin
					state <= #1 3;
					designator <= #1 0;
					r_wB <= #1 0;
					end
			end
		end
		3:
		begin
			data_valid <= #1 1;   // assign a 1 to data valid
			state <= #1 0;
		end
		endcase
	end
end
// end of process



// these are strobe signals for loading the registers
reg regrw01_load;
reg regrw02_load;
reg regrw03_load;
reg regrw04_load;
reg regrw05_load;
reg regrw06_load;
reg regrw07_load;
reg regrw08_load;
reg regrw09_load;
reg regrw10_load;
reg regrw11_load;
reg regrw12_load;
reg regrw13_load;
reg regrw14_load;
reg regrw15_load;

reg regro16_load;
reg regro17_load;
reg regro18_load;
reg regro19_load;
reg regro20_load;
reg regro21_load;
reg regro22_load;
reg regro23_load;
reg regro24_load;
reg regro25_load;
reg regro26_load;
reg regro27_load;
reg regro28_load;
reg regro29_load;
reg regro30_load;
reg regro31_load;

reg regro16_load2;
reg regro17_load2;
reg regro18_load2;
reg regro19_load2;
reg regro20_load2;
reg regro21_load2;
reg regro22_load2;
reg regro23_load2;
reg regro24_load2;
reg regro25_load2;
reg regro26_load2;
reg regro27_load2;
reg regro28_load2;
reg regro29_load2;
reg regro30_load2;
reg regro31_load2;



// this process generates the relevant load strobe
always @(posedge clk or posedge rst)
begin
	if (rst)
		begin
		regrw01_load <= #1 0;
		regrw02_load <= #1 0;
		regrw03_load <= #1 0;
		regrw04_load <= #1 0;
		regrw05_load <= #1 0;
		regrw06_load <= #1 0;
		regrw07_load <= #1 0;
		regrw08_load <= #1 0;
		regrw09_load <= #1 0;
		regrw10_load <= #1 0;
		regrw11_load <= #1 0;
		regrw12_load <= #1 0;
		regrw13_load <= #1 0;
		regrw14_load <= #1 0;
		regrw15_load <= #1 0;

		regro16_load <= #1 0;
		regro17_load <= #1 0;
		regro18_load <= #1 0;
		regro19_load <= #1 0;
		regro20_load <= #1 0;
		regro21_load <= #1 0;
		regro22_load <= #1 0;
		regro23_load <= #1 0;
		regro24_load <= #1 0;
		regro25_load <= #1 0;
		regro26_load <= #1 0;
		regro27_load <= #1 0;
		regro28_load <= #1 0;
		regro29_load <= #1 0;
		regro30_load <= #1 0;
		regro31_load <= #1 0;

		regro16_load2 <= #1 0;
		regro17_load2 <= #1 0;
		regro18_load2 <= #1 0;
		regro19_load2 <= #1 0;
		regro20_load2 <= #1 0;
		regro21_load2 <= #1 0;
		regro22_load2 <= #1 0;
		regro23_load2 <= #1 0;
		regro24_load2 <= #1 0;
		regro25_load2 <= #1 0;
		regro26_load2 <= #1 0;
		regro27_load2 <= #1 0;
		regro28_load2 <= #1 0;
		regro29_load2 <= #1 0;
		regro30_load2 <= #1 0;
		regro31_load2 <= #1 0;

		end
	else
		begin
		regrw01_load <= #1 (state == 2) & (designator == `regrw01_des);
		regrw02_load <= #1 (state == 2) & (designator == `regrw02_des);
		regrw03_load <= #1 (state == 2) & (designator == `regrw03_des);
		regrw04_load <= #1 (state == 2) & (designator == `regrw04_des);
		regrw05_load <= #1 (state == 2) & (designator == `regrw05_des);
		regrw06_load <= #1 (state == 2) & (designator == `regrw06_des);
		regrw07_load <= #1 (state == 2) & (designator == `regrw07_des);
		regrw08_load <= #1 (state == 2) & (designator == `regrw08_des);
		regrw09_load <= #1 (state == 2) & (designator == `regrw09_des);
		regrw10_load <= #1 (state == 2) & (designator == `regrw10_des);
		regrw11_load <= #1 (state == 2) & (designator == `regrw11_des);
		regrw12_load <= #1 (state == 2) & (designator == `regrw12_des);
		regrw13_load <= #1 (state == 2) & (designator == `regrw13_des);
		regrw14_load <= #1 (state == 2) & (designator == `regrw14_des);
		regrw15_load <= #1 (state == 2) & (designator == `regrw15_des);

		regro16_load <= #1 (state == 2) & (designator == `regro16_des);
		regro17_load <= #1 (state == 2) & (designator == `regro17_des);
		regro18_load <= #1 (state == 2) & (designator == `regro18_des);
		regro19_load <= #1 (state == 2) & (designator == `regro19_des);
		regro20_load <= #1 (state == 2) & (designator == `regro20_des);
		regro21_load <= #1 (state == 2) & (designator == `regro21_des);
		regro22_load <= #1 (state == 2) & (designator == `regro22_des);
		regro23_load <= #1 (state == 2) & (designator == `regro23_des);
		regro24_load <= #1 (state == 2) & (designator == `regro24_des);
		regro25_load <= #1 (state == 2) & (designator == `regro25_des);
		regro26_load <= #1 (state == 2) & (designator == `regro26_des);
		regro27_load <= #1 (state == 2) & (designator == `regro27_des);
		regro28_load <= #1 (state == 2) & (designator == `regro28_des);
		regro29_load <= #1 (state == 2) & (designator == `regro29_des);
		regro30_load <= #1 (state == 2) & (designator == `regro30_des);
		regro31_load <= #1 (state == 2) & (designator == `regro31_des);

		regro16_load2 <= #1 regro16_load;
		regro17_load2 <= #1 regro17_load;
		regro18_load2 <= #1 regro18_load;
		regro19_load2 <= #1 regro19_load;
		regro20_load2 <= #1 regro20_load;
		regro21_load2 <= #1 regro21_load;
		regro22_load2 <= #1 regro22_load;
		regro23_load2 <= #1 regro23_load;
		regro24_load2 <= #1 regro24_load;
		regro25_load2 <= #1 regro25_load;
		regro26_load2 <= #1 regro26_load;
		regro27_load2 <= #1 regro27_load;
		regro28_load2 <= #1 regro28_load;
		regro29_load2 <= #1 regro29_load;
		regro30_load2 <= #1 regro30_load;
		regro31_load2 <= #1 regro31_load;

		end
end
//end of process


// new process which clocks data in and out of the registers
// define output registers here
reg [31:0] regrw01;
reg [31:0] regrw02;
reg [31:0] regrw03;
reg [31:0] regrw04;
reg [31:0] regrw05;
reg [31:0] regrw06;
reg [31:0] regrw07;
reg [31:0] regrw08;
reg [31:0] regrw09;
reg [31:0] regrw10;
reg [31:0] regrw11;
reg [31:0] regrw12;
reg [31:0] regrw13;
reg [31:0] regrw14;
reg [31:0] regrw15;

reg [31:0] regro16;
reg [31:0] regro17;
reg [31:0] regro18;
reg [31:0] regro19;
reg [31:0] regro20;
reg [31:0] regro21;
reg [31:0] regro22;
reg [31:0] regro23;
reg [31:0] regro24;
reg [31:0] regro25;
reg [31:0] regro26;
reg [31:0] regro27;
reg [31:0] regro28;
reg [31:0] regro29;
reg [31:0] regro30;
reg [31:0] regro31;

reg [31:0] regro16_sr;
reg [31:0] regro17_sr;
reg [31:0] regro18_sr;
reg [31:0] regro19_sr;
reg [31:0] regro20_sr;
reg [31:0] regro21_sr;
reg [31:0] regro22_sr;
reg [31:0] regro23_sr;
reg [31:0] regro24_sr;
reg [31:0] regro25_sr;
reg [31:0] regro26_sr;
reg [31:0] regro27_sr;
reg [31:0] regro28_sr;
reg [31:0] regro29_sr;
reg [31:0] regro30_sr;
reg [31:0] regro31_sr;


always @(posedge clk or posedge rst)
begin
	if (rst)
	begin
		regrw01 <= #1 0;
		regrw02 <= #1 0;
		regrw03 <= #1 0;
		regrw04 <= #1 0;
		regrw05 <= #1 0;
		regrw06 <= #1 0;
		regrw07 <= #1 0;
		regrw08 <= #1 0;
		regrw09 <= #1 0;
		regrw10 <= #1 0;
		regrw11 <= #1 0;
		regrw12 <= #1 0;
		regrw13 <= #1 0;
		regrw14 <= #1 0;
		regrw15 <= #1 0;

		regro16 <= #1 0;
		regro17 <= #1 0;
		regro18 <= #1 0;
		regro19 <= #1 0;
		regro20 <= #1 0;
		regro21 <= #1 0;
		regro22 <= #1 0;
		regro23 <= #1 0;
		regro24 <= #1 0;
		regro25 <= #1 0;
		regro26 <= #1 0;
		regro27 <= #1 0;
		regro28 <= #1 0;
		regro29 <= #1 0;
		regro30 <= #1 0;
		regro31 <= #1 0;
		
		regro16_sr <= #1 0;
		regro17_sr <= #1 0;
		regro18_sr <= #1 0;
		regro19_sr <= #1 0;
		regro20_sr <= #1 0;
		regro21_sr <= #1 0;
		regro22_sr <= #1 0;
		regro23_sr <= #1 0;
		regro24_sr <= #1 0;
		regro25_sr <= #1 0;
		regro26_sr <= #1 0;
		regro27_sr <= #1 0;
		regro28_sr <= #1 0;
		regro29_sr <= #1 0;
		regro30_sr <= #1 0;
		regro31_sr <= #1 0;
		
		end
	else
	begin
		if (regrw01_load)	begin	regrw01 <= #1 {regrw01[30:0], command_real};	end
		if (regrw02_load)	begin regrw02 <= #1 {regrw02[30:0], command_real};	end
		if (regrw03_load) begin regrw03 <= #1 {regrw03[30:0], command_real}; end
		if (regrw04_load) begin regrw04 <= #1 {regrw04[30:0], command_real}; end
		if (regrw05_load) begin regrw05 <= #1 {regrw05[30:0], command_real}; end
		if (regrw06_load) begin regrw06 <= #1 {regrw06[30:0], command_real}; end
		if (regrw07_load) begin regrw07 <= #1 {regrw07[30:0], command_real}; end
		if (regrw08_load) begin regrw08 <= #1 {regrw08[30:0], command_real}; end
		if (regrw09_load) begin regrw09 <= #1 {regrw09[30:0], command_real}; end
		if (regrw10_load) begin regrw10 <= #1 {regrw10[30:0], command_real}; end
		if (regrw11_load) begin regrw11 <= #1 {regrw11[30:0], command_real}; end
		if (regrw12_load) begin regrw12 <= #1 {regrw12[30:0], command_real}; end
		if (regrw13_load) begin regrw13 <= #1 {regrw13[30:0], command_real}; end
		if (regrw14_load) begin regrw14 <= #1 {regrw14[30:0], command_real}; end
		if (regrw15_load)	begin	regrw15 <= #1 {regrw15[30:0], command_real};	end

		if (regro16_load & !regro16_load2) begin regro16_sr <= #1 16; end
		if (regro17_load & !regro17_load2) begin regro17_sr <= #1 17; end
		if (regro18_load & !regro18_load2) begin regro18_sr <= #1 18; end
		if (regro19_load & !regro19_load2) begin regro19_sr <= #1 19; end
		if (regro20_load & !regro20_load2) begin regro20_sr <= #1 20; end
		if (regro21_load & !regro21_load2) begin regro21_sr <= #1 21; end
		if (regro22_load & !regro22_load2) begin regro22_sr <= #1 22; end
		if (regro23_load & !regro23_load2) begin regro23_sr <= #1 23; end
		if (regro24_load & !regro24_load2) begin regro24_sr <= #1 24; end
		if (regro25_load & !regro25_load2) begin regro25_sr <= #1 25; end
		if (regro26_load & !regro26_load2) begin regro26_sr <= #1 26; end
		if (regro27_load & !regro27_load2) begin regro27_sr <= #1 27; end
		if (regro28_load & !regro28_load2) begin regro28_sr <= #1 28; end
		if (regro29_load & !regro29_load2) begin regro29_sr <= #1 29; end
		if (regro30_load & !regro30_load2) begin regro30_sr <= #1 30; end
		if (regro31_load & !regro31_load2) begin regro31_sr <= #1 31; end

		if (regro16_load2) begin regro16_sr <= #1 {regro16_sr[30:0], command_real}; end
		if (regro17_load2) begin regro17_sr <= #1 {regro17_sr[30:0], command_real}; end
		if (regro18_load2) begin regro18_sr <= #1 {regro18_sr[30:0], command_real}; end
		if (regro19_load2) begin regro19_sr <= #1 {regro19_sr[30:0], command_real}; end
		if (regro20_load2) begin regro20_sr <= #1 {regro20_sr[30:0], command_real}; end
		if (regro21_load2) begin regro21_sr <= #1 {regro21_sr[30:0], command_real}; end
		if (regro22_load2) begin regro22_sr <= #1 {regro22_sr[30:0], command_real}; end
		if (regro23_load2) begin regro23_sr <= #1 {regro23_sr[30:0], command_real}; end
		if (regro24_load2) begin regro24_sr <= #1 {regro24_sr[30:0], command_real}; end
		if (regro25_load2) begin regro25_sr <= #1 {regro25_sr[30:0], command_real}; end
		if (regro26_load2) begin regro26_sr <= #1 {regro26_sr[30:0], command_real}; end
		if (regro27_load2) begin regro27_sr <= #1 {regro27_sr[30:0], command_real}; end
		if (regro28_load2) begin regro28_sr <= #1 {regro28_sr[30:0], command_real}; end
		if (regro29_load2) begin regro29_sr <= #1 {regro29_sr[30:0], command_real}; end
		if (regro30_load2) begin regro30_sr <= #1 {regro30_sr[30:0], command_real}; end
		if (regro31_load2) begin regro31_sr <= #1 {regro31_sr[30:0], command_real}; end
	end
end


wire [0:31] command_word =
	{1'b0,
	regrw01[31],
	regrw02[31],
	regrw03[31],
	regrw04[31],
	regrw05[31],
	regrw06[31],
	regrw07[31],
	regrw08[31],
	regrw09[31],
	regrw10[31],
	regrw11[31],
	regrw12[31],
	regrw13[31],
	regrw14[31],
	regrw15[31],

	regro16[31],
	regro17[31],
	regro18[31],
	regro19[31],
	regro20[31],
	regro21[31],
	regro22[31],
	regro23[31],
	regro24[31],
	regro25[31],
	regro26[31],
	regro27[31],
	regro28[31],
	regro29[31],
	regro30[31],
	regro31[31]
	};



always @(posedge clk or posedge rst)
begin
	if (rst)
	begin
		command_out <= #1 0;
		command_real <= #1 0;
		end
	else
	begin
		command_out <= #1 (state == 2) & command_word[designator];		     // output the bit in command word which equals the designator
		command_real <= #1 (r_wB ? command_word[designator] : command_in);
		end
end


endmodule
