-- hds header_start
--
-- VHDL Architecture CALICE_lib.register32.untitled
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 11:33:54 11/30/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity bt_addr_gen is
   generic( 
      RESET_VAL : integer := 0
   );
   port( 
      clk      : in     std_logic;
      en_i     : in     std_logic;
      en_inc_i : in     std_logic;
      rd_i     : in     std_logic;
      rst      : in     std_logic;
      wr_i     : in     std_logic;
      addr_o   : out    std_logic_vector (15 downto 0);
      db_io    : inout  std_logic_vector (31 downto 0)
   );

-- Declarations

end bt_addr_gen ;


-- hds interface_end
architecture rtl of bt_addr_gen is
	
	signal reg 			: std_logic_vector(31 downto 0);
	signal reg_inc 	: std_logic;
	signal rd_or_wr 	: std_logic;

begin

	-- Write
	reg32_write : process (clk)
	begin
		if rising_edge(clk) then
			if (rst = '1') then
				reg 		 <= conv_std_logic_vector(RESET_VAL,32);
				reg_inc   <= '0';
				rd_or_wr  <= '0';
			
			else
				rd_or_wr  <= rd_i or wr_i;
				reg_inc   <= rd_or_wr and en_inc_i and reg(31) after 1 ns;

			
				if ((en_i and wr_i) = '1') then
					reg <= db_io after 1 ns;
					
				elsif (reg_inc = '1') then
					reg(15 downto 2) <= reg(15 downto 2) + '1' after 1 ns;
					
				end if;
			
			end if;
		end if;
	end process;
	
	
	-- Read
	db_io <= reg after 1 ns when ((en_i and rd_i) = '1') else (others => 'Z');
	
	addr_o <= ( reg(15 downto 2) & "00" );
	
	
end rtl;
