-- hds header_start
--
-- VHDL Entity CERC_trig.bt_main.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 10:47:23 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity bt_main is
   generic( 
      FIRMWARE_VER : integer := 0
   );
   port( 
      addr          : in     std_logic_vector (15 downto 0);
      clk           : in     std_logic;
      clk180        : in     std_logic;
      clk270        : in     std_logic;
      clk90         : in     std_logic;
      db_rd         : in     std_logic;
      db_rd0        : in     std_logic;
      db_wr         : in     std_logic;
      ren           : in     std_logic_vector (31 downto 0);
      rst           : in     std_logic;
      trig_ext0_i   : in     std_logic;
      trig_ext1_i   : in     std_logic;
      trig_ext2_i   : in     std_logic;
      trig_ext3_i   : in     std_logic;
      trigin_in     : in     std_logic;
      trigin_sw_i   : in     std_logic;
      busy_trig_o   : out    std_logic;
      qdr_addr_19_o : out    std_logic;
      qdr_addr_20_o : out    std_logic;
      rst_cmd       : out    std_logic;
      trig_fe_o     : out    std_logic_vector (7 downto 0);
      trig_sync_o   : out    std_logic;
      trigin_out    : out    std_logic;
      db            : inout  std_logic_vector (31 downto 0)
   );

-- Declarations

end bt_main ;


-- hds interface_end

--
-- VHDL Architecture CERC_trig.bt_main.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 10:47:24 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use IEEE.VITAL_Timing.ALL;
use ieee.numeric_std.ALL;
library unisim;
use unisim.vpkg.ALL;

library CERC_lib;
library CERC_trig;
library Timestamp;

architecture struct of bt_main is

   -- Architecture declarations

   -- Internal signal declarations
   signal ONE            : std_logic;
   signal ZERO           : std_logic;
   signal busy_trig      : std_logic;
   signal clr_busy       : std_logic;
   signal db0_n          : std_logic;
   signal epoc_secs      : std_logic_vector(31 downto 0);
   signal reg_cmd        : std_logic_vector(31 downto 0);
   signal reg_input_en   : std_logic_vector(31 downto 0);
   signal reg_input_stat : std_logic_vector(31 downto 0);
   signal reg_output_en  : std_logic_vector(31 downto 0);
   signal reg_qdr_test   : std_logic_vector(31 downto 0);
   signal reg_trig_ctl   : std_logic_vector(31 downto 0);
   signal reg_trig_osc   : std_logic_vector(31 downto 0);
   signal rgw_input_en   : std_logic;
   signal rst_trig_osc   : std_logic;
   signal trig_cmd       : std_logic;
   signal trig_fe_en     : std_logic_vector(7 downto 0);
   signal trig_osc       : std_logic;
   signal trig_sync      : std_logic;
   signal trigin_sync    : std_logic;


   -- Component Declarations
   component fe_trig_shape
   port (
      clk             : in     std_logic ;
      reg_output_en_i : in     std_logic_vector (31 downto 0);
      rst             : in     std_logic ;
      trigin_in       : in     std_logic ;
      trigin_sw_i     : in     std_logic ;
      fe_trig_o       : out    std_logic_vector (7 downto 0);
      trig_sync_o     : out    std_logic 
   );
   end component;
   component m_and2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_buff
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;
   component m_mininv
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;
   component m_or3
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      I3 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_power
   port (
      ONE  : out    std_logic ;
      ZERO : out    std_logic 
   );
   end component;
   component ram_tribus
   port (
      addr   : in     std_logic_vector (9 downto 0);
      clk    : in     std_logic ;
      enable : in     std_logic ;
      read   : in     std_logic ;
      write  : in     std_logic ;
      db     : inout  std_logic_vector (31 downto 0)
   );
   end component;
   component register32
   generic (
      RESET_VAL : integer := 0
   );
   port (
      clk   : in     std_logic ;
      en_i  : in     std_logic ;
      rd_i  : in     std_logic ;
      rst   : in     std_logic ;
      wr_i  : in     std_logic ;
      reg_o : out    std_logic_vector (31 downto 0);
      rgw_o : out    std_logic ;
      db_io : inout  std_logic_vector (31 downto 0)
   );
   end component;
   component state_clr_reg32
   port (
      en_i    : in     std_logic ;
      rd_i    : in     std_logic ;
      set_i   : in     std_logic_vector (31 downto 0);
      db_io   : inout  std_logic_vector (31 downto 0);
      wr_i    : in     std_logic ;
      rst     : in     std_logic ;
      clk     : in     std_logic ;
      state_o : out    std_logic_vector (31 downto 0)
   );
   end component;
   component statreg32
   port (
      en_i   : in     std_logic ;
      rd_i   : in     std_logic ;
      stat_i : in     std_logic_vector (31 downto 0);
      db_oz  : out    std_logic_vector (31 downto 0)
   );
   end component;
   component timestamp
   port (
      epoc_secs : out    std_logic_vector (31 downto 0)
   );
   end component;
   component trig_count_reg
   port (
      clk     : in     std_logic ;
      rd_i    : in     std_logic ;
      rst     : in     std_logic ;
      rw_en_i : in     std_logic ;
      sig     : in     std_logic ;
      wr_i    : in     std_logic ;
      db_oz   : out    std_logic_vector (31 downto 0)
   );
   end component;
   component trig_fifo
   port (
      busy_trig    : in     std_logic ;
      clk          : in     std_logic ;
      fifo_din     : in     std_logic_vector (31 downto 0);
      fifo_read_en : in     std_logic ;
      fifo_stat_en : in     std_logic ;
      rd_i         : in     std_logic ;
      rst          : in     std_logic ;
      db_oz        : out    std_logic_vector (31 downto 0)
   );
   end component;
   component trigger_osc
   port (
      clk         : in     std_logic ;
      rst         : in     std_logic ;
      count_max_i : in     std_logic_vector (31 downto 0);
      trig_osc_o  : out    std_logic 
   );
   end component;
   component trigin_control
   port (
      clk            : in     std_logic ;
      clr_busy_i     : in     std_logic ;
      reg_input_en   : in     std_logic_vector (31 downto 0);
      rst            : in     std_logic ;
      trig_cmd_i     : in     std_logic ;
      trig_ext0_i    : in     std_logic ;
      trig_ext1_i    : in     std_logic ;
      trig_ext2_i    : in     std_logic ;
      trig_ext3_i    : in     std_logic ;
      trig_osc_i     : in     std_logic ;
      reg_input_stat : out    std_logic_vector (31 downto 0);
      trigin_busy_o  : out    std_logic ;
      trigin_out     : out    std_logic ;
      trigin_sync_o  : out    std_logic 
   );
   end component;
   component version_id
   generic (
      FIRMWARE_VER : integer := 16#0000#
   );
   port (
      en_i  : in     std_logic ;
      rd_i  : in     std_logic ;
      db_oz : out    std_logic_vector (31 downto 0)
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : fe_trig_shape use entity CERC_trig.fe_trig_shape;
   for all : m_and2 use entity CERC_lib.m_and2;
   for all : m_buff use entity CERC_lib.m_buff;
   for all : m_mininv use entity CERC_lib.m_mininv;
   for all : m_or3 use entity CERC_lib.m_or3;
   for all : m_power use entity CERC_lib.m_power;
   for all : ram_tribus use entity CERC_lib.ram_tribus;
   for all : register32 use entity CERC_lib.register32;
   for all : state_clr_reg32 use entity CERC_lib.state_clr_reg32;
   for all : statreg32 use entity CERC_lib.statreg32;
   for all : timestamp use entity Timestamp.timestamp;
   for all : trig_count_reg use entity CERC_lib.trig_count_reg;
   for all : trig_fifo use entity CERC_trig.trig_fifo;
   for all : trigger_osc use entity CERC_trig.trigger_osc;
   for all : trigin_control use entity CERC_trig.trigin_control;
   for all : version_id use entity CERC_lib.version_id;
   -- pragma synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 6 reg_out_en_map
   -- reg_in_en_map
   trig_fe_en <= reg_output_en(7 downto 0);

   -- Instance port mappings.
   fe_trig_shape_1 : fe_trig_shape
      port map (
         clk             => clk,
         reg_output_en_i => reg_output_en,
         rst             => rst,
         trigin_in       => trigin_in,
         trigin_sw_i     => trigin_sw_i,
         fe_trig_o       => trig_fe_o,
         trig_sync_o     => trig_sync
      );
   m_and2_1 : m_and2
      port map (
         I1 => db_wr,
         I2 => ren(6),
         O  => rst_trig_osc
      );
   I4 : m_buff
      port map (
         I => busy_trig,
         O => busy_trig_o
      );
   I3 : m_buff
      port map (
         I => trig_sync,
         O => trig_sync_o
      );
   m_buff_9 : m_buff
      port map (
         I => busy_trig,
         O => reg_trig_ctl(0)
      );
   m_buff_8 : m_buff
      port map (
         I => reg_qdr_test(0),
         O => qdr_addr_19_o
      );
   m_buff_5 : m_buff
      port map (
         I => reg_cmd(0),
         O => trig_cmd
      );
   m_buff_6 : m_buff
      port map (
         I => reg_cmd(1),
         O => rst_cmd
      );
   m_buff_7 : m_buff
      port map (
         I => reg_qdr_test(1),
         O => qdr_addr_20_o
      );
   I2 : m_mininv
      port map (
         I => db(0),
         O => db0_n
      );
   I0 : m_or3
      port map (
         I1 => db_wr,
         I2 => ren(11),
         I3 => db0_n,
         O  => clr_busy
      );
   m_power_1 : m_power
      port map (
         ONE  => ONE,
         ZERO => ZERO
      );
   ram_tribus_1 : ram_tribus
      port map (
         addr   => addr(11 DOWNTO 2),
         clk    => clk,
         enable => ren(30),
         read   => db_rd,
         write  => db_wr,
         db     => db
      );
   register32_5 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => ren(15),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_qdr_test,
         rgw_o => open,
         db_io => db
      );
   register32_4 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => ren(12),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_cmd,
         rgw_o => open,
         db_io => db
      );
   register32_3 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => ren(6),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_trig_osc,
         rgw_o => open,
         db_io => db
      );
   register32_1 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => ren(1),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_input_en,
         rgw_o => rgw_input_en,
         db_io => db
      );
   register32_2 : register32
      generic map (
         RESET_VAL => 16#FF#
      )
      port map (
         clk   => clk,
         en_i  => ren(4),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_output_en,
         rgw_o => open,
         db_io => db
      );
   state_clr_reg32_1 : state_clr_reg32
      port map (
         en_i    => ren(3),
         rd_i    => db_rd,
         set_i   => reg_input_stat,
         db_io   => db,
         wr_i    => db_wr,
         rst     => rst,
         clk     => clk,
         state_o => open
      );
   statreg32_1 : statreg32
      port map (
         en_i   => ren(2),
         rd_i   => db_rd,
         stat_i => reg_input_stat,
         db_oz  => db
      );
   statreg32_3 : statreg32
      port map (
         en_i   => ren(11),
         rd_i   => db_rd,
         stat_i => reg_trig_ctl,
         db_oz  => db
      );
   statreg32_2 : statreg32
      port map (
         en_i   => ren(10),
         rd_i   => db_rd,
         stat_i => epoc_secs,
         db_oz  => db
      );
   I1 : timestamp
      port map (
         epoc_secs => epoc_secs
      );
   trig_count_reg_1 : trig_count_reg
      port map (
         clk     => clk,
         rd_i    => db_rd,
         rst     => rst,
         rw_en_i => ren(5),
         sig     => trig_sync,
         wr_i    => db_wr,
         db_oz   => db
      );
   trig_count_reg_2 : trig_count_reg
      port map (
         clk     => clk,
         rd_i    => db_rd,
         rst     => rst,
         rw_en_i => ren(8),
         sig     => trigin_sync,
         wr_i    => db_wr,
         db_oz   => db
      );
   trig_fifo_1 : trig_fifo
      port map (
         busy_trig    => busy_trig,
         clk          => clk,
         fifo_din     => reg_input_stat,
         fifo_read_en => ren(13),
         fifo_stat_en => ren(14),
         rd_i         => db_rd0,
         rst          => rst,
         db_oz        => db
      );
   trigger_osc_1 : trigger_osc
      port map (
         clk         => clk,
         rst         => rst_trig_osc,
         count_max_i => reg_trig_osc,
         trig_osc_o  => trig_osc
      );
   trigin_control_1 : trigin_control
      port map (
         clk            => clk,
         clr_busy_i     => clr_busy,
         reg_input_en   => reg_input_en,
         rst            => rst,
         trig_cmd_i     => trig_cmd,
         trig_ext0_i    => trig_ext0_i,
         trig_ext1_i    => trig_ext1_i,
         trig_ext2_i    => trig_ext2_i,
         trig_ext3_i    => trig_ext3_i,
         trig_osc_i     => trig_osc,
         reg_input_stat => reg_input_stat,
         trigin_busy_o  => busy_trig,
         trigin_out     => trigin_out,
         trigin_sync_o  => trigin_sync
      );
   version_id_1 : version_id
      generic map (
         FIRMWARE_VER => FIRMWARE_VER
      )
      port map (
         en_i  => ren(9),
         rd_i  => db_rd,
         db_oz => db
      );

end struct;
