-- hds header_start
--
-- VHDL Entity CERC_trig.bt_top.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 10:51:55 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity bt_top is
   port( 
      clk_in        : in     std_logic;
      rst_in        : in     std_logic;
      trig_ext0_i   : in     std_logic;
      trig_ext1_i   : in     std_logic;
      trig_ext2_i   : in     std_logic;
      trig_ext3_i   : in     std_logic;
      trigin_in     : in     std_logic;
      trigin_sw_i   : in     std_logic;
      vmeser_in     : in     std_logic;
      busy_trig_o   : out    std_logic;
      qdr_addr_19_o : out    std_logic;
      qdr_addr_20_o : out    std_logic;
      trig_fe_o     : out    std_logic_vector (7 downto 0);
      trig_sync_o   : out    std_logic;
      trigin_out    : out    std_logic;
      vmeser_out    : out    std_logic
   );

-- Declarations

end bt_top ;


-- hds interface_end

--
-- VHDL Architecture CERC_trig.bt_top.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 10:51:55 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use IEEE.VITAL_Timing.ALL;
use ieee.numeric_std.ALL;
library unisim;
use unisim.vpkg.ALL;

library CERC_lib;
library CERC_trig;

architecture struct of bt_top is

   -- Architecture declarations

   -- Internal signal declarations
   signal ONE          : std_logic;
   signal ZERO         : std_logic;
   signal addr         : std_logic_vector(15 downto 0);
   signal clk          : std_logic;
   signal clk180       : std_logic;
   signal clk270       : std_logic;
   signal clk90        : std_logic;
   signal db           : std_logic_vector(31 downto 0);
   signal db_rd        : std_logic;
   signal db_rd0       : std_logic;
   signal db_wr        : std_logic;
   signal dcm_locked_n : std_logic;
   signal ren          : std_logic_vector(31 downto 0);
   signal rst          : std_logic;
   signal rst_cmd      : std_logic;


   -- Component Declarations
   component addr_reg
   port (
      clk      : in     std_logic ;
      en_i     : in     std_logic ;
      en_inc_i : in     std_logic ;
      rd_i     : in     std_logic ;
      rst      : in     std_logic ;
      wr_i     : in     std_logic ;
      addr_o   : out    std_logic_vector (15 downto 0);
      db_io    : inout  std_logic_vector (31 downto 0)
   );
   end component;
   component aw_dcm_4phase
   port (
      clk_in    : in     std_logic ;
      rst_in    : in     std_logic ;
      locked_o  : out    std_logic ;
      locked_on : out    std_logic ;
      clk90_o   : out    std_logic ;
      clk180_o  : out    std_logic ;
      clk270_o  : out    std_logic ;
      clk0_o    : out    std_logic 
   );
   end component;
   component bt_main
   generic (
      FIRMWARE_VER : integer := 0
   );
   port (
      addr          : in     std_logic_vector (15 downto 0);
      clk           : in     std_logic ;
      clk180        : in     std_logic ;
      clk270        : in     std_logic ;
      clk90         : in     std_logic ;
      db_rd         : in     std_logic ;
      db_rd0        : in     std_logic ;
      db_wr         : in     std_logic ;
      ren           : in     std_logic_vector (31 downto 0);
      rst           : in     std_logic ;
      trig_ext0_i   : in     std_logic ;
      trig_ext1_i   : in     std_logic ;
      trig_ext2_i   : in     std_logic ;
      trig_ext3_i   : in     std_logic ;
      trigin_in     : in     std_logic ;
      trigin_sw_i   : in     std_logic ;
      busy_trig_o   : out    std_logic ;
      qdr_addr_19_o : out    std_logic ;
      qdr_addr_20_o : out    std_logic ;
      rst_cmd       : out    std_logic ;
      trig_fe_o     : out    std_logic_vector (7 downto 0);
      trig_sync_o   : out    std_logic ;
      trigin_out    : out    std_logic ;
      db            : inout  std_logic_vector (31 downto 0)
   );
   end component;
   component m_or2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_power
   port (
      ONE  : out    std_logic ;
      ZERO : out    std_logic 
   );
   end component;
   component vmeser_decode
   port (
      clk      : in     std_logic ;
      rst      : in     std_logic ;
      ser_i    : in     std_logic ;
      ser_o    : out    std_logic ;
      db_rd0_o : out    std_logic ;                     -- 1 clk early read - for FIFOs mainly
      db_rd_o  : out    std_logic ;
      db_wr_o  : out    std_logic ;
      ren_o    : out    std_logic_vector (31 downto 0); -- reg enable lines (like reg_en)
      db_io    : inout  std_logic_vector (31 downto 0)
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : addr_reg use entity CERC_trig.addr_reg;
   for all : aw_dcm_4phase use entity CERC_lib.aw_dcm_4phase;
   for all : bt_main use entity CERC_trig.bt_main;
   for all : m_or2 use entity CERC_lib.m_or2;
   for all : m_power use entity CERC_lib.m_power;
   for all : vmeser_decode use entity CERC_trig.vmeser_decode;
   -- pragma synthesis_on


begin
   -- Instance port mappings.
   addr_reg_1 : addr_reg
      port map (
         clk      => clk,
         en_i     => ren(31),
         en_inc_i => ren(30),
         rd_i     => db_rd,
         rst      => rst,
         wr_i     => db_wr,
         addr_o   => addr,
         db_io    => db
      );
   aw_dcm_4phase_1 : aw_dcm_4phase
      port map (
         clk_in    => clk_in,
         rst_in    => rst_in,
         locked_o  => open,
         locked_on => dcm_locked_n,
         clk90_o   => clk90,
         clk180_o  => clk180,
         clk270_o  => clk270,
         clk0_o    => clk
      );
   bt_main_1 : bt_main
      generic map (
         FIRMWARE_VER => 7
      )
      port map (
         addr          => addr,
         clk           => clk,
         clk180        => clk180,
         clk270        => clk270,
         clk90         => clk90,
         db_rd         => db_rd,
         db_rd0        => db_rd0,
         db_wr         => db_wr,
         ren           => ren,
         rst           => rst,
         trig_ext0_i   => trig_ext0_i,
         trig_ext1_i   => trig_ext1_i,
         trig_ext2_i   => trig_ext2_i,
         trig_ext3_i   => trig_ext3_i,
         trigin_in     => trigin_in,
         trigin_sw_i   => trigin_sw_i,
         busy_trig_o   => busy_trig_o,
         qdr_addr_19_o => qdr_addr_19_o,
         qdr_addr_20_o => qdr_addr_20_o,
         rst_cmd       => rst_cmd,
         trig_fe_o     => trig_fe_o,
         trig_sync_o   => trig_sync_o,
         trigin_out    => trigin_out,
         db            => db
      );
   I6 : m_or2
      port map (
         I1 => dcm_locked_n,
         I2 => rst_cmd,
         O  => rst
      );
   m_power_1 : m_power
      port map (
         ONE  => ONE,
         ZERO => ZERO
      );
   vmeser_decode_1 : vmeser_decode
      port map (
         clk      => clk,
         rst      => rst_in,
         ser_i    => vmeser_in,
         ser_o    => vmeser_out,
         db_rd0_o => db_rd0,
         db_rd_o  => db_rd,
         db_wr_o  => db_wr,
         ren_o    => ren,
         db_io    => db
      );

end struct;
