-- hds header_start
--
-- VHDL Entity CERC_lib.clk_rst_mgr.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:55:42 09/24/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity clk_rst_mgr is
   port( 
      dcm_clk_in : in     std_logic;
      rst_in     : in     std_logic;
      clk0       : out    std_logic;
      clk180     : out    std_logic;
      clk2x      : out    std_logic;
      clk2x180   : out    std_logic;
      rst        : out    std_logic;
      rst_cfg    : out    std_logic
   );

-- Declarations

end clk_rst_mgr ;


-- hds interface_end

--
-- VHDL Architecture CERC_lib.clk_rst_mgr.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:55:43 09/24/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use ieee.vital_timing.all;
library unisim;
use unisim.vpkg.all;
use ieee.numeric_std.ALL;

library CERC_lib;
library unisim;

architecture struct of clk_rst_mgr is

   -- Architecture declarations

   -- Internal signal declarations
   signal dcm_locked : std_logic := '0';
   signal gnd        : std_logic;
   signal q0         : std_logic;
   signal q1         : std_logic;
   signal q2         : std_logic;
   signal rising     : std_logic;
   signal rst_q0     : std_logic;
   signal rst_q1     : std_logic;

   -- Implicit buffer signal declarations
   signal rst_cfg_internal : std_logic;


   -- Component Declarations
   component FDS
   generic (
      TimingChecksOn             : Boolean          := TRUE;
      InstancePath               : STRING           := "*";
      Xon                        : Boolean          := True;
      MsgOn                      : Boolean          := False;
      INIT                       : bit              := '1';
      tpd_C_Q                    : VitalDelayType01 := (0.100 ns, 0.100 ns);
      tsetup_D_C_posedge_posedge : VitalDelayType   := 0.010 ns;
      tsetup_D_C_negedge_posedge : VitalDelayType   := 0.010 ns;
      thold_D_C_posedge_posedge  : VitalDelayType   := 0.010 ns;
      thold_D_C_negedge_posedge  : VitalDelayType   := 0.010 ns;
      tsetup_S_C_posedge_posedge : VitalDelayType   := 0.010 ns;
      tsetup_S_C_negedge_posedge : VitalDelayType   := 0.010 ns;
      thold_S_C_posedge_posedge  : VitalDelayType   := 0.010 ns;
      thold_S_C_negedge_posedge  : VitalDelayType   := 0.010 ns;
      tpw_C_posedge              : VitalDelayType   := 0.010 ns;
      tpw_C_negedge              : VitalDelayType   := 0.010 ns;
      tipd_D                     : VitalDelayType01 := (0.000 ns, 0.000 ns);
      tipd_C                     : VitalDelayType01 := (0.000 ns, 0.000 ns);
      tipd_S                     : VitalDelayType01 := (0.000 ns, 0.000 ns)
   );
   port (
      Q : out    STD_ULOGIC ;
      C : in     STD_ULOGIC ;
      D : in     STD_ULOGIC ;
      S : in     STD_ULOGIC 
   );
   end component;
   component aw_dcm_2x180
   port (
      CLKIN_IN     : in     std_logic ;
      RST_IN       : in     std_logic ;
      LOCKED_OUT   : out    std_logic ;
      CLK180_OUT   : out    std_logic ;
      CLK2X_OUT    : out    std_logic ;
      CLK2X180_OUT : out    std_logic ;
      CLK0_OUT     : out    std_logic 
   );
   end component;
   component edgedet
   port (
      clk     : in     std_logic ;
      rst     : in     std_logic ;
      sig     : in     std_logic ;
      rising  : out    std_logic ;
      falling : out    std_logic 
   );
   end component;
   component m_dff
   port (
      D  : in     std_logic ;
      c  : in     std_logic ;
      r  : in     std_logic ;
      Q  : out    std_logic ;
      Qn : out    std_logic 
   );
   end component;
   component m_dff_lut
   port (
      D   : in     std_logic ;
      clk : in     std_logic ;
      Q   : out    std_logic 
   );
   end component;
   component m_or2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_or3
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      I3 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_power
   port (
      ONE  : out    std_logic ;
      ZERO : out    std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : FDS use entity unisim.FDS;
   for all : aw_dcm_2x180 use entity CERC_lib.aw_dcm_2x180;
   for all : edgedet use entity CERC_lib.edgedet;
   for all : m_dff use entity CERC_lib.m_dff;
   for all : m_dff_lut use entity CERC_lib.m_dff_lut;
   for all : m_or2 use entity CERC_lib.m_or2;
   for all : m_or3 use entity CERC_lib.m_or3;
   for all : m_power use entity CERC_lib.m_power;
   -- pragma synthesis_on


begin
   -- Instance port mappings.
   FDS_1 : FDS
      generic map (
         TimingChecksOn             => TRUE,
         InstancePath               => "*",
         Xon                        => True,
         MsgOn                      => False,
         INIT                       => '1',
         tpd_C_Q                    => (0.100 ns, 0.100 ns),
         tsetup_D_C_posedge_posedge => 0.010 ns,
         tsetup_D_C_negedge_posedge => 0.010 ns,
         thold_D_C_posedge_posedge  => 0.010 ns,
         thold_D_C_negedge_posedge  => 0.010 ns,
         tsetup_S_C_posedge_posedge => 0.010 ns,
         tsetup_S_C_negedge_posedge => 0.010 ns,
         thold_S_C_posedge_posedge  => 0.010 ns,
         thold_S_C_negedge_posedge  => 0.010 ns,
         tpw_C_posedge              => 0.010 ns,
         tpw_C_negedge              => 0.010 ns,
         tipd_D                     => (0.000 ns, 0.000 ns),
         tipd_C                     => (0.000 ns, 0.000 ns),
         tipd_S                     => (0.000 ns, 0.000 ns)
      )
      port map (
         Q => q0,
         C => dcm_clk_in,
         D => gnd,
         S => gnd
      );
   aw_dcm_2x180_1 : aw_dcm_2x180
      port map (
         CLKIN_IN     => dcm_clk_in,
         RST_IN       => rst_cfg_internal,
         LOCKED_OUT   => dcm_locked,
         CLK180_OUT   => clk180,
         CLK2X_OUT    => clk2x,
         CLK2X180_OUT => clk2x180,
         CLK0_OUT     => clk0
      );
   edgedet_1 : edgedet
      port map (
         clk     => dcm_clk_in,
         rst     => rst_in,
         sig     => dcm_locked,
         rising  => rising,
         falling => open
      );
   m_dff_1 : m_dff
      port map (
         D  => rst_q0,
         c  => dcm_clk_in,
         r  => rst_in,
         Q  => rst_q1,
         Qn => open
      );
   m_dff_2 : m_dff
      port map (
         D  => rst_q1,
         c  => dcm_clk_in,
         r  => rst_in,
         Q  => open,
         Qn => rst
      );
   m_dff_lut_1 : m_dff_lut
      port map (
         D   => q0,
         clk => dcm_clk_in,
         Q   => q1
      );
   m_dff_lut_2 : m_dff_lut
      port map (
         D   => q1,
         clk => dcm_clk_in,
         Q   => q2
      );
   m_or2_1 : m_or2
      port map (
         I1 => rst_q1,
         I2 => rising,
         O  => rst_q0
      );
   m_or3_1 : m_or3
      port map (
         I1 => q0,
         I2 => q1,
         I3 => q2,
         O  => rst_cfg_internal
      );
   m_power_1 : m_power
      port map (
         ONE  => open,
         ZERO => gnd
      );

   -- Implicit buffered output assignments
   rst_cfg <= rst_cfg_internal;

end struct;
