-- hds header_start
--
-- VHDL Architecture back_end_fpga.data_mux.rtl
--
-- Created:
--          by - st79.UNKNOWN (TE2BELIZE)
--          at - 09:20:15 01/20/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity data_mux1 is
   port( 
      clk2x            : in     std_logic;
      qdr_FE_data      : in     std_logic_vector (71 downto 0);
      qdr_count_data   : in     std_logic_vector (71 downto 0);
      qdr_test_data_en : in     std_logic_vector (1 downto 0);
      qdr_test_pattern : in     std_logic_vector (71 downto 0);
      reset            : in     std_logic;
      qdr_wr_data      : out    std_logic_vector (71 downto 0)
   );

-- Declarations

end data_mux1 ;


-- hds interface_end
ARCHITECTURE rtl OF data_mux1 IS
BEGIN

process (reset, clk2x)
	begin
	if reset = '1' then
		qdr_wr_data <= (others => '0') after 1 ns;
	elsif clk2x'event and clk2x = '1' then
		if qdr_test_data_en = "01" then				-- select counting data to qdr
			qdr_wr_data <= qdr_count_data after 1 ns;
		elsif qdr_test_data_en = "10" then			-- select 5's and A's pattern data to qdr
			qdr_wr_data <= qdr_test_pattern after 1 ns;	
		else										
			qdr_wr_data <= qdr_FE_data after 1 ns;			-- any other condition use front end data
		end if;
	end if;
end process;

END rtl;
