-- hds header_start
--
-- VHDL Entity CALICE_lib.dcm_2x.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 14:44:01 12/18/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
--  Module TWOX_DCM
--  Generated by Xilinx Architecture Wizard
--  VHDL
--  Written for synthesis tool: Leonardo
--  Xilinx Device: XC2V2000-FG676-4
-- 
-- 
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library unisim;
use unisim.vpkg.all;

entity dcm_2x is
   port( 
      reset_in   : in     std_logic;
      clock_in   : in     std_logic;
      dcm_locked : out    std_logic;
      clk2x      : out    std_logic;
      clk0       : out    std_logic
   );

-- Declarations

end dcm_2x ;

-- hds interface_end
architecture rtl of dcm_2x is
   signal 	clock_in_ibufg : std_logic;
   signal 	clkfb_in 		: std_logic;
   signal 	clk0_buf 		: std_logic;
   signal 	gnd 				: std_logic;

   attribute CLK_FEEDBACK : string;
   attribute CLK_FEEDBACK of dcm_inst : label is "1X";
   attribute CLKDV_DIVIDE : real;
   attribute CLKDV_DIVIDE of dcm_inst : label is 2.0;
   attribute CLKFX_DIVIDE : integer;
   attribute CLKFX_DIVIDE of dcm_inst : label is 1;
   attribute CLKFX_MULTIPLY : integer;
   attribute CLKFX_MULTIPLY of dcm_inst : label is 4;
   attribute CLKIN_DIVIDE_BY_2 : boolean;
   attribute CLKIN_DIVIDE_BY_2 of dcm_inst : label is FALSE;
   attribute CLKIN_PERIOD : real;
   attribute CLKIN_PERIOD of dcm_inst : label is 25.0;
   attribute CLKOUT_PHASE_SHIFT : string;
   attribute CLKOUT_PHASE_SHIFT of dcm_inst : label is "NONE";
   attribute DESKEW_ADJUST : string;
   attribute DESKEW_ADJUST of dcm_inst : label is "SYSTEM_SYNCHRONOUS";
   attribute DFS_FREQUENCY_MODE : string;
   attribute DFS_FREQUENCY_MODE of dcm_inst : label is "LOW";
   attribute DLL_FREQUENCY_MODE : string;
   attribute DLL_FREQUENCY_MODE of dcm_inst : label is "LOW";
   attribute DUTY_CYCLE_CORRECTION : boolean;
   attribute DUTY_CYCLE_CORRECTION of dcm_inst : label is TRUE;
   attribute PHASE_SHIFT : integer;
   attribute PHASE_SHIFT of dcm_inst : label is 0;
   attribute STARTUP_WAIT : boolean;
   attribute STARTUP_WAIT of dcm_inst : label is FALSE;

	component DCM
		-- synopsys translate_off
		generic( 
			DFS_FREQUENCY_MODE : string := "LOW";
			DLL_FREQUENCY_MODE : string := "LOW";
			DUTY_CYCLE_CORRECTION : boolean := TRUE;
			CLKIN_DIVIDE_BY_2 : boolean := FALSE;
			CLK_FEEDBACK : string := "1X";
			CLKOUT_PHASE_SHIFT : string := "NONE";
			DSS_MODE : string := "NONE";
			FACTORY_JF : bit_vector := X"C080";
			STARTUP_WAIT : boolean := false;
			PHASE_SHIFT : integer := 0;
			CLKFX_MULTIPLY : integer := 4;
			CLKFX_DIVIDE : integer := 1;
			CLKDV_DIVIDE : real := 2.0;
			CLKIN_PERIOD : real := 0.0;
			DESKEW_ADJUST : string := "SYSTEM_SYNCHRONOUS"
     );
     -- synopsys translate_on
     
		port (
			CLKIN : in std_logic;
			CLKFB : in std_logic;
			RST : in std_logic;
			PSEN : in std_logic;
			PSINCDEC : in std_logic;
			PSCLK : in std_logic;
			DSSEN : in std_logic;
			CLK0 : out std_logic;
			CLK90 : out std_logic;
			CLK180 : out std_logic;
			CLK270 : out std_logic;
			CLKDV : out std_logic;
			CLK2X : out std_logic;
			CLK2X180 : out std_logic;
			CLKFX : out std_logic;
			CLKFX180 : out std_logic;
			STATUS : out std_logic_vector (7 downto 0);
			LOCKED : out std_logic;
			PSDONE : out std_logic
		);
   end component;
   
	component IBUFG
     	port (
       	I : in std_logic;
       	O : out std_logic
		);
	end component;
   
   component BUFG
     	port (
       	I : in std_logic;
       	O : out std_logic
     	);
   end component;

begin
	dcm_inst : DCM
		-- synopsys translate_off
    	Generic map (
			CLK_FEEDBACK => "1X",
			CLKDV_DIVIDE => 2.0,
			CLKFX_DIVIDE => 1,
			CLKFX_MULTIPLY => 4,
			CLKIN_DIVIDE_BY_2 => FALSE,
			CLKIN_PERIOD => 25.0,
			CLKOUT_PHASE_SHIFT => "NONE",
			DESKEW_ADJUST => "SYSTEM_SYNCHRONOUS",
			DFS_FREQUENCY_MODE => "LOW",
			DLL_FREQUENCY_MODE => "LOW",
			DUTY_CYCLE_CORRECTION => TRUE,
			PHASE_SHIFT => 0,
			STARTUP_WAIT => FALSE)
		-- synopsys translate_on
     	port map (
			CLKIN => clock_in_ibufg,
			CLKFB => clkfb_in,
			RST => reset_in,
			PSEN => gnd,
			PSINCDEC => gnd,
			PSCLK => gnd,
			DSSEN => gnd,
			CLK0 => clk0_buf,
			CLK2X => clk2x,
			LOCKED => dcm_locked);

   clock_in_ibufg_inst : IBUFG
     	port map (
      	I => clock_in,
      	O => clock_in_ibufg
      );

   clk0_bufg_inst : BUFG
     	port map (
     	 	I => clk0_buf,
      	O => clkfb_in
      );

--   CLK2X_BUFG_inst : BUFG
--     port map (
--      I => CLK2X_BUF,
--      O => CLK2X_OUT);

   clk0 <= clkfb_in;
   gnd <= '0';
end rtl;

