-- hds header_start
--
-- VHDL Entity CALICE_BE_fpga.deserialiser_80.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:55:57 08/11/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity deserialiser_80 is
   port( 
      clk   : in     std_logic;
      clr_Q : in     std_logic;
      data  : in     std_logic;
      en    : in     std_logic;
      reset : in     std_logic;
      Q     : out    std_logic_vector (79 downto 0);
      done  : out    std_logic
   );

-- Declarations

end deserialiser_80 ;


-- hds interface_end

--
-- VHDL Architecture CALICE_BE_fpga.deserialiser_80.fsm
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:55:57 08/11/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

architecture fsm of deserialiser_80 is

   -- Architecture Declarations
   signal data_count : integer range 0 to 82;
   signal tmp_q : std_logic_vector(81 downto 0);

   type state_type is (
      ser_0,
      ser_2,
      ser_3,
      ser_1,
      ser_4
   );

   -- State vector declaration
   attribute state_vector : string;
   attribute state_vector of fsm : architecture is "current_state" ;


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

   -- Declare any pre-registered internal signals
   signal Q_cld : std_logic_vector (79 downto 0) ;
   signal done_cld : std_logic  ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      clk,
      reset
   )
   ----------------------------------------------------------------------------
   begin
      if (reset = '1') then
         current_state <= ser_0;
         -- Reset Values
         Q_cld <= (others => '0');
         done_cld <= '0';
         data_count <= 0;
         tmp_q <= (others => '0');
      elsif (clk'event and clk = '1') then
         current_state <= next_state;
         -- Default Assignment To Internals

         -- Combined Actions for internal signals only
         case current_state is
         when ser_0 =>
            data_count <= 0;
            done_cld <= '0' ;
            tmp_q <= (others => '0') ;
            Q_cld <= (others => '0');
         when ser_2 =>
            tmp_q(data_count) <= data;
            data_count <= data_count  - 1;
         when ser_3 =>
            Q_cld <= tmp_q (81 downto 2)
            after 1 ns ;
            done_cld <= '1' after 1 ns ;
         when ser_1 =>
            data_count <= 81;
         when others =>
            null;
         end case;

      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      clr_Q,
      current_state,
      data,
      data_count,
      en
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when ser_0 =>
         if (en = '1') then
            next_state <= ser_1;
         else
            next_state <= ser_0;
         end if;
      when ser_2 =>
         if (data_count = 2) then
            next_state <= ser_3;
         else
            next_state <= ser_2;
         end if;
      when ser_3 =>
         if (clr_Q = '1') then
            next_state <= ser_4;
         else
            next_state <= ser_3;
         end if;
      when ser_1 =>
         if (en = '0') then
            next_state <= ser_0;
         elsif (data = '1' AND en = '1') then
            next_state <= ser_2;
         else
            next_state <= ser_1;
         end if;
      when ser_4 =>
         if (clr_Q = '0') then
            next_state <= ser_0;
         else
            next_state <= ser_4;
         end if;
      when others =>
         next_state <= ser_0;
      end case;

   end process nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   Q <= Q_cld;
   done <= done_cld;


end fsm;
