-- hds header_start
--
-- VHDL Entity CERC_trig.fe_trig_shape.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 10:47:21 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity fe_trig_shape is
   port( 
      clk             : in     std_logic;
      reg_output_en_i : in     std_logic_vector (31 downto 0);
      rst             : in     std_logic;
      trigin_in       : in     std_logic;
      trigin_sw_i     : in     std_logic;
      fe_trig_o       : out    std_logic_vector (7 downto 0);
      trig_sync_o     : out    std_logic
   );

-- Declarations

end fe_trig_shape ;


-- hds interface_end

--
-- VHDL Architecture CERC_trig.fe_trig_shape.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 10:47:23 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use IEEE.VITAL_Timing.ALL;

library CERC_lib;
library unisim;

architecture struct of fe_trig_shape is

   -- Architecture declarations

   -- Internal signal declarations
   signal ONE          : std_logic;
   signal ZERO         : std_logic;
   signal clr_ce       : std_logic;
   signal fe_trig_q    : std_logic;
   signal trig_async   : std_logic;
   signal trig_latch_q : std_logic;
   signal trigin       : std_logic;
   signal trigin_bufg  : STD_ULOGIC;


   -- Component Declarations
   component BUFG
   generic (
      TimingChecksOn : Boolean          := TRUE;
      InstancePath   : STRING           := "*";
      Xon            : Boolean          := True;
      MsgOn          : Boolean          := False;
      tpd_I_O        : VitalDelayType01 := (0.100 ns, 0.100 ns);
      tipd_I         : VitalDelayType01 := (0.000 ns, 0.000 ns)
   );
   port (
      O : out    STD_ULOGIC ;
      I : in     STD_ULOGIC 
   );
   end component;
   component fan_en8
   port (
      i  : in     std_logic ;
      en : in     std_logic_vector (7 downto 0);
      o  : out    std_logic_vector (7 downto 0)
   );
   end component;
   component fdcpe_clkz
   port (
      set     : in     std_logic ;
      clr_ce  : in     std_logic ;
      o       : out    std_logic ;
      clr_clk : in     std_logic ;
      rst     : in     std_logic 
   );
   end component;
   component m_dff
   port (
      D  : in     std_logic ;
      c  : in     std_logic ;
      r  : in     std_logic ;
      Q  : out    std_logic ;
      Qn : out    std_logic 
   );
   end component;
   component m_or2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_power
   port (
      ONE  : out    std_logic ;
      ZERO : out    std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : BUFG use entity unisim.BUFG;
   for all : fan_en8 use entity CERC_lib.fan_en8;
   for all : fdcpe_clkz use entity CERC_lib.fdcpe_clkz;
   for all : m_dff use entity CERC_lib.m_dff;
   for all : m_or2 use entity CERC_lib.m_or2;
   for all : m_power use entity CERC_lib.m_power;
   -- pragma synthesis_on


begin
   -- Instance port mappings.
   BUFG_2 : BUFG
      generic map (
         TimingChecksOn => TRUE,
         InstancePath   => "*",
         Xon            => True,
         MsgOn          => False,
         tpd_I_O        => (0.100 ns, 0.100 ns),
         tipd_I         => (0.000 ns, 0.000 ns)
      )
      port map (
         O => trigin_bufg,
         I => trigin
      );
   fan_en8_1 : fan_en8
      port map (
         i  => trig_async,
         en => reg_output_en_i(7 DOWNTO 0),
         o  => fe_trig_o
      );
   fdcpe_clkz_1 : fdcpe_clkz
      port map (
         set     => trigin_bufg,
         clr_ce  => clr_ce,
         o       => trig_async,
         clr_clk => clk,
         rst     => rst
      );
   m_dff_2 : m_dff
      port map (
         D  => trigin,
         c  => clk,
         r  => rst,
         Q  => trig_latch_q,
         Qn => open
      );
   m_dff_1 : m_dff
      port map (
         D  => trig_latch_q,
         c  => clk,
         r  => rst,
         Q  => clr_ce,
         Qn => open
      );
   m_dff_3 : m_dff
      port map (
         D  => trig_async,
         c  => clk,
         r  => rst,
         Q  => fe_trig_q,
         Qn => open
      );
   m_dff_4 : m_dff
      port map (
         D  => fe_trig_q,
         c  => clk,
         r  => rst,
         Q  => trig_sync_o,
         Qn => open
      );
   m_or2_1 : m_or2
      port map (
         I1 => trigin_sw_i,
         I2 => trigin_in,
         O  => trigin
      );
   m_power_1 : m_power
      port map (
         ONE  => ONE,
         ZERO => ZERO
      );

end struct;
