-- hds header_start
--
-- VHDL Entity CERC_lib.fifo_tribus.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 16:34:10 05/11/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity fifo_tribus is
   port( 
      clk    : in     std_logic;
      read   : in     std_logic;
      rst    : in     std_logic;
      statrd : in     std_logic;
      write  : in     std_logic;
      db     : inout  std_logic_vector (31 downto 0)
   );

-- Declarations

end fifo_tribus ;


-- hds interface_end

--
-- VHDL Architecture CERC_lib.fifo_tribus.sync1kx32
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 16:34:10 05/11/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


library CERC_lib;

architecture sync1kx32 of fifo_tribus is

   -- Architecture declarations

   -- Internal signal declarations
   signal depth       : std_logic_VECTOR(9 downto 0);
   signal empty       : std_logic;
   signal fifo_db_out : std_logic_VECTOR(31 downto 0);
   signal full        : std_logic;
   signal q           : std_logic;
   signal status      : std_logic_vector(31 downto 0);


   -- ModuleWare signal declarations for instance 'I0' of 'dff'
   signal MW_I0cregl : std_logic;

   -- Component Declarations
   component cg_fifo1kx32
   port (
      clk        : in     std_logic ;
      sinit      : in     std_logic ;
      din        : in     std_logic_VECTOR (31 downto 0);
      wr_en      : in     std_logic ;
      rd_en      : in     std_logic ;
      dout       : out    std_logic_VECTOR (31 downto 0);
      full       : out    std_logic ;
      empty      : out    std_logic ;
      data_count : out    std_logic_VECTOR (9 downto 0)
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : cg_fifo1kx32 use entity CERC_lib.cg_fifo1kx32;
   -- pragma synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 2 merge
   -- merge
   status(31 downto 18) <= (others => '0');
   status(17)           <= full;
   status(16)           <= empty;
   status(15 downto 10) <= (others => '0');
   status( 9 downto  0) <= depth;


   -- ModuleWare code for instance 'I9' of 'tribuf'
   
   I9combo: process (fifo_db_out, q)
   begin
      if (q = '0') then
         db <= (others => 'Z');
      elsif (q = '1') then
         db <= fifo_db_out;
      else
         db <= (others => 'X');
      end if;
   end process I9combo;

   -- ModuleWare code for instance 'I10' of 'tribuf'
   
   I10combo: process (status, statrd)
   begin
      if (statrd = '0') then
         db <= (others => 'Z');
      elsif (statrd = '1') then
         db <= status;
      else
         db <= (others => 'X');
      end if;
   end process I10combo;

   -- ModuleWare code for instance 'I0' of 'dff'
   q <= MW_I0cregl;
   -- synopsys async_set_reset_local of I0seq "rst"
   I0seq: process (clk, rst)
   begin
      if (rst = '1') then
         MW_I0cregl <= '0';
      elsif (clk'event and clk='1') then
         MW_I0cregl <= read;
      end if;
   end process I0seq;
   -- Instance port mappings.
   I5 : cg_fifo1kx32
      port map (
         clk        => clk,
         sinit      => rst,
         din        => db,
         wr_en      => write,
         rd_en      => read,
         dout       => fifo_db_out,
         full       => full,
         empty      => empty,
         data_count => depth
      );

end sync1kx32;
