-- hds header_start
--
-- VHDL Entity CALICE_BE_fpga.frame_sync_sig_gen.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:55:56 08/11/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

entity frame_sync_sig_gen is
   port( 
      FE_trigger          : in     std_logic;
      be_status_reg       : in     std_logic_vector (31 downto 0);
      clk1x               : in     std_logic;
      done                : in     std_logic;
      en_fe_data_capture  : in     std_logic;
      frame_sync_en       : in     std_logic;
      mode_reg            : in     std_logic_vector (3 downto 0);
      reset               : in     std_logic;
      temp_bus            : in     std_logic_vector (47 downto 0);
      tracker_header_1    : in     std_logic_vector (127 downto 0);
      tracker_header_2    : in     std_logic_vector (127 downto 0);
      tracker_header_3    : in     std_logic_vector (127 downto 0);
      tracker_header_4    : in     std_logic_vector (127 downto 0);
      tracker_header_5    : in     std_logic_vector (127 downto 0);
      tracker_header_6    : in     std_logic_vector (127 downto 0);
      tracker_header_7    : in     std_logic_vector (127 downto 0);
      tracker_header_8    : in     std_logic_vector (127 downto 0);
      en_trkr_hdr_fifo_wr : out    std_logic;
      frm_sync_in_en      : out    std_logic;
      tracker_header      : out    std_logic_vector (63 downto 0)
   );

-- Declarations

end frame_sync_sig_gen ;


-- hds interface_end

--
-- VHDL Architecture CALICE_BE_fpga.frame_sync_sig_gen.fsm
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:55:56 08/11/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

architecture fsm of frame_sync_sig_gen is

   -- Architecture Declarations
   signal count : integer range 0 to 270;

   type state_type is (
      frm_syn_0,
      frm_syn_1a,
      frm_syn_2,
      frm_syn_3,
      frm_syn_4,
      frm_syn_5,
      frm_syn_6,
      frm_syn_7,
      frm_syn_8,
      frm_syn_9,
      frm_syn_10,
      frm_syn_11,
      frm_syn_12,
      frm_syn_13,
      frm_syn_14,
      frm_syn_15,
      frm_syn_16,
      frm_syn_17,
      frm_syn_18,
      frm_syn_19,
      s_m_0,
      s_m_1,
      s_m_3,
      frm_syn_1,
      s_m_2
   );

   -- State vector declaration
   attribute state_vector : string;
   attribute state_vector of fsm : architecture is "current_state" ;


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

   -- Declare any pre-registered internal signals
   signal en_trkr_hdr_fifo_wr_cld : std_logic  ;
   signal frm_sync_in_en_cld : std_logic  ;
   signal tracker_header_cld : std_logic_vector (63 downto 0) ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      clk1x,
      reset
   )
   ----------------------------------------------------------------------------
   begin
      if (reset = '1') then
         current_state <= frm_syn_0;
         -- Reset Values
         en_trkr_hdr_fifo_wr_cld <= '0';
         frm_sync_in_en_cld <= '0';
         tracker_header_cld <= (others => '0' );
         count <= 0;
      elsif (clk1x'event and clk1x = '1') then
         if (en_fe_data_capture = '1') then
            current_state <= next_state;
            -- Default Assignment To Internals
            en_trkr_hdr_fifo_wr_cld <= '0';
            frm_sync_in_en_cld <= '0';
            tracker_header_cld <= (others => '0' );

            -- Combined Actions for internal signals only
            case current_state is
            when frm_syn_0 =>
               frm_sync_in_en_cld <= '0' ;
               en_trkr_hdr_fifo_wr_cld <= '0' ;
               tracker_header_cld <= (others => '0');
               count <= 0 ;
            when frm_syn_2 =>
               en_trkr_hdr_fifo_wr_cld <= '1' after 1 ns;
               tracker_header_cld <= tracker_header_1 (63 downto 0)
                after 1 ns;
            when frm_syn_3 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_1 (127 downto 112)
               & be_status_reg & tracker_header_1 (79 downto 64)
                after 1 ns;
            when frm_syn_4 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_2(63 downto 0)
                after 1 ns;
            when frm_syn_5 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_2 (127 downto 64)
                after 1 ns;
            when frm_syn_6 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_3(63 downto 0)
                after 1 ns;
            when frm_syn_7 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_3 (127 downto 64)
                after 1 ns;
            when frm_syn_8 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_4 (63 downto 0)
                after 1 ns;
            when frm_syn_9 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_4 (127 downto 64)
                after 1 ns;
            when frm_syn_10 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_5(63 downto 0)
                after 1 ns;
            when frm_syn_11 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_5 (127 downto 64)
                after 1 ns;
            when frm_syn_12 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_6 (63 downto 0)
                after 1 ns;
            when frm_syn_13 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_6 (127 downto 64)
                after 1 ns;
            when frm_syn_14 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_7 (63 downto 0)
                after 1 ns;
            when frm_syn_15 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_7 (127 downto 64)
                after 1 ns;
            when frm_syn_16 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_8 (63 downto 0)
                after 1 ns;
            when frm_syn_17 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_8 (127 downto 64)
                after 1 ns;
            when frm_syn_18 =>
               en_trkr_hdr_fifo_wr_cld <= '0'  after 1 ns;
            when s_m_0 =>
               en_trkr_hdr_fifo_wr_cld <= '0' after 1 ns;
            when s_m_1 =>
               tracker_header_cld <= "0101010101010101" &
               be_status_reg & "0101010101010101" 
               after 1 ns;
               en_trkr_hdr_fifo_wr_cld <= '1' after 1 ns;
               count <= count + 1;
            when s_m_3 =>
               en_trkr_hdr_fifo_wr_cld <= '0' after 1 ns;
            when s_m_2 =>
               tracker_header_cld <= "0101010101010101" &
               "0101010101010101" & "0101010101010101" 
               & "0101010101010101" after 1 ns;
               en_trkr_hdr_fifo_wr_cld <= '1' after 1 ns;
               count <= count + 1;
               if (count = 16) then
                  en_trkr_hdr_fifo_wr_cld <= '0' after 1 ns;
                  tracker_header_cld <= (others => '0')
                   after 1 ns;
               end if;
            when others =>
               null;
            end case;

         end if;
      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      count,
      current_state,
      done,
      frame_sync_en,
      mode_reg
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when frm_syn_0 =>
         if (mode_reg(1 downto 0) = "10") then
            next_state <= frm_syn_1;
         elsif (mode_reg(1 downto 0) = "01") then
            next_state <= s_m_0;
         else
            next_state <= frm_syn_0;
         end if;
      when frm_syn_1a =>
            next_state <= frm_syn_2;
      when frm_syn_2 =>
            next_state <= frm_syn_3;
      when frm_syn_3 =>
            next_state <= frm_syn_4;
      when frm_syn_4 =>
            next_state <= frm_syn_5;
      when frm_syn_5 =>
            next_state <= frm_syn_6;
      when frm_syn_6 =>
            next_state <= frm_syn_7;
      when frm_syn_7 =>
            next_state <= frm_syn_8;
      when frm_syn_8 =>
            next_state <= frm_syn_9;
      when frm_syn_9 =>
            next_state <= frm_syn_10;
      when frm_syn_10 =>
            next_state <= frm_syn_11;
      when frm_syn_11 =>
            next_state <= frm_syn_12;
      when frm_syn_12 =>
            next_state <= frm_syn_13;
      when frm_syn_13 =>
            next_state <= frm_syn_14;
      when frm_syn_14 =>
            next_state <= frm_syn_15;
      when frm_syn_15 =>
            next_state <= frm_syn_16;
      when frm_syn_16 =>
            next_state <= frm_syn_17;
      when frm_syn_17 =>
            next_state <= frm_syn_18;
      when frm_syn_18 =>
            next_state <= frm_syn_19;
      when frm_syn_19 =>
            next_state <= frm_syn_0;
      when s_m_0 =>
         if (mode_reg(1 downto 0) = "10") then
            next_state <= frm_syn_0;
         elsif (done = '1') then
            next_state <= s_m_1;
         else
            next_state <= s_m_0;
         end if;
      when s_m_1 =>
            next_state <= s_m_2;
      when s_m_3 =>
            next_state <= frm_syn_0;
      when frm_syn_1 =>
         if (mode_reg(1 downto 0) = "01") then
            next_state <= frm_syn_0;
         elsif (frame_sync_en = '1') then
            next_state <= frm_syn_1a;
         else
            next_state <= frm_syn_1;
         end if;
      when s_m_2 =>
         if (count = 16) then
            next_state <= s_m_3;
         else
            next_state <= s_m_2;
         end if;
      when others =>
         next_state <= frm_syn_0;
      end case;

   end process nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   en_trkr_hdr_fifo_wr <= en_trkr_hdr_fifo_wr_cld;
   frm_sync_in_en <= frm_sync_in_en_cld;
   tracker_header <= tracker_header_cld;


end fsm;
