-- hds header_start
--
-- VHDL Entity CALICE_BE_fpga.gen_ttc_rx_rst.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 12:29:56 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_arith.ALL;

entity gen_ttc_rx_rst is
   port( 
      TTC_rst_frm_vme_b : in     std_logic;
      clk1x             : in     std_logic;
      rst               : in     std_logic;
      ttc_rx_rst_1      : in     std_logic;
      ttc_reset_b_1     : out    std_logic
   );

-- Declarations

end gen_ttc_rx_rst ;


-- hds interface_end

--
-- VHDL Architecture CALICE_BE_fpga.gen_ttc_rx_rst.fsm
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 12:29:56 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

architecture fsm of gen_ttc_rx_rst is

   -- Architecture Declarations
   signal icount: natural range 0 to 2047;

   type state_type is (
      ttc_rst_0,
      ttc_rst_1,
      ttc_rst_2,
      ttc_rst_3
   );

   -- State vector declaration
   attribute state_vector : string;
   attribute state_vector of fsm : architecture is "current_state" ;


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

   -- Declare any pre-registered internal signals
   signal ttc_reset_b_1_cld : std_logic  ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      clk1x,
      rst
   )
   ----------------------------------------------------------------------------
   begin
      if (rst = '1') then
         current_state <= ttc_rst_0;
         -- Reset Values
         ttc_reset_b_1_cld <= '1';
         icount <= 0;
      elsif (clk1x'event and clk1x = '1') then
         current_state <= next_state;
         -- Default Assignment To Internals
         icount <= 0;
         ttc_reset_b_1_cld <= '1';

         -- Combined Actions for internal signals only
         case current_state is
         when ttc_rst_0 =>
            ttc_reset_b_1_cld <= '1' after 1 ns;
            icount <= 0 ;
         when ttc_rst_1 =>
            icount <= icount + 1;
            ttc_reset_b_1_cld <= '0' after 1 ns;
         when ttc_rst_2 =>
            ttc_reset_b_1_cld <= '1'  after 1 ns;
         when others =>
            null;
         end case;

      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      TTC_rst_frm_vme_b,
      current_state,
      icount,
      ttc_rx_rst_1
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when ttc_rst_0 =>
         if (ttc_rx_rst_1 = '1' OR 
         TTC_rst_frm_vme_b = '0') then
            next_state <= ttc_rst_1;
         else
            next_state <= ttc_rst_0;
         end if;
      when ttc_rst_1 =>
         if (icount = 2046) then
            next_state <= ttc_rst_2;
         else
            next_state <= ttc_rst_1;
         end if;
      when ttc_rst_2 =>
            next_state <= ttc_rst_3;
      when ttc_rst_3 =>
            next_state <= ttc_rst_0;
      when others =>
         next_state <= ttc_rst_0;
      end case;

   end process nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   ttc_reset_b_1 <= ttc_reset_b_1_cld;


end fsm;
