-- hds header_start
--
-- VHDL Entity CALICE_BE_fpga.i2c_cntl_lm82.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:57:26 08/11/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

entity i2c_cntl_lm82 is
   port( 
      ce_i2c          : in     std_logic;
      data_from_lm82  : in     std_logic_vector (7 downto 0);
      i2c_busy        : in     std_logic;
      i2c_err         : in     std_logic;
      i2c_rst         : in     std_logic;
      iclk40          : in     std_logic;
      lm82_control    : in     std_logic_vector (16 downto 0);
      set_lm82_status : in     std_logic;
      data_to_lm82    : out    std_logic_vector (7 downto 0);
      i2c_abort       : out    std_logic;
      i2c_rd_nwr      : out    std_logic;
      lm82_cmnd       : out    std_logic_vector (7 downto 0);
      lm82_status     : out    std_logic_vector (15 downto 0)
   );

-- Declarations

end i2c_cntl_lm82 ;


-- hds interface_end

--
-- VHDL Architecture CALICE_BE_fpga.i2c_cntl_lm82.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:57:27 08/11/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

library CALICE_BE_fpga;

architecture struct of i2c_cntl_lm82 is

   -- Architecture declarations

   -- Internal signal declarations
   signal i2c_err_held   : std_logic;
   signal ipb_high       : std_logic;
   signal lm82_data_held : std_logic_vector(7 downto 0);


   -- Component Declarations
   component i2c_ff_e
   generic (
      q_rst : std_logic := '0'
   );
   port (
      d   : in     std_logic ;
      clk : in     std_logic ;
      rst : in     std_logic ;
      q   : out    std_logic ;
      ce  : in     std_logic 
   );
   end component;
   component i2c_reg_e
   generic (
      width : integer   := 16;
      edge  : std_logic := '1'
   );
   port (
      d   : in     std_logic_vector (width-1 downto 0);
      clk : in     std_logic ;
      rst : in     std_logic ;
      q   : out    std_logic_vector (width-1 downto 0);
      ce  : in     std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : i2c_ff_e use entity CALICE_BE_fpga.i2c_ff_e;
   for all : i2c_reg_e use entity CALICE_BE_fpga.i2c_reg_e;
   -- pragma synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb1
   -- eb1 1
   lm82_status <= "000000"  
                 & i2c_err_held 
                 & i2c_busy
                 & lm82_data_held;

   -- HDL Embedded Text Block 3 eb3
   -- eb3 3
   ipb_high <= '1';

   -- HDL Embedded Text Block 4 eb4
   i2c_abort <= '0';
   i2c_rd_nwr  <=  lm82_control(16);
   lm82_cmnd <= lm82_control(15 downto 8);
   data_to_lm82 <= lm82_control(7 downto 0);

   -- Instance port mappings.
   I1 : i2c_ff_e
      generic map (
         q_rst => '0'
      )
      port map (
         d   => ipb_high,
         clk => iclk40,
         rst => i2c_rst,
         q   => i2c_err_held,
         ce  => i2c_err
      );
   I0 : i2c_reg_e
      generic map (
         width => 8,
         edge  => '1'
      )
      port map (
         d   => data_from_lm82,
         clk => iclk40,
         rst => i2c_rst,
         q   => lm82_data_held,
         ce  => set_lm82_status
      );

end struct;
