-- hds header_start
--
-- VHDL Entity CALICE_BE_fpga.qdr_rd_addr_cntl.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:53:57 08/11/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

entity qdr_rd_addr_cntl is
   port( 
      back_pressure_B         : in     std_logic;
      clk2x                   : in     std_logic;
      data_out_en             : in     std_logic;
      qdr_frame_count         : in     std_logic_vector (23 downto 0);
      rd_length_1             : in     std_logic_vector (17 downto 0);
      reset                   : in     std_logic;
      total_length_fifo_empty : in     std_logic;
      en_frm_cnt_dwn          : out    std_logic;
      rd_load_or_count        : out    std_logic;
      rd_total_length_fifo_en : out    std_logic;
      rd_trckr_hdr_en         : out    std_logic;
      start_data_format       : out    std_logic;
      stop_data_format        : out    std_logic
   );

-- Declarations

end qdr_rd_addr_cntl ;


-- hds interface_end

--
-- VHDL Architecture CALICE_BE_fpga.qdr_rd_addr_cntl.fsm_1
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:53:57 08/11/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

architecture fsm_1 of qdr_rd_addr_cntl is

   -- Architecture Declarations
   type state_type is (
      vme_rd_19,
      rd_qdr_0,
      rd_qdr_1,
      rd_qdr_2,
      vme_rd_23,
      vme_rd_24,
      vme_rd_20,
      vme_rd_21,
      vme_rd_22,
      vme_rd_9,
      vme_rd_8,
      vme_rd_7,
      vme_rd_6,
      vme_rd_5,
      vme_rd_3,
      vme_rd_4,
      vme_rd_10,
      vme_rd_11,
      vme_rd_12,
      vme_rd_13,
      vme_rd_14,
      vme_rd_15,
      vme_rd_16,
      vme_rd_2,
      vme_rd_17,
      vme_rd_18
   );

   -- State vector declaration
   attribute state_vector : string;
   attribute state_vector of fsm_1 : architecture is "current_state" ;


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

   -- Declare any pre-registered internal signals
   signal en_frm_cnt_dwn_cld : std_logic  ;
   signal rd_load_or_count_cld : std_logic  ;
   signal rd_total_length_fifo_en_cld : std_logic  ;
   signal rd_trckr_hdr_en_cld : std_logic  ;
   signal start_data_format_cld : std_logic  ;
   signal stop_data_format_cld : std_logic  ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      clk2x,
      reset
   )
   ----------------------------------------------------------------------------
   begin
      if (reset = '1') then
         current_state <= rd_qdr_0;
         -- Reset Values
         en_frm_cnt_dwn_cld <= '0';
         rd_load_or_count_cld <= '0';
         rd_total_length_fifo_en_cld <= '0';
         rd_trckr_hdr_en_cld <= '0';
         start_data_format_cld <= '0';
         stop_data_format_cld <= '0';
      elsif (clk2x'event and clk2x = '1') then
         current_state <= next_state;
         -- Default Assignment To Internals
         en_frm_cnt_dwn_cld <= '0';
         rd_load_or_count_cld <= '0';
         rd_total_length_fifo_en_cld <= '0';
         rd_trckr_hdr_en_cld <= '0';
         start_data_format_cld <= '0';
         stop_data_format_cld <= '0';

         -- Combined Actions for internal signals only
         case current_state is
         when rd_qdr_0 =>
            en_frm_cnt_dwn_cld <= '0' after 1 ns ;
            rd_load_or_count_cld <= '0' after 1 ns;
            rd_total_length_fifo_en_cld <= '0' after 1 ns;
            rd_trckr_hdr_en_cld <= '0' after 1 ns;
            start_data_format_cld <= '0' after 1 ns;
            stop_data_format_cld <= '0' after 1 ns;
         when rd_qdr_2 =>
            if (back_pressure_B = '1') then
               rd_total_length_fifo_en_cld <= '1'
               after 1 ns;
            end if;
         when vme_rd_23 =>
            stop_data_format_cld <= '1' 
            after 1 ns ;
            en_frm_cnt_dwn_cld <= '1'  
            after 1 ns;
         when vme_rd_9 =>
            if (back_pressure_B = '1') then
               rd_trckr_hdr_en_cld <= '1'  after 1 ns ;
            end if;
         when vme_rd_8 =>
            if (back_pressure_B = '1') then
               rd_trckr_hdr_en_cld <= '1'  after 1 ns;
            end if;
         when vme_rd_7 =>
            if (back_pressure_B = '1') then
               rd_trckr_hdr_en_cld <= '1' after 1 ns ;
            end if;
         when vme_rd_6 =>
            if (back_pressure_B = '1') then
               rd_trckr_hdr_en_cld <= '1' after 1 ns ;
            end if;
         when vme_rd_5 =>
            rd_trckr_hdr_en_cld <= '1'  after 1 ns;
            start_data_format_cld <=  '1'  after 1 ns;
         when vme_rd_3 =>
            rd_trckr_hdr_en_cld <= '1' 
             after 1 ns;
         when vme_rd_4 =>
            rd_trckr_hdr_en_cld <= '1'
             after 1 ns ;
         when vme_rd_10 =>
            if (back_pressure_B = '1') then
               rd_trckr_hdr_en_cld <= '1' 
                after 1 ns;
            end if;
         when vme_rd_11 =>
            if (back_pressure_B = '1') then
               rd_trckr_hdr_en_cld <= '1'
                after 1 ns ;
            end if;
         when vme_rd_12 =>
            if (back_pressure_B = '1') then
               rd_trckr_hdr_en_cld <= '1'
                after 1 ns ;
            end if;
         when vme_rd_13 =>
            if (back_pressure_B = '1') then
               rd_trckr_hdr_en_cld <= '1'
                after 1 ns ;
            end if;
         when vme_rd_14 =>
            if (back_pressure_B = '1') then
               rd_trckr_hdr_en_cld <= '1'  after 1 ns;
            end if;
         when vme_rd_15 =>
            if (back_pressure_B = '1') then
               rd_trckr_hdr_en_cld <= '1'  after 1 ns;
               rd_load_or_count_cld <= '1' after 1 ns;
            end if;
         when vme_rd_16 =>
            rd_trckr_hdr_en_cld <= '1'  after 1 ns;
         when vme_rd_2 =>
            if (back_pressure_B = '1') then
               rd_trckr_hdr_en_cld <= '1' 
                after 1 ns;
            end if;
         when vme_rd_17 =>
            rd_trckr_hdr_en_cld <= '1' 
             after 1 ns;
         when others =>
            null;
         end case;

      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      back_pressure_B,
      current_state,
      data_out_en,
      qdr_frame_count,
      rd_length_1,
      total_length_fifo_empty
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when vme_rd_19 =>
            next_state <= vme_rd_20;
      when rd_qdr_0 =>
         if (total_length_fifo_empty = '0'
         AND 
         back_pressure_B = '1') then
            next_state <= rd_qdr_1;
         else
            next_state <= rd_qdr_0;
         end if;
      when rd_qdr_1 =>
         if (qdr_frame_count > 
         "000000000000000000000000"
         AND 
         back_pressure_B = '1') then
            next_state <= rd_qdr_2;
         else
            next_state <= rd_qdr_1;
         end if;
      when rd_qdr_2 =>
         if (back_pressure_B = '1') then
            next_state <= vme_rd_2;
         else
            next_state <= rd_qdr_2;
         end if;
      when vme_rd_23 =>
            next_state <= vme_rd_24;
      when vme_rd_24 =>
         if (data_out_en = '0') then
            next_state <= rd_qdr_0;
         else
            next_state <= vme_rd_24;
         end if;
      when vme_rd_20 =>
            next_state <= vme_rd_21;
      when vme_rd_21 =>
            next_state <= vme_rd_22;
      when vme_rd_22 =>
            next_state <= vme_rd_23;
      when vme_rd_9 =>
         if (back_pressure_B = '1') then
            next_state <= vme_rd_10;
         else
            next_state <= vme_rd_9;
         end if;
      when vme_rd_8 =>
         if (back_pressure_B = '1') then
            next_state <= vme_rd_9;
         else
            next_state <= vme_rd_8;
         end if;
      when vme_rd_7 =>
         if (back_pressure_B = '1') then
            next_state <= vme_rd_8;
         else
            next_state <= vme_rd_7;
         end if;
      when vme_rd_6 =>
         if (back_pressure_B = '1') then
            next_state <= vme_rd_7;
         else
            next_state <= vme_rd_6;
         end if;
      when vme_rd_5 =>
            next_state <= vme_rd_6;
      when vme_rd_3 =>
            next_state <= vme_rd_4;
      when vme_rd_4 =>
            next_state <= vme_rd_5;
      when vme_rd_10 =>
         if (back_pressure_B = '1') then
            next_state <= vme_rd_11;
         else
            next_state <= vme_rd_10;
         end if;
      when vme_rd_11 =>
         if (back_pressure_B = '1') then
            next_state <= vme_rd_12;
         else
            next_state <= vme_rd_11;
         end if;
      when vme_rd_12 =>
         if (back_pressure_B = '1') then
            next_state <= vme_rd_13;
         else
            next_state <= vme_rd_12;
         end if;
      when vme_rd_13 =>
         if (back_pressure_B = '1') then
            next_state <= vme_rd_14;
         else
            next_state <= vme_rd_13;
         end if;
      when vme_rd_14 =>
         if (back_pressure_B = '1') then
            next_state <= vme_rd_15;
         else
            next_state <= vme_rd_14;
         end if;
      when vme_rd_15 =>
         if (back_pressure_B = '1') then
            next_state <= vme_rd_16;
         else
            next_state <= vme_rd_15;
         end if;
      when vme_rd_16 =>
            next_state <= vme_rd_17;
      when vme_rd_2 =>
         if (back_pressure_B = '1') then
            next_state <= vme_rd_3;
         else
            next_state <= vme_rd_2;
         end if;
      when vme_rd_17 =>
            next_state <= vme_rd_18;
      when vme_rd_18 =>
         if (rd_length_1 =
         "000000000000000001") then
            next_state <= vme_rd_19;
         else
            next_state <= vme_rd_18;
         end if;
      when others =>
         next_state <= rd_qdr_0;
      end case;

   end process nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   en_frm_cnt_dwn <= en_frm_cnt_dwn_cld;
   rd_load_or_count <= rd_load_or_count_cld;
   rd_total_length_fifo_en <= rd_total_length_fifo_en_cld;
   rd_trckr_hdr_en <= rd_trckr_hdr_en_cld;
   start_data_format <= start_data_format_cld;
   stop_data_format <= stop_data_format_cld;


end fsm_1;
