-- hds header_start
--
-- VHDL Entity CALICE_BE_fpga.qdr_slink_interface.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 11:55:50 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_arith.ALL;

entity qdr_slink_interface is
   port( 
      FE_enable_reg           : in     std_logic_vector (8 downto 1);
      FE_frame_sync_en        : in     std_logic_vector (8 downto 1);
      FE_trigger              : in     std_logic;
      L1A_bx_count_data       : in     std_logic_vector (35 downto 0);
      back_pressure_B         : in     std_logic;
      be_status_reg           : in     std_logic_vector (31 downto 0);
      clk1x                   : in     std_logic;
      clk2x                   : in     std_logic;
      en_fe_data_capture      : in     std_logic;
      en_qdr_data_to_slink    : in     std_logic;
      en_qdr_data_to_vme      : in     std_logic;
      fed_id_reg              : in     std_logic_vector (11 downto 0);
      frame_sync_in           : in     std_logic_vector (8 downto 1);
      internal_freeze_bar     : in     std_logic;
      locked_all_clks         : in     std_logic;
      mod1_data               : in     std_logic_vector (3 downto 0);
      mod2_data               : in     std_logic_vector (3 downto 0);
      mod3_data               : in     std_logic_vector (3 downto 0);
      mod4_data               : in     std_logic_vector (3 downto 0);
      mod5_data               : in     std_logic_vector (3 downto 0);
      mod6_data               : in     std_logic_vector (3 downto 0);
      mod7_data               : in     std_logic_vector (3 downto 0);
      mod8_data               : in     std_logic_vector (3 downto 0);
      mode_reg                : in     std_logic_vector (3 downto 0);
      qdr_1_q                 : in     std_logic_vector (17 downto 0);
      qdr_2_q                 : in     std_logic_vector (17 downto 0);
      qdr_test_data_en        : in     std_logic_vector (1 downto 0);
      readout_sync_in         : in     std_logic_vector (8 downto 1);
      reset                   : in     std_logic;
      slink_lrl               : in     std_logic_vector (3 downto 0);
      slink_lsf               : in     std_logic_vector (3 downto 0);
      vme_link_clk            : in     std_logic;
      cntl_to_vme             : out    std_logic;
      data_out_to_vme         : out    std_logic_vector (31 downto 0);
      data_to_vme_valid       : out    std_logic;
      empty_flags             : out    std_logic_vector (7 downto 0);
      full_flags              : out    std_logic_vector (7 downto 0);
      half_full_flags         : out    std_logic_vector (7 downto 0);
      partial_empty_flags     : out    std_logic_vector (7 downto 0);
      partial_full_flags      : out    std_logic_vector (7 downto 0);
      qdr_addr                : out    std_logic_vector (18 downto 1);
      qdr_bw_n                : out    std_logic_vector (1 downto 0);
      qdr_data_count          : out    std_logic_vector (17 downto 0);
      qdr_frame_count         : out    std_logic_vector (23 downto 0);
      qdr_read_b              : out    std_logic;
      qdr_write_b             : out    std_logic;
      rd_total_length_fifo_en : out    std_logic;
      readout_sync_out        : out    std_logic_vector (8 downto 1);
      slink_uclk              : out    std_logic;
      slink_ucntl_b           : out    std_logic;
      slink_ud                : out    std_logic_vector (63 downto 0);
      slink_udw               : out    std_logic_vector (1 downto 0);
      slink_ureset_b          : out    std_logic;
      slink_usf               : out    std_logic_vector (3 downto 0);
      slink_utest_b           : out    std_logic;
      slink_uwen_b            : out    std_logic;
      total_frame_count       : out    std_logic_vector (23 downto 0);
      wr_data_qdr1_lsb        : out    std_logic_vector (17 downto 0);
      wr_data_qdr2_msb        : out    std_logic_vector (17 downto 0)
   );

-- Declarations

end qdr_slink_interface ;


-- hds interface_end

--
-- VHDL Architecture CALICE_BE_fpga.qdr_slink_interface.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 11:55:58 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

LIBRARY ieee;
USE ieee.std_logic_1164.all;

library CALICE_BE_fpga;
library unisim;

architecture struct of qdr_slink_interface is

   -- Architecture declarations

   -- Internal signal declarations
   signal ctrl                 : std_logic;
   signal data1                : std_logic_vector(7 downto 0);
   signal data2                : std_logic_vector(7 downto 0);
   signal data3                : std_logic_vector(7 downto 0);
   signal data4                : std_logic_vector(7 downto 0);
   signal data5                : std_logic_vector(7 downto 0);
   signal data6                : std_logic_vector(7 downto 0);
   signal data7                : std_logic_vector(7 downto 0);
   signal data8                : std_logic_vector(7 downto 0);
   signal data_evt_stat        : std_logic_vector(7 downto 0);
   signal data_evt_ty          : std_logic_vector(3 downto 0);
   signal data_out             : std_logic_vector(63 downto 0);
   signal data_out_en          : std_logic;
   signal done                 : std_logic;
   signal fe_data              : std_logic_vector(63 downto 0);    -- Data to be written to the QDR memory
   signal frm_addr_and_lengths : std_logic_vector(35 downto 0);
   signal frm_addr_fifo_empty  : std_logic;
   signal frm_sync_in          : std_logic_vector(8 downto 1);
   signal high                 : std_logic := '0';
   signal low                  : std_logic := '0';
   signal mux1to8_en           : std_logic;
   signal qdr_data_in          : std_logic_vector(71 downto 0);
   signal qdr_data_in_en       : std_logic;
   signal qdr_rd_addr          : std_logic_vector(18 downto 1);
   signal qdr_rd_addr_en       : std_logic;
   signal qdr_wr_addr          : std_logic_vector(18 downto 1);
   signal qdr_wr_addr_en       : std_logic;
   signal rd_fe_lengths        : std_logic_vector(17 downto 0);
   signal rd_trckr_hdr_en      : std_logic;
   signal rdout_sync_in        : std_logic_vector(8 downto 1);
   signal rdout_sync_out_sig1  : std_logic;
   signal rdout_temp           : std_logic_vector(8 downto 1);
   signal readout_sync_out_sig : std_logic;
   signal ready                : std_logic;
   signal start_data_format    : std_logic;
   signal stop_data_format     : std_logic;
   signal store_frame_data_bus : std_logic_VECTOR(7 downto 0);
   signal trkr_hdr_25_flag     : std_logic;
   signal trkr_hdr_50_flag     : std_logic;
   signal trkr_hdr_87_flag     : std_logic;
   signal trkr_hdr_fifo_empty  : std_logic;
   signal trkr_hdr_fifo_full   : std_logic;

   -- Implicit buffer signal declarations
   signal rd_total_length_fifo_en_internal : std_logic;


   -- Component Declarations
   component DDR_conversion1
   port (
      FE_enable_reg        : in     std_logic_vector (8 downto 1);
      clk2x                : in     std_logic ;
      frm_addr_fifo_empty  : in     std_logic ;
      mod1_data            : in     std_logic_vector (3 downto 0);
      mod2_data            : in     std_logic_vector (3 downto 0);
      mod3_data            : in     std_logic_vector (3 downto 0);
      mod4_data            : in     std_logic_vector (3 downto 0);
      mod5_data            : in     std_logic_vector (3 downto 0);
      mod6_data            : in     std_logic_vector (3 downto 0);
      mod7_data            : in     std_logic_vector (3 downto 0);
      mod8_data            : in     std_logic_vector (3 downto 0);
      rdout_sync_out_sig1  : in     std_logic ;
      reset                : in     std_logic ;
      store_frame_data_bus : in     std_logic_VECTOR (7 downto 0);
      data1                : out    std_logic_vector (7 downto 0);
      data2                : out    std_logic_vector (7 downto 0);
      data3                : out    std_logic_vector (7 downto 0);
      data4                : out    std_logic_vector (7 downto 0);
      data5                : out    std_logic_vector (7 downto 0);
      data6                : out    std_logic_vector (7 downto 0);
      data7                : out    std_logic_vector (7 downto 0);
      data8                : out    std_logic_vector (7 downto 0);
      mux1to8_en           : out    std_logic 
   );
   end component;
   component FDC
   port (
      C   : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D   : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component SLINK_interface1
   port (
      clk2x                : in     std_logic ;
      ctrl                 : in     std_logic ;
      data_out             : in     std_logic_vector (63 downto 0);
      data_out_en          : in     std_logic ;
      en_qdr_data_to_slink : in     std_logic ;
      ready                : in     std_logic ;
      reset                : in     std_logic ;
      slink_lrl            : in     std_logic_vector (3 downto 0);
      slink_lsf            : in     std_logic_vector (3 downto 0);
      slink_uclk           : out    std_logic ;
      slink_ucntl_b        : out    std_logic ;
      slink_ud             : out    std_logic_vector (63 downto 0);
      slink_udw            : out    std_logic_vector (1 downto 0);
      slink_ureset_b       : out    std_logic ;
      slink_usf            : out    std_logic_vector (3 downto 0);
      slink_utest_b        : out    std_logic ;
      slink_uwen_b         : out    std_logic 
   );
   end component;
   component addr_gen1
   port (
      FE_enable_reg           : in     std_logic_vector (8 downto 1);
      back_pressure_B         : in     std_logic ;
      clk1x                   : in     std_logic ;
      clk2x                   : in     std_logic ;
      data_out_en             : in     std_logic ;
      en_fe_data_capture      : in     std_logic ;
      internal_freeze_bar     : in     std_logic ;
      rdout_sync_in           : in     std_logic_vector (8 downto 1);
      rdout_sync_out_sig1     : in     std_logic ;
      reset                   : in     std_logic ;
      done                    : out    std_logic ;
      empty_flags             : out    std_logic_vector (7 downto 0);
      frm_addr_and_lengths    : out    std_logic_vector (35 downto 0);
      frm_addr_fifo_empty     : out    std_logic ;
      full_flags              : out    std_logic_vector (7 downto 0);
      half_full_flags         : out    std_logic_vector (7 downto 0);
      partial_empty_flags     : out    std_logic_vector (7 downto 0);
      partial_full_flags      : out    std_logic_vector (7 downto 0);
      qdr_data_count          : out    std_logic_vector (17 downto 0);
      qdr_frame_count         : out    std_logic_vector (23 downto 0);
      qdr_rd_addr             : out    std_logic_vector (18 downto 1);
      qdr_rd_addr_en          : out    std_logic ;
      qdr_wr_addr             : out    std_logic_vector (18 downto 1);
      qdr_wr_addr_en          : out    std_logic ;
      rd_fe_lengths           : out    std_logic_vector (17 downto 0);
      rd_total_length_fifo_en : out    std_logic ;
      rd_trckr_hdr_en         : out    std_logic ;
      readout_sync_out_sig    : out    std_logic ;
      start_data_format       : out    std_logic ;
      stop_data_format        : out    std_logic ;
      store_frame_data_bus    : out    std_logic_VECTOR (7 downto 0);
      total_frame_count       : out    std_logic_vector (23 downto 0)
   );
   end component;
   component data_merger1
   port (
      clk2x      : in     std_logic ;
      data1      : in     std_logic_vector (7 downto 0);
      data2      : in     std_logic_vector (7 downto 0);
      data3      : in     std_logic_vector (7 downto 0);
      data4      : in     std_logic_vector (7 downto 0);
      data5      : in     std_logic_vector (7 downto 0);
      data6      : in     std_logic_vector (7 downto 0);
      data7      : in     std_logic_vector (7 downto 0);
      data8      : in     std_logic_vector (7 downto 0);
      mux1to8_en : in     std_logic ;
      reset      : in     std_logic ;
      fe_data    : out    std_logic_vector (63 downto 0)
   );
   end component;
   component fddrcpe
   port (
      C0  : in     STD_ULOGIC;
      C1  : in     STD_ULOGIC;
      CE  : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D0  : in     STD_ULOGIC;
      D1  : in     STD_ULOGIC;
      PRE : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component inv
   port (
      I : in     STD_ULOGIC;
      O : out    STD_ULOGIC
   );
   end component;
   component pipeline_block1
   port (
      clk1x           : in     std_logic ;
      frame_sync_in   : in     std_logic_vector (8 downto 1);
      readout_sync_in : in     std_logic_vector (8 downto 1);
      reset           : in     std_logic ;
      frm_sync_in     : out    std_logic_vector (8 downto 1);
      rdout_sync_in   : out    std_logic_vector (8 downto 1)
   );
   end component;
   component qdr_data_read1
   port (
      FE_frame_sync_en        : in     std_logic_vector (8 downto 1);
      FE_trigger              : in     std_logic ;
      L1A_bx_count_data       : in     std_logic_vector (35 downto 0);
      be_status_reg           : in     std_logic_vector (31 downto 0);
      clk1x                   : in     std_logic ;
      clk2x                   : in     std_logic ;
      data_evt_stat           : in     std_logic_vector (7 downto 0);
      data_evt_ty             : in     std_logic_vector (3 downto 0);
      done                    : in     std_logic ;
      en_fe_data_capture      : in     std_logic ;
      fed_id_reg              : in     std_logic_vector (11 downto 0);
      frm_addr_and_lengths    : in     std_logic_vector (35 downto 0);
      frm_sync_in             : in     std_logic_vector (8 downto 1);
      internal_freeze_bar     : in     std_logic ;
      mode_reg                : in     std_logic_vector (3 downto 0);
      qdr_data_in             : in     std_logic_vector (71 downto 0);
      qdr_data_in_en          : in     std_logic ;
      rd_fe_lengths           : in     std_logic_vector (17 downto 0);
      rd_total_length_fifo_en : in     std_logic ;
      rd_trckr_hdr_en         : in     std_logic ;
      reset                   : in     std_logic ;
      start_data_format       : in     std_logic ;
      stop_data_format        : in     std_logic ;
      ctrl                    : out    std_logic ;
      data_out                : out    std_logic_vector (63 downto 0);
      data_out_en             : out    std_logic ;
      ready                   : out    std_logic ;
      trkr_hdr_25_flag        : out    std_logic ;
      trkr_hdr_50_flag        : out    std_logic ;
      trkr_hdr_87_flag        : out    std_logic ;
      trkr_hdr_fifo_empty     : out    std_logic ;
      trkr_hdr_fifo_full      : out    std_logic 
   );
   end component;
   component qdr_sram_interface1
   port (
      clk2x               : in     std_logic ;
      fe_data             : in     std_logic_vector (63 downto 0);
      internal_freeze_bar : in     std_logic ;
      locked_all_clks     : in     std_logic ;
      qdr_1_q             : in     std_logic_vector (17 downto 0);
      qdr_2_q             : in     std_logic_vector (17 downto 0);
      qdr_rd_addr         : in     std_logic_vector (18 downto 1);
      qdr_rd_addr_en      : in     std_logic ;
      qdr_test_data_en    : in     std_logic_vector (1 downto 0);
      qdr_wr_addr         : in     std_logic_vector (18 downto 1);
      qdr_wr_addr_en      : in     std_logic ;
      reset               : in     std_logic ;
      qdr_addr            : out    std_logic_vector (18 downto 1);
      qdr_bw_n            : out    std_logic_vector (1 downto 0);
      qdr_data_in         : out    std_logic_vector (71 downto 0);
      qdr_data_in_en      : out    std_logic ;
      qdr_read_b          : out    std_logic ;
      qdr_write_b         : out    std_logic ;
      wr_data_qdr1_lsb    : out    std_logic_vector (17 downto 0);
      wr_data_qdr2_msb    : out    std_logic_vector (17 downto 0)
   );
   end component;
   component vme_qdr_rd1
   port (
      ctrl               : in     std_logic ;
      data_out           : in     std_logic_vector (63 downto 0);
      data_out_en        : in     std_logic ;
      en_qdr_data_to_vme : in     std_logic ;
      reset              : in     std_logic ;
      vme_link_clk       : in     std_logic ;
      cntl_to_vme        : out    std_logic ;
      data_out_to_vme    : out    std_logic_vector (31 downto 0);
      data_to_vme_valid  : out    std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : DDR_conversion1 use entity CALICE_BE_fpga.DDR_conversion1;
   for all : FDC use entity unisim.FDC;
   for all : SLINK_interface1 use entity CALICE_BE_fpga.SLINK_interface1;
   for all : addr_gen1 use entity CALICE_BE_fpga.addr_gen1;
   for all : data_merger1 use entity CALICE_BE_fpga.data_merger1;
   for all : fddrcpe use entity unisim.fddrcpe;
   for all : inv use entity unisim.inv;
   for all : pipeline_block1 use entity CALICE_BE_fpga.pipeline_block1;
   for all : qdr_data_read1 use entity CALICE_BE_fpga.qdr_data_read1;
   for all : qdr_sram_interface1 use entity CALICE_BE_fpga.qdr_sram_interface1;
   for all : vme_qdr_rd1 use entity CALICE_BE_fpga.vme_qdr_rd1;
   -- pragma synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb1
   empty_flags(3) <= trkr_hdr_fifo_empty;
   partial_empty_flags(3) <= trkr_hdr_25_flag;
   half_full_flags(3) <= trkr_hdr_50_flag;
   partial_full_flags(3) <= trkr_hdr_87_flag;
   full_flags(3) <= trkr_hdr_fifo_full;

   -- HDL Embedded Text Block 2 eb2
   data_evt_stat <= (others => '0');
   data_evt_ty <= mode_reg;


   -- ModuleWare code for instance 'I7' of 'gnd'
      low <= '0';

   -- ModuleWare code for instance 'I4' of 'vdd'
      high <= '1';
   -- Instance port mappings.
   I12 : DDR_conversion1
      port map (
         FE_enable_reg        => FE_enable_reg,
         clk2x                => clk2x,
         frm_addr_fifo_empty  => frm_addr_fifo_empty,
         mod1_data            => mod1_data,
         mod2_data            => mod2_data,
         mod3_data            => mod3_data,
         mod4_data            => mod4_data,
         mod5_data            => mod5_data,
         mod6_data            => mod6_data,
         mod7_data            => mod7_data,
         mod8_data            => mod8_data,
         rdout_sync_out_sig1  => rdout_sync_out_sig1,
         reset                => reset,
         store_frame_data_bus => store_frame_data_bus,
         data1                => data1,
         data2                => data2,
         data3                => data3,
         data4                => data4,
         data5                => data5,
         data6                => data6,
         data7                => data7,
         data8                => data8,
         mux1to8_en           => mux1to8_en
      );
   I20 : FDC
      port map (
         Q   => rdout_sync_out_sig1,
         C   => clk1x,
         CLR => reset,
         D   => readout_sync_out_sig
      );
   I6 : SLINK_interface1
      port map (
         clk2x                => clk2x,
         ctrl                 => ctrl,
         data_out             => data_out,
         data_out_en          => data_out_en,
         en_qdr_data_to_slink => en_qdr_data_to_slink,
         ready                => ready,
         reset                => reset,
         slink_lrl            => slink_lrl,
         slink_lsf            => slink_lsf,
         slink_uclk           => slink_uclk,
         slink_ucntl_b        => slink_ucntl_b,
         slink_ud             => slink_ud,
         slink_udw            => slink_udw,
         slink_ureset_b       => slink_ureset_b,
         slink_usf            => slink_usf,
         slink_utest_b        => slink_utest_b,
         slink_uwen_b         => slink_uwen_b
      );
   I0 : addr_gen1
      port map (
         FE_enable_reg           => FE_enable_reg,
         back_pressure_B         => back_pressure_B,
         clk1x                   => clk1x,
         clk2x                   => clk2x,
         data_out_en             => data_out_en,
         en_fe_data_capture      => en_fe_data_capture,
         internal_freeze_bar     => internal_freeze_bar,
         rdout_sync_in           => rdout_sync_in,
         rdout_sync_out_sig1     => rdout_sync_out_sig1,
         reset                   => reset,
         done                    => done,
         empty_flags             => empty_flags,
         frm_addr_and_lengths    => frm_addr_and_lengths,
         frm_addr_fifo_empty     => frm_addr_fifo_empty,
         full_flags              => full_flags,
         half_full_flags         => half_full_flags,
         partial_empty_flags     => partial_empty_flags,
         partial_full_flags      => partial_full_flags,
         qdr_data_count          => qdr_data_count,
         qdr_frame_count         => qdr_frame_count,
         qdr_rd_addr             => qdr_rd_addr,
         qdr_rd_addr_en          => qdr_rd_addr_en,
         qdr_wr_addr             => qdr_wr_addr,
         qdr_wr_addr_en          => qdr_wr_addr_en,
         rd_fe_lengths           => rd_fe_lengths,
         rd_total_length_fifo_en => rd_total_length_fifo_en_internal,
         rd_trckr_hdr_en         => rd_trckr_hdr_en,
         readout_sync_out_sig    => readout_sync_out_sig,
         start_data_format       => start_data_format,
         stop_data_format        => stop_data_format,
         store_frame_data_bus    => store_frame_data_bus,
         total_frame_count       => total_frame_count
      );
   I2 : data_merger1
      port map (
         clk2x      => clk2x,
         data1      => data1,
         data2      => data2,
         data3      => data3,
         data4      => data4,
         data5      => data5,
         data6      => data6,
         data7      => data7,
         data8      => data8,
         mux1to8_en => mux1to8_en,
         reset      => reset,
         fe_data    => fe_data
      );
   I3 : pipeline_block1
      port map (
         clk1x           => clk1x,
         frame_sync_in   => frame_sync_in,
         readout_sync_in => readout_sync_in,
         reset           => reset,
         frm_sync_in     => frm_sync_in,
         rdout_sync_in   => rdout_sync_in
      );
   I10 : qdr_data_read1
      port map (
         FE_frame_sync_en        => FE_frame_sync_en,
         FE_trigger              => FE_trigger,
         L1A_bx_count_data       => L1A_bx_count_data,
         be_status_reg           => be_status_reg,
         clk1x                   => clk1x,
         clk2x                   => clk2x,
         data_evt_stat           => data_evt_stat,
         data_evt_ty             => data_evt_ty,
         done                    => done,
         en_fe_data_capture      => en_fe_data_capture,
         fed_id_reg              => fed_id_reg,
         frm_addr_and_lengths    => frm_addr_and_lengths,
         frm_sync_in             => frm_sync_in,
         internal_freeze_bar     => internal_freeze_bar,
         mode_reg                => mode_reg,
         qdr_data_in             => qdr_data_in,
         qdr_data_in_en          => qdr_data_in_en,
         rd_fe_lengths           => rd_fe_lengths,
         rd_total_length_fifo_en => rd_total_length_fifo_en_internal,
         rd_trckr_hdr_en         => rd_trckr_hdr_en,
         reset                   => reset,
         start_data_format       => start_data_format,
         stop_data_format        => stop_data_format,
         ctrl                    => ctrl,
         data_out                => data_out,
         data_out_en             => data_out_en,
         ready                   => ready,
         trkr_hdr_25_flag        => trkr_hdr_25_flag,
         trkr_hdr_50_flag        => trkr_hdr_50_flag,
         trkr_hdr_87_flag        => trkr_hdr_87_flag,
         trkr_hdr_fifo_empty     => trkr_hdr_fifo_empty,
         trkr_hdr_fifo_full      => trkr_hdr_fifo_full
      );
   I1 : qdr_sram_interface1
      port map (
         clk2x               => clk2x,
         fe_data             => fe_data,
         internal_freeze_bar => internal_freeze_bar,
         locked_all_clks     => locked_all_clks,
         qdr_1_q             => qdr_1_q,
         qdr_2_q             => qdr_2_q,
         qdr_rd_addr         => qdr_rd_addr,
         qdr_rd_addr_en      => qdr_rd_addr_en,
         qdr_test_data_en    => qdr_test_data_en,
         qdr_wr_addr         => qdr_wr_addr,
         qdr_wr_addr_en      => qdr_wr_addr_en,
         reset               => reset,
         qdr_addr            => qdr_addr,
         qdr_bw_n            => qdr_bw_n,
         qdr_data_in         => qdr_data_in,
         qdr_data_in_en      => qdr_data_in_en,
         qdr_read_b          => qdr_read_b,
         qdr_write_b         => qdr_write_b,
         wr_data_qdr1_lsb    => wr_data_qdr1_lsb,
         wr_data_qdr2_msb    => wr_data_qdr2_msb
      );
   I5 : vme_qdr_rd1
      port map (
         ctrl               => ctrl,
         data_out           => data_out,
         data_out_en        => data_out_en,
         en_qdr_data_to_vme => en_qdr_data_to_vme,
         reset              => reset,
         vme_link_clk       => vme_link_clk,
         cntl_to_vme        => cntl_to_vme,
         data_out_to_vme    => data_out_to_vme,
         data_to_vme_valid  => data_to_vme_valid
      );

   g6: FOR i IN 1 TO 8 GENERATE
      I13 : inv
         port map (
            O => rdout_temp(i),
            I => clk1x
         );
      I22 : fddrcpe
         port map (
            Q   => readout_sync_out(i),
            C0  => clk1x,
            C1  => rdout_temp(i),
            CE  => high,
            D0  => rdout_sync_out_sig1,
            D1  => rdout_sync_out_sig1,
            CLR => reset,
            PRE => low
         );
   end generate g6;

   -- Implicit buffered output assignments
   rd_total_length_fifo_en <= rd_total_length_fifo_en_internal;

end struct;
