-- hds header_start
--
-- VHDL Entity CALICE_BE_fpga.qdr_wr_addr_cntl1.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 11:53:38 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

entity qdr_wr_addr_cntl1 is
   port( 
      clk2x                 : in     std_logic;
      frm_lenght_fifo_empty : in     std_logic;
      rdout_sync_out_sig1   : in     std_logic;
      readout_sync_sig      : in     std_logic;
      reset                 : in     std_logic;
      store_frame_data_bus  : in     std_logic_VECTOR (7 downto 0);
      addr_length_fifo_en   : out    std_logic;
      en_frm_cnt_up         : out    std_logic;
      load_or_count         : out    std_logic;
      readout_sync_out_sig  : out    std_logic
   );

-- Declarations

end qdr_wr_addr_cntl1 ;


-- hds interface_end

--
-- VHDL Architecture CALICE_BE_fpga.qdr_wr_addr_cntl1.fsm
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 11:53:39 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

architecture fsm of qdr_wr_addr_cntl1 is

   -- Architecture Declarations
   signal clk_cnt :  integer range 0 to 17 := 0;

   type state_type is (
      a_cntl_0,
      a_cntl_1,
      a_cntl_2,
      a_cntl_5,
      a_cntl_6,
      a_cntl_7,
      a_cntl_8,
      a_cntl_9,
      a_cntl_10,
      a_cntl_12,
      a_cntl_13,
      a_cntl_4,
      a_cntl_14,
      a_cntl_15,
      a_cntl_16,
      a_cntl_11,
      a_cntl_3,
      a_cntl_17
   );

   -- State vector declaration
   attribute state_vector : string;
   attribute state_vector of fsm : architecture is "current_state" ;


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

   -- Declare any pre-registered internal signals
   signal addr_length_fifo_en_cld : std_logic  ;
   signal en_frm_cnt_up_cld : std_logic  ;
   signal load_or_count_cld : std_logic  ;
   signal readout_sync_out_sig_cld : std_logic  ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      clk2x,
      reset
   )
   ----------------------------------------------------------------------------
   begin
      if (reset = '1') then
         current_state <= a_cntl_0;
         -- Reset Values
         addr_length_fifo_en_cld <= '0';
         en_frm_cnt_up_cld <= '0';
         load_or_count_cld <= '0';
         readout_sync_out_sig_cld <= '0';
         clk_cnt <= 0;
      elsif (clk2x'event and clk2x = '1') then
         current_state <= next_state;
         -- Default Assignment To Internals
         clk_cnt <= 0;
         en_frm_cnt_up_cld <= '0';

         -- Combined Actions for internal signals only
         case current_state is
         when a_cntl_0 =>
            load_or_count_cld <= '0' after 1 ns ;
            clk_cnt <= 0;
            addr_length_fifo_en_cld <= '0' after 1 ns;
            en_frm_cnt_up_cld <= '0' after 1 ns;
            readout_sync_out_sig_cld <= '0' after 1 ns;
         when a_cntl_2 =>
            readout_sync_out_sig_cld <= '1' 
            after 1 ns;
         when a_cntl_5 =>
            addr_length_fifo_en_cld <= '1'
            after 1 ns;
            clk_cnt <= clk_cnt +1;
         when a_cntl_6 =>
            load_or_count_cld <= '1'
            after 1 ns;
            clk_cnt <= clk_cnt +1;
         when a_cntl_7 =>
            clk_cnt <= clk_cnt +1;
         when a_cntl_8 =>
            clk_cnt <= clk_cnt +1;
         when a_cntl_9 =>
            addr_length_fifo_en_cld <= '0'
            after 1 ns;
         when a_cntl_10 =>
            load_or_count_cld <= '0' 
            after 1 ns;
         when a_cntl_12 =>
            en_frm_cnt_up_cld <= '1'
            after 1 ns;
         when a_cntl_4 =>
            clk_cnt <= clk_cnt +1;
            -- readout_sync_out_sig_cld <= '0' 
            -- after 1 ns;
         when a_cntl_3 =>
            readout_sync_out_sig_cld <= '1' 
            after 1 ns;
         when a_cntl_17 =>
            readout_sync_out_sig_cld <= '0' 
            after 1 ns;
         when others =>
            null;
         end case;

      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      clk_cnt,
      current_state,
      frm_lenght_fifo_empty,
      rdout_sync_out_sig1,
      readout_sync_sig,
      store_frame_data_bus
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when a_cntl_0 =>
         if (readout_sync_sig = '1') then
            next_state <= a_cntl_1;
         else
            next_state <= a_cntl_0;
         end if;
      when a_cntl_1 =>
         if (frm_lenght_fifo_empty = '0') then
            next_state <= a_cntl_2;
         else
            next_state <= a_cntl_1;
         end if;
      when a_cntl_2 =>
            next_state <= a_cntl_3;
      when a_cntl_5 =>
            next_state <= a_cntl_6;
      when a_cntl_6 =>
            next_state <= a_cntl_7;
      when a_cntl_7 =>
            next_state <= a_cntl_8;
      when a_cntl_8 =>
         if (clk_cnt = 13) then
            next_state <= a_cntl_9;
         else
            next_state <= a_cntl_8;
         end if;
      when a_cntl_9 =>
            next_state <= a_cntl_10;
      when a_cntl_10 =>
            next_state <= a_cntl_11;
      when a_cntl_12 =>
         if (frm_lenght_fifo_empty = '0') then
            next_state <= a_cntl_14;
         elsif (frm_lenght_fifo_empty = '1') then
            next_state <= a_cntl_13;
         else
            next_state <= a_cntl_12;
         end if;
      when a_cntl_13 =>
            next_state <= a_cntl_0;
      when a_cntl_4 =>
         if (clk_cnt = 5) then
            next_state <= a_cntl_5;
         else
            next_state <= a_cntl_4;
         end if;
      when a_cntl_14 =>
            next_state <= a_cntl_15;
      when a_cntl_15 =>
            next_state <= a_cntl_16;
      when a_cntl_16 =>
            next_state <= a_cntl_2;
      when a_cntl_11 =>
         if (store_frame_data_bus = "00000000") then
            next_state <= a_cntl_12;
         else
            next_state <= a_cntl_11;
         end if;
      when a_cntl_3 =>
            next_state <= a_cntl_17;
      when a_cntl_17 =>
         if (rdout_sync_out_sig1 = '1') then
            next_state <= a_cntl_4;
         else
            next_state <= a_cntl_17;
         end if;
      when others =>
         next_state <= a_cntl_0;
      end case;

   end process nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   addr_length_fifo_en <= addr_length_fifo_en_cld;
   en_frm_cnt_up <= en_frm_cnt_up_cld;
   load_or_count <= load_or_count_cld;
   readout_sync_out_sig <= readout_sync_out_sig_cld;


end fsm;
