-- hds header_start
--
-- VHDL Architecture back_end_fpga.rd_decrement_one.rtl_rd_throttle
--
-- Created:
--          by - st79.UNKNOWN (TE2MALDIVES)
--          at - 16:17:27 03/03/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

entity rd_decrement_one1 is
   port( 
      back_pressure_B  : in     std_logic;
      clk2x            : in     std_logic;
      rd_length_int    : in     std_logic_vector (17 downto 0);
      rd_load_or_count : in     std_logic;
      rd_total_length  : in     std_logic_vector (17 downto 0);
      reset            : in     std_logic;
      rd_frm_data_1    : out    STD_ULOGIC;
      rd_length_1      : out    std_logic_vector (17 downto 0)
   );

-- Declarations

end rd_decrement_one1 ;


-- hds interface_end
ARCHITECTURE rtl_bak_pressure OF rd_decrement_one1 IS
BEGIN
process (reset, clk2x)
	variable frame_flag : std_logic;
	variable length_temp : unsigned (17 downto 0);
	begin
	if reset = '1' then
		length_temp := (others => '0');
		frame_flag := '0';
	elsif clk2x'event AND clk2x = '1' then
		if rd_load_or_count = '1' then					-- if in load mode
			length_temp := unsigned(rd_total_length);	-- put read address out
			frame_flag := '1';							-- set read data flag to '1' for data to be read from QDR.
		elsif back_pressure_B = '1' then				-- if in count mode and back_pressure_B = 1
			length_temp := unsigned(rd_length_int);		-- then get new length
			if length_temp > 1 then						-- if length is not one, then there is still data to be read from QDR.
				length_temp := length_temp - 1;			-- then decrement the length by one 
				frame_flag := '1';						-- '1' means read data, as there is still data to be read from QDR.
			else										-- if in count mode and length is one
				frame_flag := '0';						-- all data has been stored
				length_temp := (others => '0');			-- push out length zero onto shift register
			end if;
		else										--  operation is disabled by back_pressure_B = 0
			frame_flag := '0';						-- all data has been stored
		end if;
	end if;
	rd_length_1 <= std_logic_vector (length_temp) after 1 ns;	 -- push out new length onto shift register
	rd_frm_data_1 <= frame_flag after 1 ns;
	end process;

END rtl_bak_pressure;
