-- hds header_start
--
-- VHDL Entity CALICE_BE_fpga.rdout_mux8to1.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:55:14 08/11/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity rdout_mux8to1 is
   generic( 
      widthout : integer := 64
   );
   port( 
      clk2x    : in     std_logic;
      dout1    : in     std_logic_vector (63 downto 0);
      dout2    : in     std_logic_vector (63 downto 0);
      dout3    : in     std_logic_vector (63 downto 0);
      dout4    : in     std_logic_vector (63 downto 0);
      dout5    : in     std_logic_vector (63 downto 0);
      dout6    : in     std_logic_vector (63 downto 0);
      dout7    : in     std_logic_vector (63 downto 0);
      dout8    : in     std_logic_vector (63 downto 0);
      dout_rdy : in     std_logic;
      reset    : in     std_logic;
      fe_data  : out    std_logic_vector (63 downto 0)
   );

-- Declarations

end rdout_mux8to1 ;


-- hds interface_end

--
-- VHDL Architecture CALICE_BE_fpga.rdout_mux8to1.fsm
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:55:14 08/11/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

architecture fsm of rdout_mux8to1 is

   -- Architecture Declarations
   type state_type is (
      rdout0,
      rdout1,
      rdout2,
      rdout3,
      rdout4,
      rdout5,
      rdout6,
      rdout7
   );

   -- State vector declaration
   attribute state_vector : string;
   attribute state_vector of fsm : architecture is "current_state" ;


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

   -- Declare any pre-registered internal signals
   signal fe_data_cld : std_logic_vector (63 downto 0) ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      clk2x,
      reset
   )
   ----------------------------------------------------------------------------
   begin
      if (reset = '1') then
         current_state <= rdout0;
         -- Reset Values
         fe_data_cld <= (others => '0');
      elsif (clk2x'event and clk2x = '1') then
         current_state <= next_state;
         -- Default Assignment To Internals
         fe_data_cld <= (others => '0');

         -- Combined Actions for internal signals only
         case current_state is
         when rdout0 =>
            fe_data_cld <= (others => '0') ;
            if (dout_rdy = '1') then
               fe_data_cld <= dout1 
               after 1 ns;
            end if;
         when rdout1 =>
            fe_data_cld <= dout2 
            after 1 ns;
         when rdout2 =>
            fe_data_cld <= dout3 
            after 1 ns;
         when rdout3 =>
            fe_data_cld <= dout4
            after 1 ns ;
         when rdout4 =>
            fe_data_cld <= dout5 
            after 1 ns;
         when rdout5 =>
            fe_data_cld <= dout6 
            after 1 ns;
         when rdout6 =>
            fe_data_cld <= dout7
            after 1 ns;
         when rdout7 =>
            fe_data_cld <= dout8 
            after 1 ns;
         when others =>
            null;
         end case;

      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      current_state,
      dout_rdy
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when rdout0 =>
         if (dout_rdy = '1') then
            next_state <= rdout1;
         else
            next_state <= rdout0;
         end if;
      when rdout1 =>
            next_state <= rdout2;
      when rdout2 =>
            next_state <= rdout3;
      when rdout3 =>
            next_state <= rdout4;
      when rdout4 =>
            next_state <= rdout5;
      when rdout5 =>
            next_state <= rdout6;
      when rdout6 =>
            next_state <= rdout7;
      when rdout7 =>
            next_state <= rdout0;
      when others =>
         next_state <= rdout0;
      end case;

   end process nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   fe_data <= fe_data_cld;


end fsm;
