-- hds header_start
--
-- VHDL Entity CALICE_BE_fpga.SLINK_interface1.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 11:55:03 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity SLINK_interface1 is
   port( 
      clk2x                : in     std_logic;
      ctrl                 : in     std_logic;
      data_out             : in     std_logic_vector (63 downto 0);
      data_out_en          : in     std_logic;
      en_qdr_data_to_slink : in     std_logic;
      ready                : in     std_logic;
      reset                : in     std_logic;
      slink_lrl            : in     std_logic_vector (3 downto 0);
      slink_lsf            : in     std_logic_vector (3 downto 0);
      slink_uclk           : out    std_logic;
      slink_ucntl_b        : out    std_logic;
      slink_ud             : out    std_logic_vector (63 downto 0);
      slink_udw            : out    std_logic_vector (1 downto 0);
      slink_ureset_b       : out    std_logic;
      slink_usf            : out    std_logic_vector (3 downto 0);
      slink_utest_b        : out    std_logic;
      slink_uwen_b         : out    std_logic
   );

-- Declarations

end SLINK_interface1 ;


-- hds interface_end

--
-- VHDL Architecture CALICE_BE_fpga.SLINK_interface1.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 11:55:11 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

LIBRARY ieee;
USE ieee.std_logic_1164.all;

library unisim;

architecture struct of SLINK_interface1 is

   -- Architecture declarations

   -- Internal signal declarations
   signal clk2x_slink_b : std_logic;
   signal ctrl_b        : std_logic;
   signal data_out_en_b : std_logic;
   signal high          : std_logic := '0';
   signal low           : std_logic := '0';
   signal slink_status  : std_logic_vector(7 downto 0);


   -- Component Declarations
   component FDCE
   port (
      C   : in     STD_ULOGIC;
      CE  : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D   : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component FDCPE
   port (
      C   : in     STD_ULOGIC;
      CE  : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D   : in     STD_ULOGIC;
      PRE : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component fddrcpe
   port (
      C0  : in     STD_ULOGIC;
      C1  : in     STD_ULOGIC;
      CE  : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D0  : in     STD_ULOGIC;
      D1  : in     STD_ULOGIC;
      PRE : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : FDCE use entity unisim.FDCE;
   for all : FDCPE use entity unisim.FDCPE;
   for all : fddrcpe use entity unisim.fddrcpe;
   -- pragma synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb1
   -- for test only , keep zeros
   slink_usf <= "0000" AND slink_lsf AND slink_lrl;
   
   slink_udw <= "11";
   slink_utest_b <= '1';
   
   slink_status <= slink_lsf & slink_lrl;
   
   high <= '1';
   low <= '0';


   -- ModuleWare code for instance 'I0' of 'inv'
      slink_ureset_b <= not(reset);

   -- ModuleWare code for instance 'I7' of 'inv'
      ctrl_b <= not(ctrl);

   -- ModuleWare code for instance 'I4' of 'inv'
      data_out_en_b <= not(data_out_en);

   -- ModuleWare code for instance 'I2' of 'inv'
      clk2x_slink_b <= not(clk2x);
   -- Instance port mappings.
   I3 : FDCPE
      port map (
         Q   => slink_uwen_b,
         C   => clk2x,
         CE  => en_qdr_data_to_slink,
         CLR => low,
         D   => data_out_en_b,
         PRE => reset
      );
   I5 : FDCPE
      port map (
         Q   => slink_ucntl_b,
         C   => clk2x,
         CE  => en_qdr_data_to_slink,
         CLR => low,
         D   => ctrl_b,
         PRE => reset
      );
   I1 : fddrcpe
      port map (
         Q   => slink_uclk,
         C0  => clk2x,
         C1  => clk2x_slink_b,
         CE  => high,
         D0  => low,
         D1  => high,
         CLR => reset,
         PRE => low
      );

   g6: FOR i IN 0 TO 63 GENERATE
      I6 : FDCE
         port map (
            Q   => slink_ud(i),
            C   => clk2x,
            CE  => en_qdr_data_to_slink,
            CLR => reset,
            D   => data_out(i)
         );
   end generate g6;

end struct;
