-- hds header_start
--
-- VHDL Entity CERC_lib.trig_count_reg.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 14:57:36 04/15/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity trig_count_reg is
   port( 
      clk     : in     std_logic;
      rd_i    : in     std_logic;
      rst     : in     std_logic;
      rw_en_i : in     std_logic;
      sig     : in     std_logic;
      wr_i    : in     std_logic;
      db_oz   : out    std_logic_vector (31 downto 0)
   );

-- Declarations

end trig_count_reg ;


-- hds interface_end

--
-- VHDL Architecture CERC_lib.trig_count_reg.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 14:57:36 04/15/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library CERC_lib;

architecture struct of trig_count_reg is

   -- Architecture declarations

   -- Internal signal declarations
   signal ONE         : std_logic;
   signal ZERO        : std_logic;
   signal count       : std_logic_vector(31 downto 0);
   signal count_en    : std_logic;
   signal db_oe       : std_logic;
   signal rst_counter : std_logic;
   signal wr_en       : std_logic;


   -- Component Declarations
   component counter32
   port (
      clk        : in     std_logic ;
      rst        : in     std_logic ;
      count_en_i : in     std_logic ;
      count_o    : out    std_logic_vector (31 downto 0)
   );
   end component;
   component edgedet
   port (
      clk     : in     std_logic ;
      rst     : in     std_logic ;
      sig     : in     std_logic ;
      rising  : out    std_logic ;
      falling : out    std_logic 
   );
   end component;
   component m_and2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_or2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : counter32 use entity CERC_lib.counter32;
   for all : edgedet use entity CERC_lib.edgedet;
   for all : m_and2 use entity CERC_lib.m_and2;
   for all : m_or2 use entity CERC_lib.m_or2;
   -- pragma synthesis_on


begin

   -- ModuleWare code for instance 'tribuf_1' of 'tribuf'
   
   tribuf_1combo: process (count, db_oe)
   begin
      if (db_oe = '0' or db_oe = 'L') then
         db_oz <= (others => 'Z');
      elsif (db_oe = '1' or db_oe = 'H') then
         db_oz <= count;
      else
         db_oz <= (others => 'X');
      end if;
   end process tribuf_1combo;

   -- ModuleWare code for instance 'vdd_1' of 'vdd'
      ONE <= '1';

   -- ModuleWare code for instance 'gnd_1' of 'gnd'
      ZERO <= '0';
   -- Instance port mappings.
   counter32_1 : counter32
      port map (
         clk        => clk,
         rst        => rst_counter,
         count_en_i => count_en,
         count_o    => count
      );
   edgedet_1 : edgedet
      port map (
         clk     => clk,
         rst     => rst,
         sig     => sig,
         rising  => count_en,
         falling => open
      );
   m_and2_1 : m_and2
      port map (
         I1 => wr_i,
         I2 => rw_en_i,
         O  => wr_en
      );
   m_and2_2 : m_and2
      port map (
         I1 => rw_en_i,
         I2 => rd_i,
         O  => db_oe
      );
   m_or2_1 : m_or2
      port map (
         I1 => rst,
         I2 => wr_en,
         O  => rst_counter
      );

end struct;
