-- hds header_start
--
-- VHDL Entity CERC_trig.trig_fifo.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 00:30:56 10/07/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity trig_fifo is
   port( 
      busy_trig    : in     std_logic;
      clk          : in     std_logic;
      fifo_din     : in     std_logic_vector (31 downto 0);
      fifo_read_en : in     std_logic;
      fifo_stat_en : in     std_logic;
      rd_i         : in     std_logic;
      rst          : in     std_logic;
      db_oz        : out    std_logic_vector (31 downto 0)
   );

-- Declarations

end trig_fifo ;


-- hds interface_end

--
-- VHDL Architecture CERC_trig.trig_fifo.sync1kx32
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 00:30:57 10/07/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library CERC_lib;

architecture sync1kx32 of trig_fifo is

   -- Architecture declarations

   -- Internal signal declarations
   signal O            : std_logic;
   signal busy_falling : std_logic;
   signal busy_trig_n  : std_logic;
   signal depth        : std_logic_VECTOR(6 downto 0);
   signal depth_64     : std_logic;
   signal dout         : std_logic_vector(6 downto 0);
   signal empty        : std_logic;
   signal fifo_db_out  : std_logic_VECTOR(31 downto 0);
   signal fifo_rd      : std_logic;
   signal fifo_rd_q    : std_logic;
   signal fifo_stat_rd : std_logic;
   signal full         : std_logic;
   signal rd_en        : std_logic;
   signal rotate       : std_logic;
   signal status       : std_logic_vector(31 downto 0);
   signal wr_en        : std_logic;


   -- ModuleWare signal declarations for instance 'mw_rsff_1' of 'rsff'
   signal MW_mw_rsff_1cregl : std_logic;

   -- Component Declarations
   component cg_fifo128x32
   port (
      clk        : in     std_logic ;
      sinit      : in     std_logic ;
      din        : in     std_logic_VECTOR (31 downto 0);
      wr_en      : in     std_logic ;
      rd_en      : in     std_logic ;
      dout       : out    std_logic_VECTOR (31 downto 0);
      full       : out    std_logic ;
      empty      : out    std_logic ;
      data_count : out    std_logic_VECTOR (6 downto 0)
   );
   end component;
   component edgedet
   port (
      clk     : in     std_logic ;
      rst     : in     std_logic ;
      sig     : in     std_logic ;
      rising  : out    std_logic ;
      falling : out    std_logic 
   );
   end component;
   component m_and2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_dff
   port (
      D  : in     std_logic ;
      c  : in     std_logic ;
      r  : in     std_logic ;
      Q  : out    std_logic ;
      Qn : out    std_logic 
   );
   end component;
   component m_mininv
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;
   component m_or2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : cg_fifo128x32 use entity CERC_lib.cg_fifo128x32;
   for all : edgedet use entity CERC_lib.edgedet;
   for all : m_and2 use entity CERC_lib.m_and2;
   for all : m_dff use entity CERC_lib.m_dff;
   for all : m_mininv use entity CERC_lib.m_mininv;
   for all : m_or2 use entity CERC_lib.m_or2;
   -- pragma synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 2 merge
   status(31 downto 18) 
     <= (others => '0');
   status(17) <= full;
   status(16) <= empty;
   status(15 downto 7) 
      <= (others => '0');
   status( 6 downto  0) 
      <= depth;


   -- ModuleWare code for instance 'tribuf_1' of 'tribuf'
   
   tribuf_1combo: process (fifo_db_out, fifo_rd_q)
   begin
      if (fifo_rd_q = '0') then
         db_oz <= (others => 'Z');
      elsif (fifo_rd_q = '1') then
         db_oz <= fifo_db_out;
      else
         db_oz <= (others => 'X');
      end if;
   end process tribuf_1combo;

   -- ModuleWare code for instance 'tribuf_2' of 'tribuf'
   
   tribuf_2combo: process (status, fifo_stat_rd)
   begin
      if (fifo_stat_rd = '0') then
         db_oz <= (others => 'Z');
      elsif (fifo_stat_rd = '1') then
         db_oz <= status;
      else
         db_oz <= (others => 'X');
      end if;
   end process tribuf_2combo;

   -- ModuleWare code for instance 'comp_1' of 'comp'
   
   comp_1seq: process (depth, dout)
   variable lout : std_logic;
     begin
      lout := '0';
      if (depth = dout) then
         lout := '1';
      end if;
      depth_64 <= lout;
     end process comp_1seq;

   -- ModuleWare code for instance 'constval_64' of 'constval'
      dout <= "1000000";

   -- ModuleWare code for instance 'mw_rsff_1' of 'rsff'
   wr_en <= MW_mw_rsff_1cregl;
   -- synopsys sync_set_reset_local of mw_rsff_1seq "rst"
   mw_rsff_1seq: process (clk)
   begin
      if (clk'event and clk='1') then
         if (rst = '1') then
            MW_mw_rsff_1cregl <= '0';
         elsif (full = '1') then
         MW_mw_rsff_1cregl <= '0';
         elsif (busy_trig_n = '1') then
         MW_mw_rsff_1cregl <= '1';
         end if;
   end if;
   end process mw_rsff_1seq;
   -- Instance port mappings.
   cg_fifo128x32_1 : cg_fifo128x32
      port map (
         clk        => clk,
         sinit      => O,
         din        => fifo_din,
         wr_en      => wr_en,
         rd_en      => rd_en,
         dout       => fifo_db_out,
         full       => full,
         empty      => empty,
         data_count => depth
      );
   edgedet_1 : edgedet
      port map (
         clk     => clk,
         rst     => rst,
         sig     => busy_trig,
         rising  => open,
         falling => busy_falling
      );
   m_and2_1 : m_and2
      port map (
         I1 => depth_64,
         I2 => busy_trig_n,
         O  => rotate
      );
   m_and2_2 : m_and2
      port map (
         I1 => fifo_stat_en,
         I2 => rd_i,
         O  => fifo_stat_rd
      );
   m_and2_3 : m_and2
      port map (
         I1 => fifo_read_en,
         I2 => rd_i,
         O  => fifo_rd
      );
   m_dff_1 : m_dff
      port map (
         D  => fifo_rd,
         c  => clk,
         r  => rst,
         Q  => fifo_rd_q,
         Qn => open
      );
   I1 : m_mininv
      port map (
         I => busy_trig,
         O => busy_trig_n
      );
   I0 : m_or2
      port map (
         I1 => rotate,
         I2 => fifo_rd,
         O  => rd_en
      );
   I2 : m_or2
      port map (
         I1 => busy_falling,
         I2 => rst,
         O  => O
      );

end sync1kx32;
