-- hds header_start
--
-- VHDL Entity CERC_trig.trigin_control.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 00:30:57 10/07/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity trigin_control is
   port( 
      clk            : in     std_logic;
      clr_busy_i     : in     std_logic;
      reg_input_en   : in     std_logic_vector (31 downto 0);
      rst            : in     std_logic;
      trig_cmd_i     : in     std_logic;
      trig_ext0_i    : in     std_logic;
      trig_ext1_i    : in     std_logic;
      trig_ext2_i    : in     std_logic;
      trig_ext3_i    : in     std_logic;
      trig_osc_i     : in     std_logic;
      reg_input_stat : out    std_logic_vector (31 downto 0);
      trigin_busy_o  : out    std_logic;
      trigin_out     : out    std_logic;
      trigin_sync_o  : out    std_logic
   );

-- Declarations

end trigin_control ;


-- hds interface_end

--
-- VHDL Architecture CERC_trig.trigin_control.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 00:30:58 10/07/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use IEEE.VITAL_Timing.ALL;

library CERC_lib;
library unisim;

architecture struct of trigin_control is

   -- Architecture declarations

   -- Internal signal declarations
   signal ONE             : std_logic;
   signal ZERO            : std_logic;
   signal trig_ext0       : std_logic;
   signal trig_ext1       : std_logic;
   signal trig_ext2       : std_logic;
   signal trig_ext3       : std_logic;
   signal trig_osc        : std_logic;
   signal trigin_latch    : std_logic;
   signal trigin_latch_q  : std_logic;
   signal trigin_latch_q2 : std_logic;
   signal trigin_raw      : std_logic;
   signal trigin_raw_bufg : std_logic;

   -- Implicit buffer signal declarations
   signal trigin_out_internal : std_logic;


   -- Component Declarations
   component BUFG
   generic (
      TimingChecksOn : Boolean          := TRUE;
      InstancePath   : STRING           := "*";
      Xon            : Boolean          := True;
      MsgOn          : Boolean          := False;
      tpd_I_O        : VitalDelayType01 := (0.100 ns, 0.100 ns);
      tipd_I         : VitalDelayType01 := (0.000 ns, 0.000 ns)
   );
   port (
      O : out    STD_ULOGIC ;
      I : in     STD_ULOGIC 
   );
   end component;
   component enable7
   port (
      en0 : in     std_logic ;
      in0 : in     std_logic ;
      o0  : out    std_logic ;
      en1 : in     std_logic ;
      in1 : in     std_logic ;
      o1  : out    std_logic ;
      en2 : in     std_logic ;
      in2 : in     std_logic ;
      o2  : out    std_logic ;
      en3 : in     std_logic ;
      in3 : in     std_logic ;
      o3  : out    std_logic ;
      en4 : in     std_logic ;
      in4 : in     std_logic ;
      o4  : out    std_logic ;
      en5 : in     std_logic ;
      in5 : in     std_logic ;
      o5  : out    std_logic ;
      en6 : in     std_logic ;
      in6 : in     std_logic ;
      o6  : out    std_logic 
   );
   end component;
   component latch_sr
   port (
      S    : in     std_logic ;
      R    : in     std_logic ;
      init : in     std_logic ;
      O    : out    std_logic 
   );
   end component;
   component m_and2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_dff
   port (
      D  : in     std_logic ;
      c  : in     std_logic ;
      r  : in     std_logic ;
      Q  : out    std_logic ;
      Qn : out    std_logic 
   );
   end component;
   component m_or6
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      I3 : in     std_logic ;
      I4 : in     std_logic ;
      I5 : in     std_logic ;
      I6 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_power
   port (
      ONE  : out    std_logic ;
      ZERO : out    std_logic 
   );
   end component;
   component simpsync
   port (
      async : in     std_logic ;
      clk   : in     std_logic ;
      sync  : out    std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : BUFG use entity unisim.BUFG;
   for all : enable7 use entity CERC_lib.enable7;
   for all : latch_sr use entity CERC_lib.latch_sr;
   for all : m_and2 use entity CERC_lib.m_and2;
   for all : m_dff use entity CERC_lib.m_dff;
   for all : m_or6 use entity CERC_lib.m_or6;
   for all : m_power use entity CERC_lib.m_power;
   for all : simpsync use entity CERC_lib.simpsync;
   -- pragma synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 7 reg_in_stat_map
   -- trig_status_map
   reg_input_stat(0) <= trig_ext0_i;
   reg_input_stat(1) <= trig_ext1_i;
   reg_input_stat(2) <= trig_ext2_i;
   reg_input_stat(3) <= trig_ext3_i;
   
   reg_input_stat(7 downto 4) <= (others => '0');
   
   reg_input_stat(8) <= trig_ext0;
   reg_input_stat(9) <= trig_ext1;
   reg_input_stat(10) <= trig_ext2;
   reg_input_stat(11) <= trig_ext3;
   
   
   reg_input_stat(15 downto 12) <= (others => '0');
   
   reg_input_stat(16) <= trigin_raw;
   reg_input_stat(17) <= trigin_out_internal;
   
   reg_input_stat(23 downto 18) <= (others => '0');
                                                   
   reg_input_stat(24) <= trig_osc;
   
   reg_input_stat(31 downto 25) <= (others => '0');

   -- Instance port mappings.
   BUFG_3 : BUFG
      generic map (
         TimingChecksOn => TRUE,
         InstancePath   => "*",
         Xon            => True,
         MsgOn          => False,
         tpd_I_O        => (0.100 ns, 0.100 ns),
         tipd_I         => (0.000 ns, 0.000 ns)
      )
      port map (
         O => trigin_raw_bufg,
         I => trigin_raw
      );
   enable7_1 : enable7
      port map (
         en0 => reg_input_en(0),
         in0 => trig_ext0_i,
         o0  => trig_ext0,
         en1 => reg_input_en(1),
         in1 => trig_ext1_i,
         o1  => trig_ext1,
         en2 => reg_input_en(2),
         in2 => trig_ext2_i,
         o2  => trig_ext2,
         en3 => reg_input_en(3),
         in3 => trig_ext3_i,
         o3  => trig_ext3,
         en4 => ZERO,
         in4 => ZERO,
         o4  => open,
         en5 => ZERO,
         in5 => ZERO,
         o5  => open,
         en6 => reg_input_en(24),
         in6 => trig_osc_i,
         o6  => trig_osc
      );
   latch_sr_1 : latch_sr
      port map (
         S    => trigin_raw_bufg,
         R    => clr_busy_i,
         init => rst,
         O    => trigin_latch
      );
   m_and2_2 : m_and2
      port map (
         I1 => trigin_latch,
         I2 => trigin_latch_q2,
         O  => trigin_out_internal
      );
   m_dff_3 : m_dff
      port map (
         D  => trigin_latch,
         c  => clk,
         r  => rst,
         Q  => trigin_latch_q,
         Qn => open
      );
   m_dff_4 : m_dff
      port map (
         D  => trigin_latch_q,
         c  => clk,
         r  => rst,
         Q  => open,
         Qn => trigin_latch_q2
      );
   m_or6_1 : m_or6
      port map (
         I1 => trig_cmd_i,
         I2 => trig_ext0,
         I3 => trig_ext1,
         I4 => trig_ext2,
         I5 => trig_ext3,
         I6 => trig_osc,
         O  => trigin_raw
      );
   m_power_1 : m_power
      port map (
         ONE  => ONE,
         ZERO => ZERO
      );
   simpsync_1 : simpsync
      port map (
         async => trigin_out_internal,
         clk   => clk,
         sync  => trigin_sync_o
      );
   simpsync_2 : simpsync
      port map (
         async => trigin_latch,
         clk   => clk,
         sync  => trigin_busy_o
      );

   -- Implicit buffered output assignments
   trigin_out <= trigin_out_internal;

end struct;
