-- hds header_start
--
-- VHDL Entity CALICE_BE_fpga.tst_data_gen1.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 11:54:11 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity tst_data_gen1 is
   port( 
      clk2x            : in     std_logic;
      qdr_test_data_en : in     std_logic_vector (1 downto 0);
      qdr_wr_addr_en_1 : in     std_logic;
      reset            : in     std_logic;
      qdr_test_pattern : out    std_logic_vector (71 downto 0)
   );

-- Declarations

end tst_data_gen1 ;


-- hds interface_end

--
-- VHDL Architecture CALICE_BE_fpga.tst_data_gen1.fsm
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 11:54:11 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

architecture fsm of tst_data_gen1 is

   -- Architecture Declarations
   signal count : integer := 0;

   type state_type is (
      tst_data0,
      tst_data1,
      tst_data2
   );

   -- State vector declaration
   attribute state_vector : string;
   attribute state_vector of fsm : architecture is "current_state" ;


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

   -- Declare any pre-registered internal signals
   signal qdr_test_pattern_cld : std_logic_vector (71 downto 0) ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      clk2x,
      reset
   )
   ----------------------------------------------------------------------------
   begin
      if (reset = '1') then
         current_state <= tst_data0;
         -- Reset Values
         qdr_test_pattern_cld <= (others => '0');
         count <= 0;
      elsif (clk2x'event and clk2x = '1') then
         current_state <= next_state;
         -- Default Assignment To Internals
         count <= 0;

         -- Combined Actions for internal signals only
         case current_state is
         when tst_data0 =>
            qdr_test_pattern_cld <= (others => '0');
            count <= 0;
            if (qdr_test_data_en = "10" 
            AND qdr_wr_addr_en_1 = '0') then
               qdr_test_pattern_cld <= "101010101010101010101010101010101010"
               & "101010101010101010101010101010101010"  after 1 ns;
               count <= (count + 1) after 1 ns;
            end if;
         when tst_data1 =>
            qdr_test_pattern_cld <= "101010101010101010101010101010101010"
            & "101010101010101010101010101010101010"  after 1 ns;
            count <= (count + 1) after 1 ns;
            if (qdr_wr_addr_en_1 = '1') then
            elsif (count = 7) then
               count <= 0;
            end if;
         when tst_data2 =>
            qdr_test_pattern_cld <= "010101010101010101010101010101010101"
            & "010101010101010101010101010101010101"  after 1 ns;
            count <= (count + 1) after 1 ns;
            if (qdr_wr_addr_en_1 = '1') then
            elsif (count = 7) then
               count <= 0;
            end if;
         when others =>
            null;
         end case;

      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      count,
      current_state,
      qdr_test_data_en,
      qdr_wr_addr_en_1
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when tst_data0 =>
         if (qdr_test_data_en = "10" 
         AND qdr_wr_addr_en_1 = '0') then
            next_state <= tst_data1;
         else
            next_state <= tst_data0;
         end if;
      when tst_data1 =>
         if (qdr_wr_addr_en_1 = '1') then
            next_state <= tst_data0;
         elsif (count = 7) then
            next_state <= tst_data2;
         else
            next_state <= tst_data1;
         end if;
      when tst_data2 =>
         if (qdr_wr_addr_en_1 = '1') then
            next_state <= tst_data0;
         elsif (count = 7) then
            next_state <= tst_data1;
         else
            next_state <= tst_data2;
         end if;
      when others =>
         next_state <= tst_data0;
      end case;

   end process nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   qdr_test_pattern <= qdr_test_pattern_cld;


end fsm;
