-- hds header_start
--
-- VHDL Entity CALICE_BE_fpga.vme_cntrl_status.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 14:14:14 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_arith.ALL;

entity vme_cntrl_status is
   port( 
      L1A_count             : in     std_logic_vector (23 downto 0);
      TTC_rst_frm_vme_b     : in     std_logic;
      bx_count              : in     std_logic_vector (11 downto 0);
      calice_cmd_in         : in     std_logic;
      clk1x                 : in     std_logic;
      clk2x                 : in     std_logic;
      config_in             : in     std_logic_vector (8 downto 1);
      empty_flags           : in     std_logic_vector (7 downto 0);
      full_flags            : in     std_logic_vector (7 downto 0);
      half_full_flags       : in     std_logic_vector (7 downto 0);
      internal_freeze_bar   : in     std_logic;
      local_vme_read        : in     std_logic;
      local_vme_write       : in     std_logic;
      partial_empty_flags   : in     std_logic_vector (7 downto 0);
      partial_full_flags    : in     std_logic_vector (7 downto 0);
      qdr_data_count        : in     std_logic_vector (17 downto 0);
      qdr_frame_count       : in     std_logic_vector (23 downto 0);
      reset                 : in     std_logic;
      rst                   : in     std_logic;
      slink_ldown_b         : in     std_logic;
      slink_lff_b           : in     std_logic;
      temp_int_b            : in     std_logic;
      total_frame_count     : in     std_logic_vector (23 downto 0);
      ttc_broadcast_command : in     std_logic_vector (12 downto 0);
      ttc_ready             : in     std_logic;
      ttc_single_command    : in     std_logic_vector (38 downto 0);
      vme_command_in        : in     std_logic;
      vme_spare_in          : in     std_logic_vector (5 downto 1);
      vme_throttle          : in     std_logic;
      FE_enable_reg         : out    std_logic_vector (8 downto 1);
      FE_frame_sync_en      : out    std_logic_vector (8 downto 1);
      apv_frame_en          : out    std_logic;
      back_pressure_B       : out    std_logic;
      be_status_reg         : out    std_logic_vector (31 downto 0);
      calice_cmd_out        : out    std_logic;
      config_out            : out    std_logic_vector (8 downto 1);
      en_fe_data_capture    : out    std_logic;
      en_qdr_data_to_slink  : out    std_logic;
      en_qdr_data_to_vme    : out    std_logic;
      en_trigger            : out    std_logic;
      fed_id_reg            : out    std_logic_vector (11 downto 0);
      lm82_scl              : out    std_logic;
      mode_reg              : out    std_logic_vector (3 downto 0);
      qdr_test_data_en      : out    std_logic_vector (1 downto 0);
      sel_trig_source       : out    std_logic_vector (2 downto 0);
      sw_reset              : out    std_logic;
      sw_trigger            : out    std_logic;
      throttle_en           : out    std_logic;
      ttc_reset_b           : out    std_logic;
      ttc_scl               : out    std_logic;
      vme_command_out       : out    std_logic;
      lm82_sda              : inout  std_logic;
      ttc_sda               : inout  std_logic
   );

-- Declarations

end vme_cntrl_status ;


-- hds interface_end

--
-- VHDL Architecture CALICE_BE_fpga.vme_cntrl_status.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 14:14:42 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_arith.ALL;

library CALICE_BE_fpga;
library unisim;

architecture struct of vme_cntrl_status is

   -- Architecture declarations

   -- Internal signal declarations
   signal BE_cmnd_out       : std_logic;
   signal BE_cmnd_out1      : std_logic;
   signal FE_disable_reg_1  : std_logic_vector(8 downto 1);
   signal TTC_control       : std_logic_vector(15 downto 0);
   signal back_pressure_int : std_logic;
   signal be_rdout_cntl     : std_logic_vector(1 downto 0);
   signal be_rdout_cntl_1   : std_logic_vector(1 downto 0);
   signal be_run_cntl       : std_logic_vector(1 downto 0);
   signal be_run_cntl_1     : std_logic_vector(1 downto 0);
   signal be_status_reg_1   : std_logic_vector(31 downto 0);
   signal command_out       : std_logic;
   signal data_valid        : std_logic;
   signal fed_id_reg_1      : std_logic_vector(11 downto 0);
   signal firmware_id_reg   : std_logic_vector(31 downto 0);
   signal int_throttle      : std_logic;
   signal intl_frze_bar_1   : std_logic;
   signal lm82_cntl         : std_logic_vector(16 downto 0);
   signal lm82_cntl_1       : std_logic_vector(16 downto 0);
   signal lm82_i2c_en       : std_logic;
   signal lm82_status       : std_logic_vector(15 downto 0);
   signal mode_reg_1        : std_logic_vector(3 downto 0);
   signal sw_reset1         : std_logic;
   signal sw_trigger_1      : std_logic;
   signal test_register     : std_logic_vector(31 downto 0);
   signal test_register1    : std_logic_vector(31 downto 0);
   signal trigger_select_1  : std_logic_vector(2 downto 0);
   signal ttc_i2c_en        : std_logic;
   signal ttc_reset_b_1     : std_logic;
   signal ttc_rx_i2c_1      : std_logic_vector(15 downto 0);
   signal ttc_rx_rst_1      : std_logic;
   signal ttc_status        : std_logic_vector(15 downto 0);

   -- Implicit buffer signal declarations
   signal FE_enable_reg_internal        : std_logic_vector (8 downto 1);
   signal throttle_en_internal          : std_logic;
   signal back_pressure_B_internal      : std_logic;
   signal be_status_reg_internal        : std_logic_vector (31 downto 0);
   signal en_qdr_data_to_vme_internal   : std_logic;
   signal en_qdr_data_to_slink_internal : std_logic;


   -- ModuleWare signal declarations for instance 'I3' of 'split'
   signal MW_I3dinl : std_logic_vector(1 downto 0);

   -- ModuleWare signal declarations for instance 'I4' of 'split'
   signal MW_I4dinl : std_logic_vector(1 downto 0);

   -- Component Declarations
   component BE_cmnd_decoder
   port (
      -- // parameter RESET_LENGTH = 16; // Number of zeros that constitute a reset
      -- 
      -- // Internal Declarations
      clk               : in     std_logic ;
      -- // parameter RESET_LENGTH = 16; // Number of zeros that constitute a reset
      -- 
      -- // Internal Declarations
      rst               : in     std_logic ;
      -- // parameter RESET_LENGTH = 16; // Number of zeros that constitute a reset
      -- 
      -- // Internal Declarations
      command_in        : in     std_logic ;
      command_out       : out    std_logic ;
      command_real      : out    std_logic ;
      trigger_select    : out    std_logic_vector (2 downto 0);
      mode_reg          : out    std_logic_vector (3 downto 0);
      ttc_rx_cntl       : out    std_logic_vector (15 downto 0); -- // TTCrx control register
      test_reg          : out    std_logic_vector (31 downto 0);
      fe_enable_reg     : out    std_logic_vector (7 downto 0);
      be_rdout_cntl     : out    std_logic_vector (1 downto 0);
      be_run_cntl       : out    std_logic_vector (1 downto 0);
      sw_trigger        : out    std_logic ;
      soft_rst          : out    std_logic ;
      fed_id_reg        : out    std_logic_vector (11 downto 0);
      ttc_rx_rst        : out    std_logic ;
      lm82_cntl         : out    std_logic_vector (16 downto 0); -- // LM82 control register
      be_status_reg     : in     std_logic_vector (31 downto 0); -- // Back end status register
      rd_L1A_count      : in     std_logic_vector (23 downto 0); -- // read L1A counter
      rd_bx_count       : in     std_logic_vector (11 downto 0); -- // read bunch crossing counter
      qdr_frame_count   : in     std_logic_vector (23 downto 0); -- // read QDR frame counter
      TTC_ready         : in     std_logic ;                     -- // read TTC ready signal
      firmware_id_reg   : in     std_logic_vector (31 downto 0); -- // read user code
      qdr_data_count    : in     std_logic_vector (17 downto 0); -- // read QDR data counter
      total_frame_count : in     std_logic_vector (23 downto 0); -- // read total frame counter
      ttc_status        : in     std_logic_vector (15 downto 0); -- // read TTCrx I2C data in
      ttc_i2c_en        : out    std_logic ;
      lm82_status       : in     std_logic_vector (15 downto 0); -- // read LM82 I2C data in
      lm82_i2c_en       : out    std_logic ;
      data_valid        : out    std_logic ;
      ttc_single_cmnd   : in     std_logic_vector (38 downto 0); -- // read ttc single command/data reg read only
      ttc_brdcst_cmnd   : in     std_logic_vector (12 downto 0)  -- // read ttc broadcast command/data read only
   );
   end component;
   component FDC
   port (
      C   : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D   : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component FDCE
   port (
      C   : in     STD_ULOGIC;
      CE  : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D   : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component INV
   port (
      I : in     STD_ULOGIC;
      O : out    STD_ULOGIC
   );
   end component;
   component OR2
   port (
      I0 : in     STD_ULOGIC;
      I1 : in     STD_ULOGIC;
      O  : out    STD_ULOGIC
   );
   end component;
   component gen_sw_rst
   port (
      clk1x      : in     std_logic ;
      data_valid : in     std_logic ;
      rst        : in     std_logic ;
      sw_reset1  : in     std_logic ;
      sw_reset   : out    std_logic 
   );
   end component;
   component gen_ttc_rx_rst
   port (
      TTC_rst_frm_vme_b : in     std_logic ;
      clk1x             : in     std_logic ;
      rst               : in     std_logic ;
      ttc_rx_rst_1      : in     std_logic ;
      ttc_reset_b_1     : out    std_logic 
   );
   end component;
   component i2c_lm82
   port (
      i2c_init     : in     std_logic ;
      i2c_rst      : in     std_logic ;
      iclk40       : in     std_logic ;
      lm82_control : in     std_logic_vector (16 downto 0);
      lm82_status  : out    std_logic_vector (15 downto 0);
      scl          : out    std_logic ;
      sda          : inout  std_logic 
   );
   end component;
   component i2c_ttc
   port (
      TTC_control : in     std_logic_vector (15 downto 0);
      i2c_init    : in     std_logic ;
      i2c_rst     : in     std_logic ;
      iclk40      : in     std_logic ;
      scl         : out    std_logic ;
      ttc_status  : out    std_logic_vector (15 downto 0);
      sda         : inout  std_logic 
   );
   end component;
   component serial_router
   port (
      clk          : in     std_logic ;
      cmnd_in_a    : in     std_logic ;
      cmnd_in_b    : in     std_logic ;
      cmnd_in_c    : in     std_logic ;
      cmnd_in_d    : in     std_logic ;
      cmnd_in_e    : in     std_logic ;
      cmnd_in_f    : in     std_logic ;
      cmnd_in_g    : in     std_logic ;
      cmnd_in_h    : in     std_logic ;
      cmnd_in_i    : in     std_logic ;
      cmnd_in_j    : in     std_logic ;
      comnd_in     : in     std_logic ;
      rst          : in     std_logic ;
      cmnd_out_a   : out    std_logic ;
      cmnd_out_b   : out    std_logic ;
      cmnd_out_c   : out    std_logic ;
      cmnd_out_d   : out    std_logic ;
      cmnd_out_e   : out    std_logic ;
      cmnd_out_f   : out    std_logic ;
      cmnd_out_g   : out    std_logic ;
      cmnd_out_h   : out    std_logic ;
      cmnd_out_i   : out    std_logic ;
      cmnd_out_j   : out    std_logic ;
      data_from_FE : out    std_logic 
   );
   end component;
   component throttle_select
   port (
      clk2x                : in     std_logic ;
      en_qdr_data_to_slink : in     std_logic ;
      en_qdr_data_to_vme   : in     std_logic ;
      rst                  : in     std_logic ;
      slink_ldown_b        : in     std_logic ;
      slink_lff_b          : in     std_logic ;
      vme_throttle         : in     std_logic ;
      int_throttle         : out    std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : FDC use entity unisim.FDC;
   for all : FDCE use entity unisim.FDCE;
   for all : INV use entity unisim.INV;
   for all : OR2 use entity unisim.OR2;
   for all : gen_sw_rst use entity CALICE_BE_fpga.gen_sw_rst;
   for all : gen_ttc_rx_rst use entity CALICE_BE_fpga.gen_ttc_rx_rst;
   for all : i2c_lm82 use entity CALICE_BE_fpga.i2c_lm82;
   for all : i2c_ttc use entity CALICE_BE_fpga.i2c_ttc;
   for all : serial_router use entity CALICE_BE_fpga.serial_router;
   for all : throttle_select use entity CALICE_BE_fpga.throttle_select;
   -- pragma synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb4
   BE_cmnd_out1 <= BE_cmnd_out after 1 ns;
   
   be_status_reg_1 <= 
   (empty_flags & 
   half_full_flags & 
   full_flags &
   "000" & back_pressure_int & NOT(slink_lff_b) & NOT(slink_ldown_b) &
    NOT(internal_freeze_bar) & NOT(temp_int_b)) after 1 ns;
   
   -- user code = 12000244
   firmware_id_reg <= "00010010" & "00000000" & "00000010" & "01000100";

   -- HDL Embedded Text Block 2 eb1
   apv_frame_en <= test_register(0);
   throttle_en_internal <= test_register(1);
   qdr_test_data_en <= test_register(3 downto 2);

   -- HDL Embedded Text Block 3 eb2
   ttc_reset_b <= (ttc_reset_b_1 ) after 2 ns;


   -- ModuleWare code for instance 'I3' of 'split'
   MW_I3dinl <= be_run_cntl;
   en_trigger <= MW_I3dinl(0);
   en_fe_data_capture <= MW_I3dinl(1);

   -- ModuleWare code for instance 'I0' of 'buff'
   FE_frame_sync_en <= FE_enable_reg_internal;

   -- ModuleWare code for instance 'I2' of 'buff'
   sw_trigger <= sw_trigger_1;

   -- ModuleWare code for instance 'I4' of 'split'
   MW_I4dinl <= be_rdout_cntl;
   en_qdr_data_to_slink_internal <= MW_I4dinl(0);
   en_qdr_data_to_vme_internal <= MW_I4dinl(1);
   -- Instance port mappings.
   I5 : BE_cmnd_decoder
      port map (
         clk               => clk1x,
         rst               => rst,
         command_in        => BE_cmnd_out1,
         command_out       => command_out,
         command_real      => open,
         trigger_select    => trigger_select_1,
         mode_reg          => mode_reg_1,
         ttc_rx_cntl       => ttc_rx_i2c_1,
         test_reg          => test_register1,
         fe_enable_reg     => FE_disable_reg_1,
         be_rdout_cntl     => be_rdout_cntl_1,
         be_run_cntl       => be_run_cntl_1,
         sw_trigger        => sw_trigger_1,
         soft_rst          => sw_reset1,
         fed_id_reg        => fed_id_reg_1,
         ttc_rx_rst        => ttc_rx_rst_1,
         lm82_cntl         => lm82_cntl_1,
         be_status_reg     => be_status_reg_internal,
         rd_L1A_count      => L1A_count,
         rd_bx_count       => bx_count,
         qdr_frame_count   => qdr_frame_count,
         TTC_ready         => ttc_ready,
         firmware_id_reg   => firmware_id_reg,
         qdr_data_count    => qdr_data_count,
         total_frame_count => total_frame_count,
         ttc_status        => ttc_status,
         ttc_i2c_en        => ttc_i2c_en,
         lm82_status       => lm82_status,
         lm82_i2c_en       => lm82_i2c_en,
         data_valid        => data_valid,
         ttc_single_cmnd   => ttc_single_command,
         ttc_brdcst_cmnd   => ttc_broadcast_command
      );
   I25 : FDC
      port map (
         Q   => intl_frze_bar_1,
         C   => clk2x,
         CLR => rst,
         D   => internal_freeze_bar
      );
   I26 : INV
      port map (
         O => back_pressure_int,
         I => back_pressure_B_internal
      );
   I17 : OR2
      port map (
         O  => back_pressure_B_internal,
         I0 => throttle_en_internal,
         I1 => int_throttle
      );
   I15 : gen_sw_rst
      port map (
         clk1x      => clk1x,
         data_valid => data_valid,
         rst        => rst,
         sw_reset1  => sw_reset1,
         sw_reset   => sw_reset
      );
   I20 : gen_ttc_rx_rst
      port map (
         TTC_rst_frm_vme_b => TTC_rst_frm_vme_b,
         clk1x             => clk1x,
         rst               => rst,
         ttc_rx_rst_1      => ttc_rx_rst_1,
         ttc_reset_b_1     => ttc_reset_b_1
      );
   I22 : i2c_lm82
      port map (
         i2c_init     => lm82_i2c_en,
         i2c_rst      => reset,
         iclk40       => clk1x,
         lm82_control => lm82_cntl,
         lm82_status  => lm82_status,
         scl          => lm82_scl,
         sda          => lm82_sda
      );
   I21 : i2c_ttc
      port map (
         TTC_control => TTC_control,
         i2c_init    => ttc_i2c_en,
         i2c_rst     => reset,
         iclk40      => clk1x,
         scl         => ttc_scl,
         ttc_status  => ttc_status,
         sda         => ttc_sda
      );
   I1 : serial_router
      port map (
         clk          => clk1x,
         cmnd_in_a    => config_in(1),
         cmnd_in_b    => config_in(2),
         cmnd_in_c    => config_in(3),
         cmnd_in_d    => config_in(4),
         cmnd_in_e    => config_in(5),
         cmnd_in_f    => config_in(6),
         cmnd_in_g    => config_in(7),
         cmnd_in_h    => config_in(8),
         cmnd_in_i    => calice_cmd_in,
         cmnd_in_j    => command_out,
         comnd_in     => vme_command_in,
         rst          => rst,
         cmnd_out_a   => config_out(1),
         cmnd_out_b   => config_out(2),
         cmnd_out_c   => config_out(3),
         cmnd_out_d   => config_out(4),
         cmnd_out_e   => config_out(5),
         cmnd_out_f   => config_out(6),
         cmnd_out_g   => config_out(7),
         cmnd_out_h   => config_out(8),
         cmnd_out_i   => calice_cmd_out,
         cmnd_out_j   => BE_cmnd_out,
         data_from_FE => vme_command_out
      );
   I16 : throttle_select
      port map (
         clk2x                => clk2x,
         en_qdr_data_to_slink => en_qdr_data_to_slink_internal,
         en_qdr_data_to_vme   => en_qdr_data_to_vme_internal,
         rst                  => rst,
         slink_ldown_b        => slink_ldown_b,
         slink_lff_b          => slink_lff_b,
         vme_throttle         => vme_throttle,
         int_throttle         => int_throttle
      );

   g0: FOR i IN 0 TO 1 GENERATE
      I7 : FDCE
         port map (
            Q   => be_run_cntl(i),
            C   => clk1x,
            CE  => data_valid,
            CLR => rst,
            D   => be_run_cntl_1(i)
         );
   end generate g0;

   g9: FOR i IN 0 TO 31 GENERATE
      I24 : FDCE
         port map (
            Q   => be_status_reg_internal(i),
            C   => clk2x,
            CE  => intl_frze_bar_1,
            CLR => rst,
            D   => be_status_reg_1(i)
         );
   end generate g9;

   g1: FOR i IN 0 TO 1 GENERATE
      I8 : FDCE
         port map (
            Q   => be_rdout_cntl(i),
            C   => clk1x,
            CE  => data_valid,
            CLR => rst,
            D   => be_rdout_cntl_1(i)
         );
   end generate g1;

   g2: FOR i IN 1 TO 8 GENERATE
      I9 : FDCE
         port map (
            Q   => FE_enable_reg_internal(i),
            C   => clk1x,
            CE  => data_valid,
            CLR => rst,
            D   => FE_disable_reg_1(i)
         );
   end generate g2;

   g3: FOR i IN 0 TO 2 GENERATE
      I10 : FDCE
         port map (
            Q   => sel_trig_source(i),
            C   => clk1x,
            CE  => data_valid,
            CLR => rst,
            D   => trigger_select_1(i)
         );
   end generate g3;

   g4: FOR i IN 0 TO 3 GENERATE
      I11 : FDCE
         port map (
            Q   => mode_reg(i),
            C   => clk1x,
            CE  => data_valid,
            CLR => rst,
            D   => mode_reg_1(i)
         );
   end generate g4;

   g5: FOR i IN 0 TO 15 GENERATE
      I12 : FDCE
         port map (
            Q   => TTC_control(i),
            C   => clk1x,
            CE  => data_valid,
            CLR => rst,
            D   => ttc_rx_i2c_1(i)
         );
   end generate g5;

   g6: FOR i IN 0 TO 11 GENERATE
      I14 : FDCE
         port map (
            Q   => fed_id_reg(i),
            C   => clk1x,
            CE  => data_valid,
            CLR => rst,
            D   => fed_id_reg_1(i)
         );
   end generate g6;

   g7: FOR i IN 0 TO 31 GENERATE
      I13 : FDCE
         port map (
            Q   => test_register(i),
            C   => clk1x,
            CE  => data_valid,
            CLR => rst,
            D   => test_register1(i)
         );
   end generate g7;

   g8: FOR i IN 0 TO 16 GENERATE
      I19 : FDCE
         port map (
            Q   => lm82_cntl(i),
            C   => clk1x,
            CE  => data_valid,
            CLR => rst,
            D   => lm82_cntl_1(i)
         );
   end generate g8;

   -- Implicit buffered output assignments
   FE_enable_reg        <= FE_enable_reg_internal;
   throttle_en          <= throttle_en_internal;
   back_pressure_B      <= back_pressure_B_internal;
   be_status_reg        <= be_status_reg_internal;
   en_qdr_data_to_vme   <= en_qdr_data_to_vme_internal;
   en_qdr_data_to_slink <= en_qdr_data_to_slink_internal;

end struct;
