-- hds header_start
--
-- VHDL Entity CALICE_BE_fpga.vme_qdr_rd.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 10:15:39 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity vme_qdr_rd is
   port( 
      ctrl               : in     std_logic;
      data_out           : in     std_logic_vector (63 downto 0);
      data_out_en        : in     std_logic;
      en_qdr_data_to_vme : in     std_logic;
      reset              : in     std_logic;
      vme_link_clk       : in     std_logic;
      cntl_to_vme        : out    std_logic;
      data_out_to_vme    : out    std_logic_vector (31 downto 0);
      data_to_vme_valid  : out    std_logic
   );

-- Declarations

end vme_qdr_rd ;


-- hds interface_end

--
-- VHDL Architecture CALICE_BE_fpga.vme_qdr_rd.struct_clk_inv
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 10:15:52 10/19/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

LIBRARY ieee;
USE ieee.std_logic_1164.all;

library unisim;

architecture struct_clk_inv of vme_qdr_rd is

   -- Architecture declarations

   -- Internal signal declarations
   signal clk2x_inv1   : std_logic;
   signal clk2x_inv2   : std_logic;
   signal clk_inv      : std_logic_vector(31 downto 0);
   signal data_out_lsb : std_logic_vector(31 downto 0);
   signal data_out_msb : std_logic_vector(31 downto 0);
   signal low          : STD_ULOGIC;


   -- ModuleWare signal declarations for instance 'I10' of 'split'
   signal MW_I10dinl : std_logic_vector(63 downto 0);

   -- Component Declarations
   component FDDRCPE
   port (
      C0  : in     STD_ULOGIC;
      C1  : in     STD_ULOGIC;
      CE  : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D0  : in     STD_ULOGIC;
      D1  : in     STD_ULOGIC;
      PRE : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component inv
   port (
      I : in     STD_ULOGIC;
      O : out    STD_ULOGIC
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : FDDRCPE use entity unisim.FDDRCPE;
   for all : inv use entity unisim.inv;
   -- pragma synthesis_on


begin

   -- ModuleWare code for instance 'I10' of 'split'
   MW_I10dinl <= data_out;
   data_out_lsb <= MW_I10dinl(31 downto 0);
   data_out_msb <= MW_I10dinl(63 downto 32);

   -- ModuleWare code for instance 'I12' of 'gnd'
      low <= '0';
   -- Instance port mappings.
   I2 : FDDRCPE
      port map (
         Q   => data_to_vme_valid,
         C0  => clk2x_inv1,
         C1  => vme_link_clk,
         CE  => en_qdr_data_to_vme,
         D0  => data_out_en,
         D1  => data_out_en,
         CLR => reset,
         PRE => low
      );
   I1 : FDDRCPE
      port map (
         Q   => cntl_to_vme,
         C0  => clk2x_inv2,
         C1  => vme_link_clk,
         CE  => en_qdr_data_to_vme,
         D0  => ctrl,
         D1  => ctrl,
         CLR => reset,
         PRE => low
      );
   I5 : inv
      port map (
         O => clk2x_inv1,
         I => vme_link_clk
      );
   I6 : inv
      port map (
         O => clk2x_inv2,
         I => vme_link_clk
      );

   g2: FOR i IN 0 TO 31 GENERATE
      I4 : inv
         port map (
            O => clk_inv(i),
            I => vme_link_clk
         );
      I3 : FDDRCPE
         port map (
            Q   => data_out_to_vme(i),
            C0  => clk_inv(i),
            C1  => vme_link_clk,
            CE  => en_qdr_data_to_vme,
            D0  => data_out_msb(i),
            D1  => data_out_lsb(i),
            CLR => reset,
            PRE => low
         );
   end generate g2;

end struct_clk_inv;
