-- hds header_start
--
-- VHDL Architecture CALICE_lib.addr_decoder.rtl2
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:52:36 11/30/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity addr_decoder is
   port( 
      rst        : in     std_logic;
      clk        : in     std_logic;
      addr_i     : in     std_logic_vector (15 downto 0);
      ram_en_o   : out    std_logic;
      reg_en00_o : out    std_logic;
      reg_en01_o : out    std_logic;
      reg_en02_o : out    std_logic;
      reg_en03_o : out    std_logic;
      reg_en04_o : out    std_logic;
      reg_en05_o : out    std_logic;
      reg_en06_o : out    std_logic;
      reg_en07_o : out    std_logic;
      reg_en08_o : out    std_logic;
      reg_en09_o : out    std_logic;
      reg_en10_o : out    std_logic;
      reg_en11_o : out    std_logic;
      reg_en12_o : out    std_logic;
      reg_en13_o : out    std_logic;
      reg_en14_o : out    std_logic;
      reg_en15_o : out    std_logic;
      reg_en16_o : out    std_logic;
      reg_en17_o : out    std_logic;
      reg_en18_o : out    std_logic;
      reg_en19_o : out    std_logic;
      reg_en20_o : out    std_logic;
      reg_en21_o : out    std_logic;
      reg_en22_o : out    std_logic;
      reg_en23_o : out    std_logic;
      reg_en24_o : out    std_logic;
      reg_en25_o : out    std_logic;
      reg_en26_o : out    std_logic;
      reg_en27_o : out    std_logic;
      reg_en28_o : out    std_logic;
      reg_en29_o : out    std_logic;
      reg_en30_o : out    std_logic;
      reg_en31_o : out    std_logic
   );

-- Declarations

end addr_decoder ;

-- hds interface_end
architecture rtl of addr_decoder is

	signal reg_en	: std_logic_vector(31 downto 0);
	signal ram_en	: std_logic;
	
-------------------------------------------------------------------------------
-- MAIN CODE
-------------------------------------------------------------------------------
begin

	process (clk)
  	begin
  	
  		if rising_edge(clk) then
  		
	  		if (rst = '1') then
  				ram_en <= '0';
  				reg_en <= (others => '0');
  		
	    	else
	    		-- defaults
	    		ram_en <= '0';
	    		reg_en <= (others => '0');
	    		
	    		if (addr_i(15) = '1') then
	    			ram_en <= '1';
	    		
	    		else
	      		case addr_i(14 downto 2) is
	      																										  --No  Addr
		        		when "0000000000000" =>  reg_en <= "00000000000000000000000000000001"; --00  0x00
						when "0000000000001" =>  reg_en <= "00000000000000000000000000000010"; --01  0x04
						when "0000000000010" =>  reg_en <= "00000000000000000000000000000100"; --02  0x08
						when "0000000000011" =>  reg_en <= "00000000000000000000000000001000"; --03  0x0c
						when "0000000000100" =>  reg_en <= "00000000000000000000000000010000"; --04  0x10
						when "0000000000101" =>  reg_en <= "00000000000000000000000000100000"; --05  0x14
						when "0000000000110" =>  reg_en <= "00000000000000000000000001000000"; --06  0x18
						when "0000000000111" =>  reg_en <= "00000000000000000000000010000000"; --07  0x1c
						when "0000000001000" =>  reg_en <= "00000000000000000000000100000000"; --08  0x20
						when "0000000001001" =>  reg_en <= "00000000000000000000001000000000"; --09  0x24
						when "0000000001010" =>  reg_en <= "00000000000000000000010000000000"; --10  0x28
						when "0000000001011" =>  reg_en <= "00000000000000000000100000000000"; --11  0x2c
						when "0000000001100" =>  reg_en <= "00000000000000000001000000000000"; --12  0x30
						when "0000000001101" =>  reg_en <= "00000000000000000010000000000000"; --13  0x34
						when "0000000001110" =>  reg_en <= "00000000000000000100000000000000"; --14  0x38
						when "0000000001111" =>  reg_en <= "00000000000000001000000000000000"; --15  0x3c
						when "0000000010000" =>  reg_en <= "00000000000000010000000000000000"; --16  0x40
						when "0000000010001" =>  reg_en <= "00000000000000100000000000000000"; --17  0x44
						when "0000000010010" =>  reg_en <= "00000000000001000000000000000000"; --18  0x48
						when "0000000010011" =>  reg_en <= "00000000000010000000000000000000"; --19  0x4c
						when "0000000010100" =>  reg_en <= "00000000000100000000000000000000"; --20  0x50
						when "0000000010101" =>  reg_en <= "00000000001000000000000000000000"; --21  0x54
						when "0000000010110" =>  reg_en <= "00000000010000000000000000000000"; --22  0x58
						when "0000000010111" =>  reg_en <= "00000000100000000000000000000000"; --23  0x5c
						when "0000000011000" =>  reg_en <= "00000001000000000000000000000000"; --24  0x60
						when "0000000011001" =>  reg_en <= "00000010000000000000000000000000"; --25  0x64
			        	when "0000000011010" =>  reg_en <= "00000100000000000000000000000000"; --26  0x68
						when "0000000011011" =>  reg_en <= "00001000000000000000000000000000"; --27  0x6c
						when "0000000011100" =>  reg_en <= "00010000000000000000000000000000"; --28  0x70
						when "0000000011101" =>  reg_en <= "00100000000000000000000000000000"; --29  0x74
						when "0000000011110" =>  reg_en <= "01000000000000000000000000000000"; --30  0x78
						when "0000000011111" =>  reg_en <= "10000000000000000000000000000000"; --31  0x7c
	        
		        		when others =>            reg_en <= (others => '0');					      
		      	end case;
		      end if;
	     	end if;
		end if;
  	end process;

	-- Output Mapping
	-----------------------------------------------------------------
	
	ram_en_o <= ram_en;	

	reg_en00_o <= reg_en(00);
	reg_en01_o <= reg_en(01);
	reg_en02_o <= reg_en(02);
	reg_en03_o <= reg_en(03);
	reg_en04_o <= reg_en(04);
	reg_en05_o <= reg_en(05);
	reg_en06_o <= reg_en(06);
	reg_en07_o <= reg_en(07);
	reg_en08_o <= reg_en(08);
	reg_en09_o <= reg_en(09);
	reg_en10_o <= reg_en(10);
	reg_en11_o <= reg_en(11);
	reg_en12_o <= reg_en(12);
	reg_en13_o <= reg_en(13);
	reg_en14_o <= reg_en(14);
	reg_en15_o <= reg_en(15);
	reg_en16_o <= reg_en(16);
	reg_en17_o <= reg_en(17);
	reg_en18_o <= reg_en(18);
	reg_en19_o <= reg_en(19);
	reg_en20_o <= reg_en(20);
	reg_en21_o <= reg_en(21);
	reg_en22_o <= reg_en(22);
	reg_en23_o <= reg_en(23);
	reg_en24_o <= reg_en(24);
	reg_en25_o <= reg_en(25);
	reg_en26_o <= reg_en(26);
	reg_en27_o <= reg_en(27);
	reg_en28_o <= reg_en(28);
	reg_en29_o <= reg_en(29);
	reg_en30_o <= reg_en(30);
	reg_en31_o <= reg_en(31);



end rtl;
