-- hds header_start
--
-- VHDL Architecture CALICE_lib.counter_delay.untitled
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:58:04 09/29/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;


entity counter_delay is
   generic( 
      WIDTH : integer := 32
   );
   port( 
      clk         : in     std_logic;
      delay       : in     std_logic_vector ((WIDTH-1) downto 0);
      reset       : in     std_logic;
      sig         : in     std_logic;
      delayed_sig : out    std_logic
   );

-- Declarations

end counter_delay ;

-- hds interface_end
architecture rtl of counter_delay is

	signal count     : std_logic_vector((WIDTH-1) downto 0);
	signal count_en  : std_logic;
	signal sig0		  : std_logic;
	
begin

 
	delay_counter : process (clk)
	begin
		if rising_edge(clk) then
		
			if (reset = '1') then
				delayed_sig <= '0';
				count 		<= (others => '1');
				count_en	   <= '0'; 
				sig0 		   <= '0'; 
				
			else
				sig0 <= sig;
				
				if (count = 0) then
					delayed_sig <= '1';
					count 		<= (others => '1');
					count_en    <= '0';

				elsif (sig = '1') and (sig0 = '0') then --rising edge
					count_en    <= '1';
				   count 		<= delay;
				
				elsif (count_en = '1') then
					count <= count - '1';
												
				end if;
			end if;
		end if;
	end process;


end rtl;
