-- hds header_start
--
-- VHDL Architecture CALICE_lib.register32.untitled
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 11:33:54 11/30/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity multireg32 is
   generic( 
      RESET_VAL : integer := 0
   );
   port( 
      clk   : in     std_logic;
      en_i  : in     std_logic;
      rd_i  : in     std_logic;
      rst   : in     std_logic;
      wr_i  : in     std_logic;
      reg_o : out    std_logic_vector (31 downto 0);
      reg_i : in     std_logic_vector (31 downto 0);
      rgw_o : out    std_logic;
      db_io : inout  std_logic_vector (31 downto 0)
   );

-- Declarations

end multireg32 ;


-- hds interface_end
architecture rtl of multireg32 is
	
	signal reg : std_logic_vector(31 downto 0);
	signal rgw : std_logic;

begin

	reg_o <= reg;
	
	rgw   <= (en_i and wr_i);
	rgw_o <= rgw;
	
	-- Write
	reg32_write : process (clk)
	begin
		if rising_edge(clk) then
			if (rst = '1') then
				reg <= conv_std_logic_vector(RESET_VAL,32);
			
			else
			
				if (rgw = '1') then
					reg <= db_io after 1 ns;
					
				end if;
			
			end if;
		end if;
	end process;
	
	
	-- Read
	db_io <= reg_i  after 1 ns when ((en_i and rd_i) = '1') else (others => 'Z');		
	
end rtl;
