-- hds header_start
--
-- VHDL Entity CERC_trig.bt_main.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 15:31:46 05/31/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity bt_main is
   generic( 
      FIRMWARE_VER : integer := 0
   );
   port( 
      addr              : in     std_logic_vector (15 downto 0);
      be_reset_i        : in     std_logic;
      clk               : in     std_logic;
      clk180            : in     std_logic;
      clk270            : in     std_logic;
      clk2x             : in     std_logic;
      clk90             : in     std_logic;
      db_rd             : in     std_logic;
      db_rd0            : in     std_logic;
      db_wr             : in     std_logic;
      fe_trig_sync_i    : in     std_logic;
      readout_sync_in   : in     std_logic;
      ren               : in     std_logic_vector (31 downto 0);
      rst               : in     std_logic;
      sinkdata_fe0_i    : in     std_logic_vector (31 downto 0);
      squirt_en_i       : in     std_logic;
      tqdr_en_i         : in     std_logic;
      trig_ext_i        : in     std_logic_vector (15 downto 0);
      busy_crate_trig_o : out    std_logic;
      fanout_en_o       : out    std_logic;
      frame_sync_out    : out    STD_ULOGIC;
      readout_data_out  : out    std_logic_vector (7 downto 0);
      readout_sync_out  : out    STD_ULOGIC;
      rst_cmd           : out    std_logic;
      squirt_disable_o  : out    std_logic;
      trig_cand0_o      : out    std_logic;
      trig_out_o        : out    std_logic;
      trig_raw_o        : out    std_logic;
      trig_raw_sync_o   : out    std_logic;
      trig_sync_o       : out    std_logic;
      db                : inout  std_logic_vector (31 downto 0)
   );

-- Declarations

end bt_main ;

-- hds interface_end
--
-- VHDL Architecture CERC_trig.bt_main.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 15:31:47 05/31/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use IEEE.VITAL_Timing.ALL;
use ieee.numeric_std.ALL;
library unisim;
use unisim.vpkg.ALL;
use ieee.std_logic_textio.ALL;

library CERC_lib;
library CERC_trig;
library Timestamp;

architecture struct of bt_main is

   -- Architecture declarations

   -- Internal signal declarations
   signal ONE                    : std_logic;
   signal ZERO                   : std_logic;
   signal bburst_en              : std_logic;
   signal bto_en                 : std_logic;
   signal burst_en               : std_logic;
   signal busy_trig              : std_logic;
   signal busy_trig_n            : std_logic;
   signal coinc_en               : std_logic;
   signal epoc_secs              : std_logic_vector(31 downto 0);
   signal fetrg_readout_delay    : std_logic_vector(12 downto 0);
   signal fifo_data_out          : std_logic_vector(31 downto 0);
   signal fifo_empty             : std_logic;
   signal fifo_full              : std_logic;
   signal fifo_idlelvl           : std_logic_vector(15 downto 0);
   signal fifo_max_depth         : std_logic_VECTOR(9 downto 0);
   signal fifo_testmode          : std_logic_vector(1 downto 0);
   signal frame_sync_delay_val   : std_logic_vector(15 downto 0);
   signal ibto_en                : std_logic;
   signal input_stat             : std_logic_vector(31 downto 0);
   signal oa_busy_force          : std_logic;
   signal oa_clr_busy_trig       : std_logic;
   signal prebusy_catch          : std_logic_vector(31 downto 0);
   signal readout_sync_delay_val : std_logic_vector(2 downto 0);
   signal reg_busy_timeout       : std_logic_vector(31 downto 0);
   signal reg_cand0_en           : std_logic_vector(31 downto 0);
   signal reg_cand1_en           : std_logic_vector(31 downto 0);
   signal reg_cand2_en           : std_logic_vector(31 downto 0);
   signal reg_cand3_en           : std_logic_vector(31 downto 0);
   signal reg_cmd                : std_logic_vector(31 downto 0);
   signal reg_config             : std_logic_vector(31 downto 0);
   signal reg_fetrg_conf         : std_logic_vector(31 downto 0);
   signal reg_gen_en             : std_logic_vector(31 downto 0);
   signal reg_input_en           : std_logic_vector(31 downto 0);
   signal reg_invert_trig        : std_logic_vector(31 downto 0);
   signal reg_sequencer          : std_logic_vector(31 downto 0);
   signal reg_trig_osc           : std_logic_vector(31 downto 0);
   signal rgw_busy_timeout       : std_logic;
   signal rgw_trig_osc           : std_logic;
   signal seq_busy               : std_logic;
   signal seq_mode_en            : std_logic;
   signal tbto_en                : std_logic;
   signal tqdr_fifo_rd           : std_logic;
   signal trig_cand0             : std_logic;
   signal trig_cand0_raw         : std_logic;
   signal trig_cand1             : std_logic;
   signal trig_cand1_raw         : std_logic;
   signal trig_cand2             : std_logic;
   signal trig_cand2_raw         : std_logic;
   signal trig_cand3             : std_logic;
   signal trig_cand3_raw         : std_logic;
   signal trig_cmd               : std_logic;
   signal trig_extall            : std_logic;
   signal trig_extall_raw        : std_logic;
   signal trig_id                : std_logic_vector(31 downto 0);
   signal trig_osc               : std_logic;
   signal trig_osc_raw           : std_logic;
   signal trig_out               : std_logic;
   signal trig_raw               : std_logic;
   signal trig_raw_sync          : std_logic;
   signal trig_seq               : std_logic_vector(15 downto 0);
   signal trig_sync              : std_logic;


   -- Component Declarations
   component burst_sys
   port (
      rst                : in     std_logic ;
      clk                : in     std_logic ;
      db                 : inout  std_logic_vector (31 downto 0);
      db_rd              : in     std_logic ;
      db_wr              : in     std_logic ;
      ren_burst_i        : in     std_logic ;
      ren_control_i      : in     std_logic ;
      ren_busy_trig_to_i : in     std_logic ;
      ren_burst_to_i     : in     std_logic ;
      tbto_en_i          : in     std_logic ;
      burst_en_i         : in     std_logic ;
      bto_en_i           : in     std_logic ;
      ibto_en_i          : in     std_logic ;
      --bburst_en_i     : in     std_logic;
      busy_trig_i        : in     std_logic ;
      trig_sync_i        : in     std_logic ;
      oa_clr_busy_trig_o : out    std_logic ;
      oa_busy_force_o    : out    std_logic 
   );
   end component;
   component en_1enn
   generic (
      N : integer := 8
   );
   port (
      I  : in     std_logic_vector (N-1 downto 0);
      en : in     std_logic ;
      O  : out    std_logic_vector (N-1 downto 0)
   );
   end component;
   component fe_comms
   port (
      clk40                    : in     std_logic ;
      clk80                    : in     STD_ULOGIC ;
      fifo_data_count          : in     std_logic_VECTOR (9 downto 0);
      fifo_data_out            : in     std_logic_vector (31 downto 0);
      fifo_empty               : in     std_logic ;
      frame_sync_delay_val_i   : in     std_logic_vector (15 downto 0);
      readout_sync_delay_val_i : in     std_logic_vector (2 downto 0);
      readout_sync_in          : in     std_logic ;
      rst                      : in     std_logic ;
      trgfe_readout_delay      : in     std_logic_vector (12 downto 0);
      trigger                  : in     std_logic ;
      fifo_rd                  : out    std_logic ;
      frame_sync_out           : out    STD_ULOGIC ;
      readout_data_out         : out    std_logic_vector (7 downto 0);
      readout_sync_out         : out    STD_ULOGIC 
   );
   end component;
   component m_buff
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;
   component m_buff16
   port (
      I : in     std_logic_vector (15 downto 0);
      O : out    std_logic_vector (15 downto 0)
   );
   end component;
   component m_buffn
   generic (
      N : integer := 8
   );
   port (
      I : in     std_logic_vector (N-1 downto 0);
      O : out    std_logic_vector (N-1 downto 0)
   );
   end component;
   component m_mininv
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;
   component m_power
   port (
      ONE  : out    std_logic ;
      ZERO : out    std_logic 
   );
   end component;
   component register32
   generic (
      RESET_VAL : integer := 0
   );
   port (
      clk   : in     std_logic ;
      en_i  : in     std_logic ;
      rd_i  : in     std_logic ;
      rst   : in     std_logic ;
      wr_i  : in     std_logic ;
      reg_o : out    std_logic_vector (31 downto 0);
      rgw_o : out    std_logic ;
      db_io : inout  std_logic_vector (31 downto 0)
   );
   end component;
   component sequencer
   port (
      addr_i          : in     std_logic_vector (9 downto 0);
      busy_trig_i     : in     std_logic ;
      clk             : in     std_logic ;
      db_rd           : in     std_logic ;
      db_wr           : in     std_logic ;
      reg_sequencer_i : in     std_logic_vector (31 downto 0);
      ren_ram_i       : in     std_logic ;
      rst             : in     std_logic ;
      seq_busy_o      : out    std_logic ;
      trig_seq_o      : out    std_logic_vector (15 downto 0);
      db              : inout  std_logic_vector (31 downto 0)
   );
   end component;
   component state_clr_reg32
   port (
      en_i    : in     std_logic ;
      rd_i    : in     std_logic ;
      set_i   : in     std_logic_vector (31 downto 0);
      db_io   : inout  std_logic_vector (31 downto 0);
      wr_i    : in     std_logic ;
      rst     : in     std_logic ;
      clk     : in     std_logic ;
      state_o : out    std_logic_vector (31 downto 0)
   );
   end component;
   component statreg32
   port (
      en_i   : in     std_logic ;
      rd_i   : in     std_logic ;
      stat_i : in     std_logic_vector (31 downto 0);
      db_oz  : out    std_logic_vector (31 downto 0)
   );
   end component;
   component timestamp
   port (
      epoc_secs : out    std_logic_vector (31 downto 0)
   );
   end component;
   component trig_control
   port (
      clk                : in     std_logic ;
      oa_busy_force_i    : in     std_logic ;
      oa_clr_busy_trig_i : in     std_logic ;
      rst                : in     std_logic ;
      trig_raw_i         : in     std_logic ;
      busy_trig_o        : out    std_logic ;
      trig_out_o         : out    std_logic ;
      trig_raw_sync_o    : out    std_logic ;
      trig_sync_o        : out    std_logic 
   );
   end component;
   component trig_count_reg
   port (
      clk         : in     std_logic ;
      rd_i        : in     std_logic ;
      rst         : in     std_logic ;
      rw_en_i     : in     std_logic ;
      trig_sync_i : in     std_logic ;
      wr_i        : in     std_logic ;
      db_oz       : out    std_logic_vector (31 downto 0);
      trig_id_o   : out    std_logic_vector (31 downto 0)
   );
   end component;
   component trig_en_matrix
   port (
      coinc_en_i        : in     std_logic ;
      reg_cand0_en_i    : in     std_logic_vector (31 downto 0);
      reg_cand1_en_i    : in     std_logic_vector (31 downto 0);
      reg_cand2_en_i    : in     std_logic_vector (31 downto 0);
      reg_cand3_en_i    : in     std_logic_vector (31 downto 0);
      reg_input_en      : in     std_logic_vector (31 downto 0);
      reg_invert_trig   : in     std_logic_vector (31 downto 0);
      seq_mode_en_i     : in     std_logic ;
      trig_cmd_i        : in     std_logic ;
      trig_ext_i        : in     std_logic_vector (15 downto 0);
      trig_osc_raw_i    : in     std_logic ;
      trig_seq_i        : in     std_logic_vector (15 downto 0);
      trig_cand0_o      : out    std_logic ;
      trig_cand0_raw_o  : out    std_logic ;
      trig_cand1_o      : out    std_logic ;
      trig_cand1_raw_o  : out    std_logic ;
      trig_cand2_o      : out    std_logic ;
      trig_cand2_raw_o  : out    std_logic ;
      trig_cand3_o      : out    std_logic ;
      trig_cand3_raw_o  : out    std_logic ;
      trig_extall_o     : out    std_logic ;
      trig_extall_raw_o : out    std_logic ;
      trig_osc_o        : out    std_logic ;
      trig_raw_o        : out    std_logic 
   );
   end component;
   component trig_fifo
   port (
      busy_trig_i      : in     std_logic ;
      clk              : in     std_logic ;
      db_rd0_i         : in     std_logic ;
      db_rd_i          : in     std_logic ;
      fifo_data_i      : in     std_logic_VECTOR (31 downto 0);
      fifo_idlelvl_i   : in     std_logic_vector (15 downto 0);
      fifo_testmode_i  : in     std_logic_vector (1 downto 0);
      ren_fifo_i       : in     std_logic ;
      ren_fifo_stat_i  : in     std_logic ;
      rst              : in     std_logic ;
      squirt_en_i      : in     std_logic ;
      tqdr_en_i        : in     std_logic ;
      tqdr_fifo_rd_i   : in     std_logic ;
      trig_id_i        : in     std_logic_VECTOR (31 downto 0);
      db_oz            : out    std_logic_vector (31 downto 0);
      fifo_data_o      : out    std_logic_VECTOR (31 downto 0);
      fifo_empty_o     : out    std_logic ;
      fifo_full_o      : out    std_logic ;
      fifo_max_depth_o : out    std_logic_vector (9 downto 0);
      squirt_disable_o : out    std_logic 
   );
   end component;
   component trigger_osc
   port (
      clk         : in     std_logic ;
      rst         : in     std_logic ;
      clr_i       : in     std_logic ;
      count_max_i : in     std_logic_vector (31 downto 0);
      trig_osc_o  : out    std_logic 
   );
   end component;
   component version_id
   generic (
      FIRMWARE_VER : integer := 16#0000#
   );
   port (
      en_i  : in     std_logic ;
      rd_i  : in     std_logic ;
      db_oz : out    std_logic_vector (31 downto 0)
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : burst_sys use entity CERC_trig.burst_sys;
   for all : en_1enn use entity CERC_lib.en_1enn;
   for all : fe_comms use entity CERC_trig.fe_comms;
   for all : m_buff use entity CERC_lib.m_buff;
   for all : m_buff16 use entity CERC_lib.m_buff16;
   for all : m_buffn use entity CERC_lib.m_buffn;
   for all : m_mininv use entity CERC_lib.m_mininv;
   for all : m_power use entity CERC_lib.m_power;
   for all : register32 use entity CERC_lib.register32;
   for all : sequencer use entity CERC_trig.sequencer;
   for all : state_clr_reg32 use entity CERC_lib.state_clr_reg32;
   for all : statreg32 use entity CERC_lib.statreg32;
   for all : timestamp use entity Timestamp.timestamp;
   for all : trig_control use entity CERC_trig.trig_control;
   for all : trig_count_reg use entity CERC_lib.trig_count_reg;
   for all : trig_en_matrix use entity CERC_trig.trig_en_matrix;
   for all : trig_fifo use entity CERC_trig.trig_fifo;
   for all : trigger_osc use entity CERC_trig.trigger_osc;
   for all : version_id use entity CERC_lib.version_id;
   -- pragma synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 8 aggr_stat
   input_stat(31 downto 29)  <= (others => '0');
   input_stat(28)            <= trig_cand3;
   input_stat(27)            <= trig_cand2;
   input_stat(26)            <= trig_cand1;
   input_stat(25)            <= trig_cand0;
   input_stat(24)            <= trig_osc;
   input_stat(23)            <= trig_extall;
   input_stat(22)            <= trig_cmd;
   input_stat(21)            <= trig_raw;
   input_stat(20)            <= trig_sync;
   input_stat(19)            <= trig_out;
   input_stat(18 downto 16) <= (others => '0');
   input_stat(15 downto 0)   <= trig_ext_i;

   -- Instance port mappings.
   burst_sys_1 : burst_sys
      port map (
         rst                => rst,
         clk                => clk,
         db                 => db,
         db_rd              => db_rd,
         db_wr              => db_wr,
         ren_burst_i        => ren(7),
         ren_control_i      => ren(11),
         ren_busy_trig_to_i => ren(16),
         ren_burst_to_i     => ren(17),
         tbto_en_i          => tbto_en,
         burst_en_i         => burst_en,
         bto_en_i           => bto_en,
         ibto_en_i          => ibto_en,
         busy_trig_i        => busy_trig,
         trig_sync_i        => trig_sync,
         oa_clr_busy_trig_o => oa_clr_busy_trig,
         oa_busy_force_o    => oa_busy_force
      );
   I0 : en_1enn
      generic map (
         N => 32
      )
      port map (
         I  => input_stat,
         en => busy_trig_n,
         O  => prebusy_catch
      );
   fe_comms_1 : fe_comms
      port map (
         clk40                    => clk,
         clk80                    => clk2x,
         fifo_data_count          => fifo_max_depth,
         fifo_data_out            => fifo_data_out,
         fifo_empty               => fifo_empty,
         frame_sync_delay_val_i   => frame_sync_delay_val,
         readout_sync_delay_val_i => readout_sync_delay_val,
         readout_sync_in          => readout_sync_in,
         rst                      => rst,
         trgfe_readout_delay      => fetrg_readout_delay,
         trigger                  => fe_trig_sync_i,
         fifo_rd                  => tqdr_fifo_rd,
         frame_sync_out           => frame_sync_out,
         readout_data_out         => readout_data_out,
         readout_sync_out         => readout_sync_out
      );
   I9 : m_buff
      port map (
         I => reg_gen_en(0),
         O => fanout_en_o
      );
   I8 : m_buff
      port map (
         I => trig_sync,
         O => trig_sync_o
      );
   I7 : m_buff
      port map (
         I => trig_out,
         O => trig_out_o
      );
   I6 : m_buff
      port map (
         I => trig_raw_sync,
         O => trig_raw_sync_o
      );
   I5 : m_buff
      port map (
         I => trig_raw,
         O => trig_raw_o
      );
   I12 : m_buff
      port map (
         I => reg_gen_en(1),
         O => tbto_en
      );
   I16 : m_buff
      port map (
         I => reg_gen_en(4),
         O => burst_en
      );
   I17 : m_buff
      port map (
         I => reg_gen_en(5),
         O => bto_en
      );
   I18 : m_buff
      port map (
         I => reg_gen_en(6),
         O => ibto_en
      );
   I20 : m_buff
      port map (
         I => reg_gen_en(16),
         O => seq_mode_en
      );
   I19 : m_buff
      port map (
         I => reg_gen_en(7),
         O => bburst_en
      );
   I13 : m_buff
      port map (
         I => reg_gen_en(8),
         O => coinc_en
      );
   I4 : m_buff
      port map (
         I => busy_trig,
         O => busy_crate_trig_o
      );
   I14 : m_buff
      port map (
         I => trig_cand0,
         O => trig_cand0_o
      );
   m_buff_6 : m_buff
      port map (
         I => reg_cmd(1),
         O => rst_cmd
      );
   m_buff_5 : m_buff
      port map (
         I => reg_cmd(0),
         O => trig_cmd
      );
   I15 : m_buff16
      port map (
         I => reg_config(31 DOWNTO 16),
         O => fifo_idlelvl
      );
   I11 : m_buffn
      generic map (
         N => 16
      )
      port map (
         I => reg_fetrg_conf(15 DOWNTO 0),
         O => frame_sync_delay_val
      );
   I3 : m_buffn
      generic map (
         N => 2
      )
      port map (
         I => reg_config(1 DOWNTO 0),
         O => fifo_testmode
      );
   I10 : m_buffn
      generic map (
         N => 3
      )
      port map (
         I => reg_fetrg_conf(18 DOWNTO 16),
         O => readout_sync_delay_val
      );
   I21 : m_buffn
      generic map (
         N => 13
      )
      port map (
         I => reg_fetrg_conf(31 DOWNTO 19),
         O => fetrg_readout_delay
      );
   I2 : m_mininv
      port map (
         I => busy_trig,
         O => busy_trig_n
      );
   m_power_1 : m_power
      port map (
         ONE  => ONE,
         ZERO => ZERO
      );
   register32_13 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => ren(28),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_sequencer,
         rgw_o => open,
         db_io => db
      );
   register32_25 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => ren(25),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_fetrg_conf,
         rgw_o => open,
         db_io => db
      );
   register32_12 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => ren(20),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_cand1_en,
         rgw_o => open,
         db_io => db
      );
   register32_11 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => ren(19),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_cand0_en,
         rgw_o => open,
         db_io => db
      );
   register32_24 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => ren(24),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_invert_trig,
         rgw_o => open,
         db_io => db
      );
   register32_8 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => ren(16),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_busy_timeout,
         rgw_o => rgw_busy_timeout,
         db_io => db
      );
   register32_7 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => ren(4),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_gen_en,
         rgw_o => open,
         db_io => db
      );
   register32_6 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => ren(6),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_trig_osc,
         rgw_o => rgw_trig_osc,
         db_io => db
      );
   register32_14 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => ren(21),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_cand2_en,
         rgw_o => open,
         db_io => db
      );
   register32_15 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => ren(22),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_cand3_en,
         rgw_o => open,
         db_io => db
      );
   register32_5 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => ren(15),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_config,
         rgw_o => open,
         db_io => db
      );
   register32_4 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => ren(12),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_cmd,
         rgw_o => open,
         db_io => db
      );
   register32_1 : register32
      generic map (
         RESET_VAL => 0
      )
      port map (
         clk   => clk,
         en_i  => ren(1),
         rd_i  => db_rd,
         rst   => rst,
         wr_i  => db_wr,
         reg_o => reg_input_en,
         rgw_o => open,
         db_io => db
      );
   sequencer_1 : sequencer
      port map (
         addr_i          => addr(11 DOWNTO 2),
         busy_trig_i     => busy_trig,
         clk             => clk,
         db_rd           => db_rd,
         db_wr           => db_wr,
         reg_sequencer_i => reg_sequencer,
         ren_ram_i       => ren(30),
         rst             => rst,
         seq_busy_o      => seq_busy,
         trig_seq_o      => trig_seq,
         db              => db
      );
   state_clr_reg32_3 : state_clr_reg32
      port map (
         en_i    => ren(18),
         rd_i    => db_rd,
         set_i   => prebusy_catch,
         db_io   => db,
         wr_i    => db_wr,
         rst     => rst,
         clk     => clk,
         state_o => open
      );
   state_clr_reg32_1 : state_clr_reg32
      port map (
         en_i    => ren(3),
         rd_i    => db_rd,
         set_i   => input_stat,
         db_io   => db,
         wr_i    => db_wr,
         rst     => rst,
         clk     => clk,
         state_o => open
      );
   state_clr_reg32_2 : state_clr_reg32
      port map (
         en_i    => ren(27),
         rd_i    => db_rd,
         set_i   => sinkdata_fe0_i,
         db_io   => db,
         wr_i    => db_wr,
         rst     => rst,
         clk     => clk,
         state_o => open
      );
   statreg32_1 : statreg32
      port map (
         en_i   => ren(2),
         rd_i   => db_rd,
         stat_i => input_stat,
         db_oz  => db
      );
   statreg32_10 : statreg32
      port map (
         en_i   => ren(10),
         rd_i   => db_rd,
         stat_i => epoc_secs,
         db_oz  => db
      );
   I1 : timestamp
      port map (
         epoc_secs => epoc_secs
      );
   trig_control_1 : trig_control
      port map (
         clk                => clk,
         oa_busy_force_i    => oa_busy_force,
         oa_clr_busy_trig_i => oa_clr_busy_trig,
         rst                => rst,
         trig_raw_i         => trig_raw,
         busy_trig_o        => busy_trig,
         trig_out_o         => trig_out,
         trig_raw_sync_o    => trig_raw_sync,
         trig_sync_o        => trig_sync
      );
   trig_count_reg_1 : trig_count_reg
      port map (
         clk         => clk,
         rd_i        => db_rd,
         rst         => rst,
         rw_en_i     => ren(5),
         trig_sync_i => trig_sync,
         wr_i        => db_wr,
         db_oz       => db,
         trig_id_o   => trig_id
      );
   trig_count_reg_8 : trig_count_reg
      port map (
         clk         => clk,
         rd_i        => db_rd,
         rst         => rst,
         rw_en_i     => ren(8),
         trig_sync_i => trig_raw_sync,
         wr_i        => db_wr,
         db_oz       => db,
         trig_id_o   => open
      );
   trig_en_matrix_1 : trig_en_matrix
      port map (
         coinc_en_i        => coinc_en,
         reg_cand0_en_i    => reg_cand0_en,
         reg_cand1_en_i    => reg_cand1_en,
         reg_cand2_en_i    => reg_cand2_en,
         reg_cand3_en_i    => reg_cand3_en,
         reg_input_en      => reg_input_en,
         reg_invert_trig   => reg_invert_trig,
         seq_mode_en_i     => seq_mode_en,
         trig_cmd_i        => trig_cmd,
         trig_ext_i        => trig_ext_i,
         trig_osc_raw_i    => trig_osc_raw,
         trig_seq_i        => trig_seq,
         trig_cand0_o      => trig_cand0,
         trig_cand0_raw_o  => trig_cand0_raw,
         trig_cand1_o      => trig_cand1,
         trig_cand1_raw_o  => trig_cand1_raw,
         trig_cand2_o      => trig_cand2,
         trig_cand2_raw_o  => trig_cand2_raw,
         trig_cand3_o      => trig_cand3,
         trig_cand3_raw_o  => trig_cand3_raw,
         trig_extall_o     => trig_extall,
         trig_extall_raw_o => trig_extall_raw,
         trig_osc_o        => trig_osc,
         trig_raw_o        => trig_raw
      );
   trig_fifo_1 : trig_fifo
      port map (
         busy_trig_i      => busy_trig,
         clk              => clk,
         db_rd0_i         => db_rd0,
         db_rd_i          => db_rd,
         fifo_data_i      => input_stat,
         fifo_idlelvl_i   => fifo_idlelvl,
         fifo_testmode_i  => fifo_testmode,
         ren_fifo_i       => ren(13),
         ren_fifo_stat_i  => ren(14),
         rst              => rst,
         squirt_en_i      => squirt_en_i,
         tqdr_en_i        => tqdr_en_i,
         tqdr_fifo_rd_i   => tqdr_fifo_rd,
         trig_id_i        => trig_id,
         db_oz            => db,
         fifo_data_o      => fifo_data_out,
         fifo_empty_o     => fifo_empty,
         fifo_full_o      => fifo_full,
         fifo_max_depth_o => fifo_max_depth,
         squirt_disable_o => squirt_disable_o
      );
   trigger_osc_1 : trigger_osc
      port map (
         clk         => clk,
         rst         => rst,
         clr_i       => rgw_trig_osc,
         count_max_i => reg_trig_osc,
         trig_osc_o  => trig_osc_raw
      );
   version_id_1 : version_id
      generic map (
         FIRMWARE_VER => FIRMWARE_VER
      )
      port map (
         en_i  => ren(9),
         rd_i  => db_rd,
         db_oz => db
      );

end struct;
