-- hds header_start
--
-- VHDL Entity CERC_trig.fe_comms.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 15:27:28 05/31/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.all;
USE ieee.std_logic_textio.all;
USE ieee.std_logic_unsigned.ALL;

entity fe_comms is
   port( 
      clk40                    : in     std_logic;
      clk80                    : in     STD_ULOGIC;
      fifo_data_count          : in     std_logic_VECTOR (9 downto 0);
      fifo_data_out            : in     std_logic_vector (31 downto 0);
      fifo_empty               : in     std_logic;
      frame_sync_delay_val_i   : in     std_logic_vector (15 downto 0);
      readout_sync_delay_val_i : in     std_logic_vector (2 downto 0);
      readout_sync_in          : in     std_logic;
      rst                      : in     std_logic;
      trgfe_readout_delay      : in     std_logic_vector (12 downto 0);
      trigger                  : in     std_logic;
      fifo_rd                  : out    std_logic;
      frame_sync_out           : out    STD_ULOGIC;
      readout_data_out         : out    std_logic_vector (7 downto 0);
      readout_sync_out         : out    STD_ULOGIC
   );

-- Declarations

end fe_comms ;

-- hds interface_end
--
-- VHDL Architecture CERC_trig.fe_comms.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 15:27:29 05/31/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.ALL;

library CERC_lib;
library CERC_trig;

architecture struct of fe_comms is

   -- Architecture declarations

   -- Internal signal declarations
   signal delayed_trig : std_logic;
   signal trigdly      : std_logic;


   -- Component Declarations
   component counter_delay
   generic (
      WIDTH : integer := 32
   );
   port (
      clk         : in     std_logic ;
      delay       : in     std_logic_vector ((WIDTH-1) downto 0);
      reset       : in     std_logic ;
      sig         : in     std_logic ;
      delayed_sig : out    std_logic 
   );
   end component;
   component fe_data_mux
   port (
      clk40                    : in     std_logic ;
      clk80                    : in     STD_ULOGIC ;
      fifo_data_count          : in     std_logic_VECTOR (9 downto 0);
      fifo_data_out            : in     std_logic_vector (31 downto 0);
      fifo_empty               : in     std_logic ;
      readout_sync_delay_val_i : in     std_logic_vector (2 downto 0);
      readout_sync_in          : in     std_logic ;
      rst                      : in     std_logic ;
      fifo_rd                  : out    std_logic ;
      readout_data_out         : out    std_logic_vector (7 downto 0)
   );
   end component;
   component fe_dlyd_frame_sync
   port (
      clk40                  : in     std_logic ;
      frame_sync_delay_val_i : in     std_logic_vector (15 downto 0);
      rst                    : in     std_logic ;
      trigger                : in     std_logic ;
      trigdly                : out    std_logic 
   );
   end component;
   component fe_frm_sync_out
   port (
      clk40          : in     std_logic ;
      rst            : in     std_logic ;
      trigdly        : in     std_logic ;
      frame_sync_out : out    STD_ULOGIC 
   );
   end component;
   component fe_readout_sync_mc
   port (
      clk40            : in     std_logic ;
      fifo_data_count  : in     std_logic_VECTOR (9 downto 0);
      fifo_full_i      : in     std_logic ;
      rst              : in     std_logic ;
      readout_sync_out : out    STD_ULOGIC 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : counter_delay use entity CERC_lib.counter_delay;
   for all : fe_data_mux use entity CERC_trig.fe_data_mux;
   for all : fe_dlyd_frame_sync use entity CERC_trig.fe_dlyd_frame_sync;
   for all : fe_frm_sync_out use entity CERC_trig.fe_frm_sync_out;
   for all : fe_readout_sync_mc use entity CERC_trig.fe_readout_sync_mc;
   -- pragma synthesis_on


begin
   -- Instance port mappings.
   counter_delay_1 : counter_delay
      generic map (
         WIDTH => 13
      )
      port map (
         clk         => clk40,
         delay       => trgfe_readout_delay,
         reset       => rst,
         sig         => trigger,
         delayed_sig => delayed_trig
      );
   I7 : fe_data_mux
      port map (
         clk40                    => clk40,
         clk80                    => clk80,
         fifo_data_count          => fifo_data_count,
         fifo_data_out            => fifo_data_out,
         fifo_empty               => fifo_empty,
         readout_sync_delay_val_i => readout_sync_delay_val_i,
         readout_sync_in          => readout_sync_in,
         rst                      => rst,
         fifo_rd                  => fifo_rd,
         readout_data_out         => readout_data_out
      );
   I11 : fe_dlyd_frame_sync
      port map (
         clk40                  => clk40,
         frame_sync_delay_val_i => frame_sync_delay_val_i,
         rst                    => rst,
         trigger                => trigger,
         trigdly                => trigdly
      );
   I5 : fe_frm_sync_out
      port map (
         clk40          => clk40,
         rst            => rst,
         trigdly        => trigdly,
         frame_sync_out => frame_sync_out
      );
   I4 : fe_readout_sync_mc
      port map (
         clk40            => clk40,
         fifo_data_count  => fifo_data_count,
         fifo_full_i      => delayed_trig,
         rst              => rst,
         readout_sync_out => readout_sync_out
      );

end struct;
