-- hds header_start
--
-- VHDL Entity CERC_trig.fe_data_mux.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:11:15 05/16/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.ALL;

entity fe_data_mux is
   port( 
      clk40                    : in     std_logic;
      clk80                    : in     STD_ULOGIC;
      fifo_data_count          : in     std_logic_VECTOR (9 downto 0);
      fifo_data_out            : in     std_logic_vector (31 downto 0);
      fifo_empty               : in     std_logic;
      readout_sync_delay_val_i : in     std_logic_vector (2 downto 0);
      readout_sync_in          : in     std_logic;
      rst                      : in     std_logic;
      fifo_rd                  : out    std_logic;
      readout_data_out         : out    std_logic_vector (7 downto 0)
   );

-- Declarations

end fe_data_mux ;

-- hds interface_end
--
-- VHDL Architecture CERC_trig.fe_data_mux.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:11:15 05/16/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.all;
USE ieee.std_logic_textio.all;
USE ieee.std_logic_unsigned.ALL;

library CERC_lib;
library CERC_trig;

architecture struct of fe_data_mux is

   -- Architecture declarations

   -- Internal signal declarations
   signal data_muxd           : std_logic_vector(15 downto 0);
   signal fifo_empty1         : std_logic;
   signal readout_data_out_q0 : std_logic_vector(7 downto 0);
   signal readoutsyncdly      : std_logic;


   -- Component Declarations
   component fe_mux16_to_8
   port (
      clk80            : in     STD_ULOGIC ;
      data_muxd        : in     std_logic_vector (15 downto 0);
      fifo_empty1      : in     std_logic ;
      rst              : in     std_logic ;
      readout_data_out : out    std_logic_vector (7 downto 0)
   );
   end component;
   component fe_mux32_to_16
   port (
      clk40           : in     std_logic ;
      fifo_data_count : in     std_logic_VECTOR (9 downto 0);
      fifo_data_out   : in     std_logic_vector (31 downto 0);
      fifo_empty      : in     std_logic ;
      readoutsyncdly  : in     std_logic ;
      rst             : in     std_logic ;
      data_muxd       : out    std_logic_vector (15 downto 0);
      fifo_empty1     : out    std_logic ;
      fifo_rd         : out    std_logic 
   );
   end component;
   component fe_redoutsync1
   port (
      clk40                    : in     std_logic ;
      readout_sync_delay_val_i : in     std_logic_vector (2 downto 0);
      readout_sync_in          : in     std_logic ;
      rst                      : in     std_logic ;
      readoutsyncdly           : out    std_logic 
   );
   end component;
   component m_buffn
   generic (
      N : integer := 8
   );
   port (
      I : in     std_logic_vector (N-1 downto 0);
      O : out    std_logic_vector (N-1 downto 0)
   );
   end component;
   component m_dff8
   port (
      D  : in     std_logic_vector (7 downto 0);
      c  : in     std_logic ;
      r  : in     std_logic ;
      Q  : out    std_logic_vector (7 downto 0);
      Qn : out    std_logic_vector (7 downto 0)
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : fe_mux16_to_8 use entity CERC_trig.fe_mux16_to_8;
   for all : fe_mux32_to_16 use entity CERC_trig.fe_mux32_to_16;
   for all : fe_redoutsync1 use entity CERC_trig.fe_redoutsync1;
   for all : m_buffn use entity CERC_lib.m_buffn;
   for all : m_dff8 use entity CERC_lib.m_dff8;
   -- pragma synthesis_on


begin
   -- Instance port mappings.
   I1 : fe_mux16_to_8
      port map (
         clk80            => clk80,
         data_muxd        => data_muxd,
         fifo_empty1      => fifo_empty1,
         rst              => rst,
         readout_data_out => readout_data_out_q0
      );
   I0 : fe_mux32_to_16
      port map (
         clk40           => clk40,
         fifo_data_count => fifo_data_count,
         fifo_data_out   => fifo_data_out,
         fifo_empty      => fifo_empty,
         readoutsyncdly  => readoutsyncdly,
         rst             => rst,
         data_muxd       => data_muxd,
         fifo_empty1     => fifo_empty1,
         fifo_rd         => fifo_rd
      );
   I2 : fe_redoutsync1
      port map (
         clk40                    => clk40,
         readout_sync_delay_val_i => readout_sync_delay_val_i,
         readout_sync_in          => readout_sync_in,
         rst                      => rst,
         readoutsyncdly           => readoutsyncdly
      );
   I4 : m_buffn
      generic map (
         N => 8
      )
      port map (
         I => readout_data_out_q0,
         O => open
      );
   I3 : m_dff8
      port map (
         D  => readout_data_out_q0,
         c  => clk80,
         r  => rst,
         Q  => readout_data_out,
         Qn => open
      );

end struct;
