-- hds header_start
--
-- VHDL Entity CERC_trig.fe_mux32_to_16.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:11:15 05/16/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.all;
USE ieee.std_logic_textio.all;
USE ieee.std_logic_unsigned.ALL;

entity fe_mux32_to_16 is
   port( 
      clk40           : in     std_logic;
      fifo_data_count : in     std_logic_VECTOR (9 downto 0);
      fifo_data_out   : in     std_logic_vector (31 downto 0);
      fifo_empty      : in     std_logic;
      readoutsyncdly  : in     std_logic;
      rst             : in     std_logic;
      data_muxd       : out    std_logic_vector (15 downto 0);
      fifo_empty1     : out    std_logic;
      fifo_rd         : out    std_logic
   );

-- Declarations

end fe_mux32_to_16 ;

-- hds interface_end
--
-- VHDL Architecture CERC_trig.fe_mux32_to_16.fsm2
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:11:15 05/16/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.ALL;

architecture fsm2 of fe_mux32_to_16 is

   -- Architecture Declarations
   signal fifodata_count_int : std_logic_vector (9 downto 0);

   type state_type is (
      s5,
      s4,
      s0,
      s1,
      s3,
      s2
   );

   -- State vector declaration
   attribute state_vector : string;
   attribute state_vector of fsm2 : architecture is "current_state" ;


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

   -- Declare any pre-registered internal signals
   signal data_muxd_int : std_logic_vector (15 downto 0) ;
   signal fifo_empty1_cld : std_logic  ;
   signal fifo_rd_cld : std_logic  ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      clk40
   )
   ----------------------------------------------------------------------------
   begin
      if (clk40'event and clk40 = '1') then
         if (rst = '1') then
            current_state <= s0;
            -- Reset Values
            data_muxd <= "0000000000000000";
            fifo_empty1_cld <= '1';
            fifo_rd_cld <= '0';
            fifodata_count_int <= "0000000000";
         else
            current_state <= next_state;
            -- Registered output assignments
            data_muxd <= data_muxd_int;

            -- Default Assignment To Internals
            fifodata_count_int <= "0000000000";
            fifo_empty1_cld <= '1';
            fifo_rd_cld <= '0';

            -- Combined Actions for internal signals only
            case current_state is
            when s5 =>
               fifo_empty1_cld <='1' after 1 ns;
               fifo_rd_cld <='0' after 1 ns;
            when s4 =>
               fifo_rd_cld <='0' after 1 ns; --*** was '1'
               fifodata_count_int <= fifodata_count_int after 1 ns;
               fifo_empty1_cld <='0' after 1 ns;
            when s0 =>
               fifo_rd_cld <='0' after 1 ns;
            when s1 =>
               -- look for a single pulse
               fifodata_count_int <= fifo_data_count after 1 ns ;
               fifo_rd_cld <='1' after 1 ns;
               fifo_empty1_cld <='0' after 1 ns;
            when s3 =>
               fifo_rd_cld <='1' after 1 ns; --*** was 0
               fifo_empty1_cld <='0' after 1 ns;
               fifodata_count_int <= (fifodata_count_int-1); -- after 1 ns ;
            when s2 =>
               -- *** Matt added state for extra delay
               fifodata_count_int <= fifodata_count_int;
               fifo_rd_cld <='0' after 1 ns;
               fifo_empty1_cld <='0' after 1 ns;
            when others =>
               null;
            end case;

         end if;
      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      current_state,
      fifo_empty,
      fifodata_count_int,
      readoutsyncdly
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when s5 =>
            next_state <= s0;
      when s4 =>
         if (fifodata_count_int =  "0000000000") then
            next_state <= s5;
         else
            next_state <= s3;
         end if;
      when s0 =>
         if (readoutsyncdly ='1' and fifo_empty ='0') then
            next_state <= s1;
         else
            next_state <= s0;
         end if;
      when s1 =>
            next_state <= s2;
      when s3 =>
            next_state <= s4;
      when s2 =>
            next_state <= s3;
      when others =>
         next_state <= s0;
      end case;

   end process nextstate;

   ----------------------------------------------------------------------------
   output : process (
      current_state,
      fifo_data_out
   )
   ----------------------------------------------------------------------------
   begin
      -- Default Assignment
      data_muxd_int <= "0000000000000000";
      -- Default Assignment To Internals

      -- Combined Actions
      case current_state is
      when s4 =>
         data_muxd_int <= fifo_data_out (15 downto 0) after 1 ns;
      when s0 =>
         data_muxd_int <= "0000000000000000" after 1 ns;
      when s3 =>
         data_muxd_int <= fifo_data_out (31 downto 16) after 1 ns;
      when others =>
         null;
      end case;

   end process output;

   -- Concurrent Statements
   -- Clocked output assignments
   fifo_empty1 <= fifo_empty1_cld;
   fifo_rd <= fifo_rd_cld;


end fsm2;
