-- hds header_start
--
-- VHDL Entity CERC_trig.fe_trig_shape.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 15:26:31 05/31/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity fe_trig_shape is
   port( 
      clk_in         : in     std_logic;
      fe_trig_en_i   : in     std_logic_vector (7 downto 0);
      rst_in         : in     std_logic;
      trig_i         : in     std_logic;
      fe_trig_o      : out    std_logic_vector (7 downto 0);
      fe_trig_sync_o : out    std_logic
   );

-- Declarations

end fe_trig_shape ;

-- hds interface_end
--
-- VHDL Architecture CERC_trig.fe_trig_shape.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 15:26:31 05/31/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use IEEE.numeric_std.ALL;
library unisim;
use unisim.VPKG.ALL;

library CERC_lib;
library CERC_trig;

architecture struct of fe_trig_shape is

   -- Architecture declarations

   -- Internal signal declarations
   signal clk           : std_logic;
   signal clr_en        : std_logic;
   signal clr_enn       : std_logic;
   signal rst           : std_logic;
   signal trig          : std_logic;
   signal trig_async_fe : std_logic_vector(7 downto 0);
   signal trig_q1       : std_logic;


   -- Component Declarations
   component edgedet
   port (
      clk     : in     std_logic ;
      rst     : in     std_logic ;
      sig     : in     std_logic ;
      rising  : out    std_logic ;
      falling : out    std_logic 
   );
   end component;
   component fan_en8
   port (
      i  : in     std_logic ;
      en : in     std_logic_vector (7 downto 0);
      o  : out    std_logic_vector (7 downto 0)
   );
   end component;
   component latch_trig
   port (
      async_preset : in     std_logic ;
      rst_clk_en   : in     std_logic ;
      q            : out    std_logic ;
      rst_clk      : in     std_logic ;
      async_clr    : in     std_logic 
   );
   end component;
   component m_2dff
   port (
      D   : in     std_logic ;
      c   : in     std_logic ;
      r   : in     std_logic ;
      Q1  : out    std_logic ;
      Q1n : out    std_logic ;
      Q2  : out    std_logic ;
      Q2n : out    std_logic 
   );
   end component;
   component m_and2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_buff
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : edgedet use entity CERC_lib.edgedet;
   for all : fan_en8 use entity CERC_lib.fan_en8;
   for all : latch_trig use entity CERC_trig.latch_trig;
   for all : m_2dff use entity CERC_lib.m_2dff;
   for all : m_and2 use entity CERC_lib.m_and2;
   for all : m_buff use entity CERC_lib.m_buff;
   -- pragma synthesis_on


begin
   -- Instance port mappings.
   edgedet_1 : edgedet
      port map (
         clk     => clk,
         rst     => rst,
         sig     => trig_q1,
         rising  => fe_trig_sync_o,
         falling => open
      );
   fan_en8_1 : fan_en8
      port map (
         i  => trig,
         en => fe_trig_en_i,
         o  => trig_async_fe
      );
   I5 : m_2dff
      port map (
         D   => trig_i,
         c   => clk,
         r   => rst,
         Q1  => trig_q1,
         Q1n => open,
         Q2  => clr_en,
         Q2n => clr_enn
      );
   I0 : m_and2
      port map (
         I1 => clr_enn,
         I2 => trig_i,
         O  => trig
      );
   I3 : m_buff
      port map (
         I => clk_in,
         O => clk
      );
   I4 : m_buff
      port map (
         I => rst_in,
         O => rst
      );

   g0: FOR n IN 0 TO 7 GENERATE
      latch_trig_1 : latch_trig
         port map (
            async_preset => trig_async_fe(n),
            rst_clk_en   => clr_en,
            q            => fe_trig_o(n),
            rst_clk      => clk,
            async_clr    => rst
         );
   end generate g0;

end struct;
