-- hds header_start
--
-- VHDL Entity CERC_trig.trig_control.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:11:09 05/16/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity trig_control is
   port( 
      clk                : in     std_logic;
      oa_busy_force_i    : in     std_logic;
      oa_clr_busy_trig_i : in     std_logic;
      rst                : in     std_logic;
      trig_raw_i         : in     std_logic;
      busy_trig_o        : out    std_logic;
      trig_out_o         : out    std_logic;
      trig_raw_sync_o    : out    std_logic;
      trig_sync_o        : out    std_logic
   );

-- Declarations

end trig_control ;

-- hds interface_end
--
-- VHDL Architecture CERC_trig.trig_control.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:11:10 05/16/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library CERC_lib;

architecture struct of trig_control is

   -- Architecture declarations

   -- Internal signal declarations
   signal ONE               : std_logic;
   signal ZERO              : std_logic;
   signal oa_busy_force_n   : std_logic;
   signal trig_clr          : std_logic;
   signal trig_latch        : std_logic;
   signal trig_latch_q      : std_logic;
   signal trig_raw_latch    : std_logic;
   signal trig_raw_latch_q1 : std_logic;
   signal trig_raw_q2       : std_logic;
   signal trig_raw_q2n      : std_logic;
   signal trig_raw_rising   : std_logic;
   signal trig_set          : std_logic;
   signal trigin_latch_q2n  : std_logic;


   -- Component Declarations
   component edgedet
   port (
      clk     : in     std_logic ;
      rst     : in     std_logic ;
      sig     : in     std_logic ;
      rising  : out    std_logic ;
      falling : out    std_logic 
   );
   end component;
   component latch_sr
   port (
      S    : in     std_logic ;
      R    : in     std_logic ;
      init : in     std_logic ;
      O    : out    std_logic 
   );
   end component;
   component m_2dff
   port (
      D   : in     std_logic ;
      c   : in     std_logic ;
      r   : in     std_logic ;
      Q1  : out    std_logic ;
      Q1n : out    std_logic ;
      Q2  : out    std_logic ;
      Q2n : out    std_logic 
   );
   end component;
   component m_and2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_mininv
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;
   component m_or2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_power
   port (
      ONE  : out    std_logic ;
      ZERO : out    std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : edgedet use entity CERC_lib.edgedet;
   for all : latch_sr use entity CERC_lib.latch_sr;
   for all : m_2dff use entity CERC_lib.m_2dff;
   for all : m_and2 use entity CERC_lib.m_and2;
   for all : m_mininv use entity CERC_lib.m_mininv;
   for all : m_or2 use entity CERC_lib.m_or2;
   for all : m_power use entity CERC_lib.m_power;
   -- pragma synthesis_on


begin
   -- Instance port mappings.
   edgedet_1 : edgedet
      port map (
         clk     => clk,
         rst     => rst,
         sig     => trig_latch_q,
         rising  => trig_sync_o,
         falling => open
      );
   edgedet_2 : edgedet
      port map (
         clk     => clk,
         rst     => rst,
         sig     => trig_raw_latch_q1,
         rising  => trig_raw_sync_o,
         falling => open
      );
   latch_sr_2 : latch_sr
      port map (
         S    => trig_raw_i,
         R    => trig_raw_q2,
         init => rst,
         O    => trig_raw_latch
      );
   latch_sr_1 : latch_sr
      port map (
         S    => trig_set,
         R    => trig_clr,
         init => rst,
         O    => trig_latch
      );
   I6 : m_2dff
      port map (
         D   => trig_latch,
         c   => clk,
         r   => rst,
         Q1  => trig_latch_q,
         Q1n => open,
         Q2  => busy_trig_o,
         Q2n => trigin_latch_q2n
      );
   I4 : m_2dff
      port map (
         D   => trig_raw_latch,
         c   => clk,
         r   => rst,
         Q1  => trig_raw_latch_q1,
         Q1n => open,
         Q2  => trig_raw_q2,
         Q2n => open
      );
   m_and2_2 : m_and2
      port map (
         I1 => trig_latch,
         I2 => trigin_latch_q2n,
         O  => trig_out_o
      );
   I3 : m_and2
      port map (
         I1 => trig_raw_q2n,
         I2 => trig_raw_i,
         O  => trig_raw_rising
      );
   I7 : m_and2
      port map (
         I1 => oa_busy_force_n,
         I2 => oa_clr_busy_trig_i,
         O  => trig_clr
      );
   I5 : m_mininv
      port map (
         I => trig_raw_q2,
         O => trig_raw_q2n
      );
   I8 : m_mininv
      port map (
         I => oa_busy_force_i,
         O => oa_busy_force_n
      );
   I2 : m_or2
      port map (
         I1 => trig_raw_rising,
         I2 => oa_busy_force_i,
         O  => trig_set
      );
   m_power_1 : m_power
      port map (
         ONE  => ONE,
         ZERO => ZERO
      );

end struct;
