-- hds header_start
--
-- VHDL Entity CERC_trig.trig_fifo.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:11:11 05/16/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity trig_fifo is
   port( 
      busy_trig_i      : in     std_logic;
      clk              : in     std_logic;
      db_rd0_i         : in     std_logic;
      db_rd_i          : in     std_logic;
      fifo_data_i      : in     std_logic_VECTOR (31 downto 0);
      fifo_idlelvl_i   : in     std_logic_vector (15 downto 0);
      fifo_testmode_i  : in     std_logic_vector (1 downto 0);
      ren_fifo_i       : in     std_logic;
      ren_fifo_stat_i  : in     std_logic;
      rst              : in     std_logic;
      squirt_en_i      : in     std_logic;
      tqdr_en_i        : in     std_logic;
      tqdr_fifo_rd_i   : in     std_logic;
      trig_id_i        : in     std_logic_VECTOR (31 downto 0);
      db_oz            : out    std_logic_vector (31 downto 0);
      fifo_data_o      : out    std_logic_VECTOR (31 downto 0);
      fifo_empty_o     : out    std_logic;
      fifo_full_o      : out    std_logic;
      fifo_max_depth_o : out    std_logic_vector (9 downto 0);
      squirt_disable_o : out    std_logic
   );

-- Declarations

end trig_fifo ;

-- hds interface_end
--
-- VHDL Architecture CERC_trig.trig_fifo.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:11:11 05/16/06
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library CERC_lib;
library CERC_trig;

architecture struct of trig_fifo is

   -- Architecture declarations

   -- Internal signal declarations
   signal f1_count : std_logic_vector(7 downto 0);
   signal f1_din   : std_logic_vector(31 downto 0);
   signal f1_dout  : std_logic_vector(31 downto 0);
   signal f1_empty : std_logic;
   signal f1_full  : std_logic;
   signal f1_init  : std_logic;
   signal f1_rd    : std_logic;
   signal f1_wr    : std_logic;


   -- Component Declarations
   component cg_fifo256x32
   port (
      clk        : in     std_logic ;
      sinit      : in     std_logic ;
      din        : in     std_logic_VECTOR (31 downto 0);
      wr_en      : in     std_logic ;
      rd_en      : in     std_logic ;
      dout       : out    std_logic_VECTOR (31 downto 0);
      full       : out    std_logic ;
      empty      : out    std_logic ;
      data_count : out    std_logic_VECTOR (7 downto 0)
   );
   end component;
   component fifo_control
   generic (
      FIFO_DEPTH : integer := 256
   );
   port (
      rst              : in     std_logic ;
      clk              : in     std_logic ;
      db_rd0_i         : in     std_logic ;
      db_rd_i          : in     std_logic ;
      db_oz            : out    std_logic_vector (31 downto 0);
      ren_fifo_stat_i  : in     std_logic ;
      ren_fifo_i       : in     std_logic ;
      squirt_en_i      : in     std_logic ;
      fifo_idlelvl_i   : in     std_logic_vector (15 downto 0);
      fifo_testmode_i  : in     std_logic_vector (1 downto 0);
      tqdr_en_i        : in     std_logic ;
      tqdr_fifo_rd_i   : in     std_logic ;
      busy_trig_i      : in     std_logic ;
      f1_din_o         : out    std_logic_vector (31 downto 0);
      f1_dout_i        : in     std_logic_vector (31 downto 0);
      f1_rd_o          : out    std_logic ;
      f1_wr_o          : out    std_logic ;
      f1_empty_i       : in     std_logic ;
      f1_full_i        : in     std_logic ;
      f1_count_i       : in     std_logic_vector (7 downto 0);
      f1_init_o        : out    std_logic ;
      fifo_data_o      : out    std_logic_VECTOR (31 downto 0);
      fifo_data_i      : in     std_logic_VECTOR (31 downto 0);
      fifo_empty_o     : out    std_logic ;
      fifo_full_o      : out    std_logic ;
      squirt_disable_o : out    std_logic ;
      trig_id_i        : in     std_logic_VECTOR (31 downto 0);
      fifo_max_depth_o : out    std_logic_vector (9 downto 0)
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : cg_fifo256x32 use entity CERC_lib.cg_fifo256x32;
   for all : fifo_control use entity CERC_trig.fifo_control;
   -- pragma synthesis_on


begin
   -- Instance port mappings.
   cg_fifo256x32_1 : cg_fifo256x32
      port map (
         clk        => clk,
         sinit      => f1_init,
         din        => f1_din,
         wr_en      => f1_wr,
         rd_en      => f1_rd,
         dout       => f1_dout,
         full       => f1_full,
         empty      => f1_empty,
         data_count => f1_count
      );
   fifo_control_1 : fifo_control
      generic map (
         FIFO_DEPTH => 256
      )
      port map (
         rst              => rst,
         clk              => clk,
         db_rd0_i         => db_rd0_i,
         db_rd_i          => db_rd_i,
         db_oz            => db_oz,
         ren_fifo_stat_i  => ren_fifo_stat_i,
         ren_fifo_i       => ren_fifo_i,
         squirt_en_i      => squirt_en_i,
         fifo_idlelvl_i   => fifo_idlelvl_i,
         fifo_testmode_i  => fifo_testmode_i,
         tqdr_en_i        => tqdr_en_i,
         tqdr_fifo_rd_i   => tqdr_fifo_rd_i,
         busy_trig_i      => busy_trig_i,
         f1_din_o         => f1_din,
         f1_dout_i        => f1_dout,
         f1_rd_o          => f1_rd,
         f1_wr_o          => f1_wr,
         f1_empty_i       => f1_empty,
         f1_full_i        => f1_full,
         f1_count_i       => f1_count,
         f1_init_o        => f1_init,
         fifo_data_o      => fifo_data_o,
         fifo_data_i      => fifo_data_i,
         fifo_empty_o     => fifo_empty_o,
         fifo_full_o      => fifo_full_o,
         squirt_disable_o => squirt_disable_o,
         trig_id_i        => trig_id_i,
         fifo_max_depth_o => fifo_max_depth_o
      );

end struct;
