-- hds header_start
--
-- VHDL Architecture CALICE_lib.simpsync.rtl
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 11:56:40 09/25/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;


entity trig_shape is
   generic( 
      LEN : integer := 10
   );
   port( 
      rst            : in     std_logic;
      clk            : in     std_logic;
      trig_i         : in     std_logic;
      trig_o         : out    std_logic;
      busy_trig_o    : out    std_logic;
      ren_busy_ctl_i : in     std_logic;
      rd_i           : in     std_logic;
      wr_i           : in     std_logic;
      db_io          : inout  std_logic_vector (31 downto 0)
   );

-- Declarations

end trig_shape ;


-- hds interface_end
architecture rtl of trig_shape is
	signal sr 		: std_logic_vector(LEN downto 0);
	signal l_out	: std_logic;
	signal sr_out	: std_logic;
	
	signal reg : std_logic_vector(31 downto 0);
	
	signal clr_busy : std_logic;
	signal busy_trig : std_logic;

begin

	-- Busy 'register' 
	start_reg : process (clk)
	begin
		if rising_edge(clk) then
			if (rst = '1') then
				clr_busy <= '0';
			
			else
			
				if ((ren_busy_ctl_i and wr_i) = '1') then
					clr_busy <= not db_io(0) after 1 ns;
					
				end if;
			
			end if;
		end if;
	end process;
	
	reg(0) 				<= busy_trig;
	reg(31 downto 1) 	<= (others => '0');
	
	db_io <= reg after 1 ns when ((ren_busy_ctl_i and rd_i) = '1') else (others => 'Z');

		
	-- Busy control
	busy_control : process (clk)
	begin
		if rising_edge(clk) then
			if (rst = '1') then
				busy_trig <= '0';
			
			else
			
				if  trig_i = '1' then
					busy_trig <= '1';
					
				elsif clr_busy = '1' then
					busy_trig <= '0';
					
				end if;
			
			end if;
		end if;
	end process;
	
		
	busy_trig_o <= busy_trig;
	

 	latch : process (rst, trig_i, sr_out)
   begin
   	if (rst = '1') then 
   		l_out <= '0';
   	
   	else
	      if (trig_i = '1') then
	         l_out <= '1' after 1 ns;
	         
	      elsif (sr_out = '1') then
	         l_out <= '0' after 1 ns;
	            
	      end if;
	   end if;
   end process;


	shift_reg : process (clk)
	begin
		if rising_edge(clk) then
			if (rst = '1') then
				sr <= (others => '0');
		
			else
				sr <= (sr((LEN-1) downto 0) & l_out) after 1 ns;
			
			end if;
		end if;
	end process;

	sr_out <= sr(LEN);
	trig_o <= l_out;
	
	
	
			

	
end rtl;
